/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace CodeMetricsGui
{
    /// <summary>
    /// _CAO\NX
    /// </summary>
    class CDMtrGuiDialog
    {
        /// <summary>
        /// fBNgI_CAO\
        /// </summary>
        static public string CDMtrDialogOpenDir(string strRootPath)
        {
            string retPath;

            retPath = null;

            using (FolderBrowserDialog openDirDialog = new FolderBrowserDialog())
            {

                openDirDialog.Description = CodeMetricsGui.Properties.Resources.GuiDialog_01;
                openDirDialog.SelectedPath = strRootPath;
                openDirDialog.ShowNewFolderButton = false;

                DialogResult dr = openDirDialog.ShowDialog();

                if (dr == DialogResult.OK)
                {
                    try
                    {
                        retPath = openDirDialog.SelectedPath;
                    }
                    catch (Exception exp)
                    {
                        CDMtrDialogWarn(exp.Message);
                    }
                }
            }
            return retPath;
        }

        /// <summary>
        /// t@CI_CAO\
        /// </summary>
        static public string CDMtrDialogOpenFile(string strRootPath, string strDefaultFileName)
        {
            string retPath;

            retPath = null;

            using (OpenFileDialog openFileDialog = new OpenFileDialog())
            {

                openFileDialog.Title = CodeMetricsGui.Properties.Resources.GuiDialog_02;

                openFileDialog.InitialDirectory = strRootPath;

                openFileDialog.FileName = strDefaultFileName;

                openFileDialog.Filter = CodeMetricsGui.Properties.Resources.GuiDialog_03;

                openFileDialog.FilterIndex = 1;

                openFileDialog.RestoreDirectory = true;

                openFileDialog.Multiselect = false;

                openFileDialog.ShowHelp = false;

                openFileDialog.ShowReadOnly = false;

                openFileDialog.ReadOnlyChecked = false;

                if (openFileDialog.ShowDialog() == DialogResult.OK)
                {
                    try
                    {
                        retPath = openFileDialog.FileName;
                    }
                    catch (Exception exp)
                    {
                        CDMtrDialogWarn(exp.Message);
                    }
                }
            }
            return retPath;
        }

        /// <summary>
        /// t@Cۑ_CAO\
        /// </summary>
        static public string CDMtrDialogSaveFile(string strRootPath, string strDefaltFileName)
        {
            string retPath;

            retPath = null;

            using (SaveFileDialog saveFileDialog = new SaveFileDialog())
            {

                saveFileDialog.Title = CodeMetricsGui.Properties.Resources.GuiDialog_04;

                saveFileDialog.InitialDirectory = strRootPath;

                saveFileDialog.FileName = strDefaltFileName;

                saveFileDialog.Filter = CodeMetricsGui.Properties.Resources.GuiDialog_05;

                saveFileDialog.FilterIndex = 1;

                saveFileDialog.RestoreDirectory = true;

                saveFileDialog.ShowHelp = false;

                saveFileDialog.CreatePrompt = false;

                saveFileDialog.AddExtension = false;

                if (saveFileDialog.ShowDialog() == DialogResult.OK)
                {
                    try
                    {
                        retPath = saveFileDialog.FileName;
                    }
                    catch (Exception exp)
                    {
                        CDMtrDialogWarn(exp.Message);
                    }
                }
            }
            return retPath;
        }

        /// <summary>
        /// [jObZ[W\([jOACR)
        /// </summary>
        static public void CDMtrDialogWarn(string strMsg)
        {
            MessageBox.Show(strMsg, Properties.Resources.GuiDialog_06, MessageBoxButtons.OK, MessageBoxIcon.Warning);
            return;
        }

        /// <summary>
        /// G[bZ[W\(G[ACR)
        /// </summary>
        static public void CDMtrDialogErr(string strMsg)
        {
            MessageBox.Show(strMsg, Properties.Resources.GuiDialog_06, MessageBoxButtons.OK, MessageBoxIcon.Error);
            return;
        }
    }
}
