/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace CodeMetricsGui
{
    /// <summary>
    /// ݒNX GUIŐݒ肷ݒێB
    /// </summary>
    public class CDMtrGuiSetInfo
    {
        public int iExecMode;

        public int iRowInputFileNum;

        public string[] strRowInputFileArray;

        public string strDiffOldInputFile;

        public string strDiffNewInputFile;

        public string strPropFile;

        public string strOutFile;

        public string strOutFolderPath;

        public string strOutFileName;

        public string strExecOutFileName;

        public bool bAddSuffixCheck;

        public string strOptionFile;

        public bool bFormatCheck;

        public string strFormatTool;

        public int iRestyleCheck;

        public bool bDetailCheck;

        public bool bDebugCheck;

        public int iDefNum;

        public string[] strDefArray;

        public int iIncNum;

        public string[] strIncArray;

        public int iSysIncNum;

        public string[] strSysIncArray;

        public int iOptionClassNum;

        public string[] strOptionClassArray;

        public string strCompVer;

        public string strOutPutFormat;

        public string strNcmetergVer;

        private const string PROP_APP_GUI = "GUI";

        private const string PROP_ATTR_EXEMODE = "EXEMODE";

        private const string PROP_ATTR_ROW_INFILENUM = "ROW_INFILENUM";

        private const string PROP_ATTR_ROW_INFILE = "ROW_INFILE";

        private const string PROP_ATTR_DIFF_OLDINFILE = "DIFF_OLDINFILE";

        private const string PROP_ATTR_DIFF_NEWINFILE = "DIFF_NEWINFILE";

        private const string PROP_ATTR_PROPFILE = "PROPFILE";

        private const string PROP_ATTR_OUTFILE = "OUTFILE";

        private const string PROP_ATTR_OUTFOLDER = "OUTFOLDER";

        private const string PROP_ATTR_OUTFILENAME = "OUTFILENAME";

        private const string PROP_ATTR_ADDSUFFIXCHECK = "ADDSUFFIXCHECK";

        private const string PROP_ATTR_RESTYLE = "RESTYLE";

        private const string PROP_ATTR_DETAIL = "DETAIL";

        private const string PROP_ATTR_DEBUG = "DEBUG";

        private const string PROP_ATTR_DEFNUM = "DEFNUM";

        private const string PROP_ATTR_DEFINE = "DEFINE";

        private const string PROP_ATTR_INCNUM = "INCNUM";

        private const string PROP_ATTR_INCPATH = "INCPATH";

        private const string PROP_ATTR_SYSINCNUM = "SYSINCNUM";

        private const string PROP_ATTR_SYSINCPATH = "SYSINCPATH";

        private const string PROP_ATTR_OPTIONCLASSPATH = "OPTIONCLASSPATH";

        private const string PROP_ATTR_COMPVER = "COMPVER";

        private const string PROP_ATTR_FORMATCHECK = "FORMATCHECK";

        private const string PROP_ATTR_FORMATTOOL = "FORMATTOOL";

        private const string PROP_ATTR_OUTFORMAT = "OUTFORMAT";

        private const string PROP_APP_TOOLVERSION = "VERSION";

        public CDMtrGuiSetInfo()
        {
            CDMtrGuiSetInfoInit(this, "");
            return;
        }

        /// <summary>
        /// c[NpXftHgpXƂݒCX^X쐬
        /// </summary>
        public CDMtrGuiSetInfo(string strStartupPath)
        {
            CDMtrGuiSetInfoInit(this, strStartupPath);
            return;
        }

        /// <summary>
        /// w肳ꂽݒ񂩂ݒCX^X쐬
        /// </summary>
        public CDMtrGuiSetInfo(CDMtrGuiSetInfo setInfo)
        {
            CDMtrGuiSetInfoLoad(setInfo);
            return;
        }

        /// <summary>
        ///  ݒ̏
        /// </summary>
        public void CDMtrGuiSetInfoInit(CDMtrGuiSetInfo setInfo, string strStartupPath)
        {
            string strEnvPath;
            string strFormatToolPath = string.Empty ;

            if (strStartupPath != "")
            {
                strEnvPath = CDMtrGuiPath.CDMtrPathCombine(strStartupPath, CDMtrGui.ENVIRONMENT_PATH);
                strFormatToolPath = CDMtrGuiPath.CDMtrPathCombine(strStartupPath, CDMtrGui.FORMATTOOL_PATH);
                strFormatToolPath = CDMtrGuiPath.CDMtrPathCombine(strFormatToolPath, CDMtrGui.FILENAME_FORMATTOOL);
            }
            else
            {
                strEnvPath = "";
                strFormatToolPath = string.Empty;
            }

            setInfo.iExecMode = (int)CDMtrGui.EXEC_MODE.ROW;
            setInfo.iRowInputFileNum = 0;
            setInfo.strRowInputFileArray = null;
            setInfo.strDiffOldInputFile = "";
            setInfo.strDiffNewInputFile = "";
            setInfo.strPropFile = CDMtrGuiPath.CDMtrPathCombine(strEnvPath, CDMtrGui.FILENAME_PROP);
            setInfo.strOutFile = CDMtrGuiPath.CDMtrPathCombine(strStartupPath, CDMtrGui.FILENAME_OUTPUT);

            setInfo.strOutFolderPath = strStartupPath;
            setInfo.strOutFileName = CDMtrGui.FILENAME_OUTPUT_DEFAULT;
            setInfo.bAddSuffixCheck = false;

            setInfo.iRestyleCheck = (int)CDMtrGui.RESTYLE_MODE.NONE;
            setInfo.bDetailCheck = true;
            setInfo.bDebugCheck = false;
            setInfo.iDefNum = 0;
            setInfo.strDefArray = null;
            setInfo.iIncNum = 0;
            setInfo.strIncArray = null;
            setInfo.iSysIncNum = 0;
            setInfo.strSysIncArray = null;
            setInfo.iOptionClassNum = 0;
            setInfo.strOptionClassArray = null;
            setInfo.strCompVer = "";
            setInfo.strOutPutFormat = "csv";


            setInfo.bFormatCheck = false;
            if (strFormatToolPath.Length > 0 && File.Exists(strFormatToolPath))
            {
                setInfo.strFormatTool = strFormatToolPath;
            }
            else
            {
                setInfo.strFormatTool = string.Empty ;
            }
            
            return;
        }

        /// <summary>
        /// ݒ̍XV(w肳ꂽݒ{ݒNXɃRs[)
        /// </summary>
        public void CDMtrGuiSetInfoLoad(CDMtrGuiSetInfo setInfo)
        {
            this.iExecMode = setInfo.iExecMode;
            this.iRowInputFileNum = setInfo.iRowInputFileNum;
            this.strRowInputFileArray = setInfo.strRowInputFileArray;
            this.strDiffOldInputFile = setInfo.strDiffOldInputFile;
            this.strDiffNewInputFile = setInfo.strDiffNewInputFile;

            this.strPropFile = setInfo.strPropFile;
            this.strOutFile = setInfo.strOutFile;

            this.strOutFolderPath = setInfo.strOutFolderPath;
            this.strOutFileName = setInfo.strOutFileName;
            this.bAddSuffixCheck = setInfo.bAddSuffixCheck;
            this.strExecOutFileName = setInfo.strExecOutFileName;

            this.iRestyleCheck = setInfo.iRestyleCheck;
            this.bDetailCheck = setInfo.bDetailCheck;
            this.bDebugCheck = setInfo.bDebugCheck;
            this.iDefNum = setInfo.iDefNum;
            this.strDefArray = setInfo.strDefArray;
            this.iIncNum = setInfo.iIncNum;
            this.strIncArray = setInfo.strIncArray;
            this.iSysIncNum = setInfo.iSysIncNum;
            this.strSysIncArray = setInfo.strSysIncArray;
            this.iOptionClassNum = setInfo.iOptionClassNum;
            this.strOptionClassArray = setInfo.strOptionClassArray;
            this.strCompVer = setInfo.strCompVer;
            this.strOutPutFormat = setInfo.strOutPutFormat;

            this.bFormatCheck = setInfo.bFormatCheck;
            this.strFormatTool = setInfo.strFormatTool;

            return;
        }

        /// <summary>
        /// ݒt@CݒǍ
        /// </summary>
        public void CDMtrGuiSetInfoRead(string strPropPath)
        {
            CDMtrGuiProp prop;

            if ((prop = new CDMtrGuiProp(strPropPath, PROP_APP_GUI)) != null)
            {
                try
                {
                    this.iExecMode = int.Parse(prop.CDMtrPropReadValue(PROP_ATTR_EXEMODE, "0"));
                    switch (this.iExecMode)
                    {
                        case (int)CDMtrGui.EXEC_MODE.ROW:
                        case (int)CDMtrGui.EXEC_MODE.DIFF:
                        case (int)CDMtrGui.EXEC_MODE.STRUCT:
                        case (int)CDMtrGui.EXEC_MODE.CK:
                            break;
                        default:
                            this.iExecMode = (int)CDMtrGui.EXEC_MODE.ROW;
                            break;
                    }
                }
                catch (Exception ex)
                {
                    this.iExecMode = (int)CDMtrGui.EXEC_MODE.ROW;
                    CDMtrGuiDebug.write(ex.ToString());
                }

                try
                {
                    this.iRowInputFileNum = int.Parse(prop.CDMtrPropReadValue(PROP_ATTR_ROW_INFILENUM, "0"));
                    if (this.iRowInputFileNum < 0)
                    {
                        this.iRowInputFileNum = 0;
                    }
                }
                catch (Exception ex)
                {
                    this.iRowInputFileNum = 0;
                    CDMtrGuiDebug.write(ex.ToString());
                }
                this.strRowInputFileArray = new string[this.iRowInputFileNum];
                if (this.strRowInputFileArray != null)
                {
                    for (int i = 0; i < this.iRowInputFileNum; i++)
                    {
                        this.strRowInputFileArray[i] = prop.CDMtrPropReadValue(PROP_ATTR_ROW_INFILE + i.ToString(), "");
                    }
                }
                else
                {
                    this.iRowInputFileNum = 0;
                }

                this.strDiffOldInputFile = prop.CDMtrPropReadValue(PROP_ATTR_DIFF_OLDINFILE, "");
                this.strDiffNewInputFile = prop.CDMtrPropReadValue(PROP_ATTR_DIFF_NEWINFILE, "");


                this.strPropFile = prop.CDMtrPropReadValue(PROP_ATTR_PROPFILE, "");

                this.strNcmetergVer = prop.CDMtrPropReadValue(PROP_APP_TOOLVERSION, "");

                if (this.strNcmetergVer == "")
                {

                    this.strOutFile = prop.CDMtrPropReadValue(PROP_ATTR_OUTFILE, "");


                    if (this.strOutFile != "")
                    {
                        try
                        {
                            this.strOutFolderPath = CDMtrGuiPath.CDMtrPathGetDirName(this.strOutFile);
                        }
                        catch (Exception ex)
                        {
                            this.strOutFolderPath = Application.StartupPath;
                            CDMtrGuiDebug.write(ex.ToString());
                        }

                        try
                        {
                            this.strOutFileName = Path.GetFileNameWithoutExtension(this.strOutFile);
                        }
                        catch (Exception ex)
                        {
                            this.strOutFileName = CDMtrGui.FILENAME_OUTPUT_DEFAULT;
                            CDMtrGuiDebug.write(ex.ToString());
                        }
                    }
                }
                else
                {
                    this.strOutFolderPath = prop.CDMtrPropReadValue(PROP_ATTR_OUTFOLDER, "");
                    this.strOutFileName = prop.CDMtrPropReadValue(PROP_ATTR_OUTFILENAME, "");

                }

                try
                {
                        this.bAddSuffixCheck = bool.Parse(prop.CDMtrPropReadValue(PROP_ATTR_ADDSUFFIXCHECK, "false"));
                }
                catch (Exception ex)
                {
                    this.bAddSuffixCheck = false;
                    CDMtrGuiDebug.write(ex.ToString());
                }

                try
                {
                    this.iRestyleCheck = int.Parse(prop.CDMtrPropReadValue(PROP_ATTR_RESTYLE, CDMtrGui.RESTYLE_MODE.NONE.ToString()));
                    switch (this.iRestyleCheck)
                    {
                        case (int)CDMtrGui.RESTYLE_MODE.BOTH:
                        case (int)CDMtrGui.RESTYLE_MODE.STD:
                        case (int)CDMtrGui.RESTYLE_MODE.NONE:
                            break;
                        default:
                            this.iRestyleCheck = (int)CDMtrGui.RESTYLE_MODE.NONE;
                            break;
                    }
                }
                catch (Exception ex)
                {
                    this.iRestyleCheck = (int)CDMtrGui.RESTYLE_MODE.NONE;
                    CDMtrGuiDebug.write(ex.ToString());
                }

                try
                {
                    this.bDetailCheck = bool.Parse(prop.CDMtrPropReadValue(PROP_ATTR_DETAIL, "true"));
                }
                catch (Exception ex)
                {
                    this.bDetailCheck = true;
                    CDMtrGuiDebug.write(ex.ToString());
                }

                try
                {
                    this.bDebugCheck = bool.Parse(prop.CDMtrPropReadValue(PROP_ATTR_DEBUG, "false"));
                }
                catch (Exception ex)
                {
                    this.bDebugCheck = false;
                    CDMtrGuiDebug.write(ex.ToString());
                }

                try
                {
                    this.iDefNum = int.Parse(prop.CDMtrPropReadValue(PROP_ATTR_DEFNUM, "0"));
                    if (this.iDefNum < 0)
                    {
                        this.iDefNum = 0;
                    }
                }
                catch (Exception ex)
                {
                    this.iDefNum = 0;
                    CDMtrGuiDebug.write(ex.ToString());
                }
                this.strDefArray = new string[this.iDefNum];
                if (this.strDefArray != null)
                {
                    for (int i = 0; i < this.iDefNum; i++)
                    {
                        this.strDefArray[i] = prop.CDMtrPropReadValue(PROP_ATTR_DEFINE + i.ToString(), "");
                    }
                }
                else
                {
                    this.iDefNum = 0;
                }

                try
                {
                    this.iIncNum = int.Parse(prop.CDMtrPropReadValue(PROP_ATTR_INCNUM, "0"));
                    if (this.iIncNum < 0)
                    {
                        this.iIncNum = 0;
                    }
                }
                catch (Exception ex)
                {
                    this.iIncNum = 0;
                    CDMtrGuiDebug.write(ex.ToString());
                }
                this.strIncArray = new string[this.iIncNum];
                if (this.strIncArray != null)
                {
                    for (int i = 0; i < this.iIncNum; i++)
                    {
                        this.strIncArray[i] = prop.CDMtrPropReadValue(PROP_ATTR_INCPATH + i.ToString(), "");
                    }
                }
                else
                {
                    this.iIncNum = 0;
                }

                try
                {
                    this.iSysIncNum = int.Parse(prop.CDMtrPropReadValue(PROP_ATTR_SYSINCNUM, "0"));
                    if (this.iSysIncNum < 0)
                    {
                        this.iSysIncNum = 0;
                    }
                }
                catch (Exception ex)
                {
                    this.iSysIncNum = 0;
                    CDMtrGuiDebug.write(ex.ToString());
                }
                this.strSysIncArray = new string[this.iSysIncNum];
                if (this.strIncArray != null)
                {
                    for (int i = 0; i < this.iSysIncNum; i++)
                    {
                        this.strSysIncArray[i] = prop.CDMtrPropReadValue(PROP_ATTR_SYSINCPATH + i.ToString(), "");
                    }
                }
                else
                {
                    this.iSysIncNum = 0;
                }

                try
                {
                    this.iOptionClassNum = int.Parse(prop.CDMtrPropReadValue(PROP_ATTR_OPTIONCLASSPATH, "0"));
                    if (this.iOptionClassNum < 0)
                    {
                        this.iOptionClassNum = 0;
                    }
                }
                catch (Exception ex)
                {
                    this.iOptionClassNum = 0;
                    CDMtrGuiDebug.write(ex.ToString());
                }
                this.strOptionClassArray = new string[this.iOptionClassNum];
                if (this.strOptionClassArray != null)
                {
                    for (int i = 0; i < this.iOptionClassNum; i++)
                    {
                        this.strOptionClassArray[i] = prop.CDMtrPropReadValue(PROP_ATTR_OPTIONCLASSPATH + i.ToString(), "");
                    }
                }
                else
                {
                    this.iOptionClassNum = 0;
                }

                this.strCompVer = prop.CDMtrPropReadValue(PROP_ATTR_COMPVER, "");

                try
                {
                    this.bFormatCheck = bool.Parse(prop.CDMtrPropReadValue(PROP_ATTR_FORMATCHECK, "false"));
                }
                catch (Exception ex)
                {
                    this.bFormatCheck = false;
                    CDMtrGuiDebug.write(ex.ToString());
                }
                this.strFormatTool = prop.CDMtrPropReadValue(PROP_ATTR_FORMATTOOL, "");

                try
                {
                    this.strOutPutFormat = prop.CDMtrPropReadValue(PROP_ATTR_OUTFORMAT, "csv");
                }
                catch (Exception ex)
                {
                    this.strOutPutFormat = "csv";
                    CDMtrGuiDebug.write(ex.ToString());
                }
            }

            return;
        }

        /// <summary>
        /// ݒݒt@Cɕۑ
        /// </summary>
        public void CDMtrGuiSetInfoSave(string strPropPath)
        {
            CDMtrGuiProp prop;


            if ((prop = new CDMtrGuiProp(strPropPath, PROP_APP_GUI)) != null)
            {
                try
                {
                    prop.CDMtrPropDeleteSection(PROP_APP_GUI);


                    prop.CDMtrPropValue(PROP_APP_TOOLVERSION, Application.ProductVersion);

                    prop.CDMtrPropValue(PROP_ATTR_EXEMODE, this.iExecMode.ToString());

                    prop.CDMtrPropValue(PROP_ATTR_ROW_INFILENUM, this.iRowInputFileNum.ToString());
                    for (int i = 0; i < this.iRowInputFileNum; i++)
                    {
                        prop.CDMtrPropValue(PROP_ATTR_ROW_INFILE + i.ToString(), this.strRowInputFileArray[i]);
                    }

                    prop.CDMtrPropValue(PROP_ATTR_DIFF_OLDINFILE, this.strDiffOldInputFile);
                    prop.CDMtrPropValue(PROP_ATTR_DIFF_NEWINFILE, this.strDiffNewInputFile);

                    prop.CDMtrPropValue(PROP_ATTR_PROPFILE, this.strPropFile);


                    prop.CDMtrPropValue(PROP_ATTR_OUTFOLDER, this.strOutFolderPath);

                    prop.CDMtrPropValue(PROP_ATTR_OUTFILENAME, this.strOutFileName);

                    prop.CDMtrPropValue(PROP_ATTR_ADDSUFFIXCHECK, this.bAddSuffixCheck.ToString());

                    prop.CDMtrPropValue(PROP_ATTR_RESTYLE, this.iRestyleCheck.ToString());

                    prop.CDMtrPropValue(PROP_ATTR_DETAIL, this.bDetailCheck.ToString());

                    prop.CDMtrPropValue(PROP_ATTR_DEBUG, this.bDebugCheck.ToString());

                    prop.CDMtrPropValue(PROP_ATTR_DEFNUM, this.iDefNum.ToString());
                    for (int i = 0; i < this.iDefNum; i++)
                    {
                        prop.CDMtrPropValue(PROP_ATTR_DEFINE + i.ToString(), this.strDefArray[i]);
                    }

                    prop.CDMtrPropValue(PROP_ATTR_INCNUM, this.iIncNum.ToString());
                    for (int i = 0; i < this.iIncNum; i++)
                    {
                        prop.CDMtrPropValue(PROP_ATTR_INCPATH + i.ToString(), this.strIncArray[i]);
                    }

                    prop.CDMtrPropValue(PROP_ATTR_SYSINCNUM, this.iSysIncNum.ToString());
                    for (int i = 0; i < this.iSysIncNum; i++)
                    {
                        prop.CDMtrPropValue(PROP_ATTR_SYSINCPATH + i.ToString(), this.strSysIncArray[i]);
                    }

                    prop.CDMtrPropValue(PROP_ATTR_OPTIONCLASSPATH, this.iOptionClassNum.ToString());
                    for (int i = 0; i < this.iOptionClassNum; i++)
                    {
                        prop.CDMtrPropValue(PROP_ATTR_OPTIONCLASSPATH + i.ToString(), this.strOptionClassArray[i]);
                    }

                    prop.CDMtrPropValue(PROP_ATTR_COMPVER, this.strCompVer);

                    prop.CDMtrPropValue(PROP_ATTR_FORMATCHECK, this.bFormatCheck.ToString());
                    prop.CDMtrPropValue(PROP_ATTR_FORMATTOOL, this.strFormatTool);

                    prop.CDMtrPropValue(PROP_ATTR_OUTFORMAT, this.strOutPutFormat.ToString());


                
                }
                catch (Exception ex)
                {
                    CDMtrGuiDebug.write(ex.ToString());
                }
            }

            return;
        }
    }
}
