/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef CDMTRCNTFUNC_H_
#define CDMTRCNTFUNC_H_

#define TEMP_FILE_SPLIT_BASE _T("split_func_base.tmp")
#define TEMP_FILE_SPLIT_DIST _T("split_func_dist.tmp")
#define TEMP_FUNC_DATA_BASE _T("temp_funclist_base.tmp")
#define TEMP_FUNC_DATA_DIST _T("temp_funclist_dist.tmp")

enum {
    FUNC_NONE,
    FUNC_MATCH,
    FUNC_MATCH_EQU,
    FUNC_MATCH_MOD,
    FUNC_ADD,
    FUNC_ADD_VS_NONE,
    FUNC_ADD_VS_INVALID,
    FUNC_DEL,
    FUNC_DEL_VS_NONE,
    FUNC_DEL_VS_INVALID,
    FUNC_INVALID,
    FUNC_INVALID_ADD,
    FUNC_INVALID_DEL,
};

enum {
    FILE_EQU,
    FILE_MOD
};

typedef struct tag_FUNCINFOFILE_OPT {
    _TCHAR *pcFilePath;
    _TCHAR *pcLogoutFilePath;
    _TCHAR *pcErrPath;
    _TCHAR *pcOutputPath;
    _TCHAR *pcStructExePath;
    _TCHAR *pcOptDebug2;
    _TCHAR *pcOptOutFormat;
    _TCHAR *pcOptLangName;
    _TCHAR *pcOptLangType;
    _TCHAR *pcOptFuncOpt;
    _TCHAR *pcOptMetricSkip;
    _TCHAR *pcOptQrtFlg;
} _FUNCINFOFILE_OPT;



typedef struct tag_FUNC_MATCHING_LIST {
    int             iFlg;
    _LINECOUNT_LIST *ptBaseList;
    _LINECOUNT_LIST *ptDistList;
    struct tag_FUNC_MATCHING_LIST *next;
} _FUNC_MATCHING_LIST;

typedef struct tag_FILE_STATUS {
    long    lBaseFileIndex;
    long    lDistFileIndex;
    FILE    *fpBase;
    FILE    *fpDist;
} _FILE_STATUS;


extern int CDMtrCntFuncCreateFuncList(_TCHAR *pcFilePath, _LINECOUNT_LIST *ptLineList);
extern int CDMtrCntFuncDoFuncMatching(_TCHAR *cpBaseFilePath, _TCHAR *cpDistFilePath, _LINECOUNT_LIST *ptBaseList, _LINECOUNT_LIST *ptDistList, _FUNC_MATCHING_LIST *ptFuncMatchingList, int *piFileDiffKind);
extern int CDMtrCntFuncSetDeleteDiffLineCount(_LINECOUNT_LIST *ptLinlist);
extern int CDMtrCntFuncSetAddDiffLineCount(_LINECOUNT_LIST *ptLinlist);
extern void CDMtrCntFuncFreeChain(_LINECOUNT_LIST *ptLineList);
extern void CDMtrCntFuncFreeChainMatchingList(_FUNC_MATCHING_LIST *ptList);
extern int CDMtrCntFuncCreateFuncInfoFile(_FUNCINFOFILE_OPT *ptFuncOpt);

#endif
