/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef CDMTRCNTMAIN_H_
#define CDMTRCNTMAIN_H_

/*!@def*/
#define FOLDER_SEPALATE_CHAR    _T('\\')
#define FOLDER_SEPALATE         _T("\\")
#define LONGPATH_UNC_PREFIX     _T("\\\\?\\UNC\\")

#define FUNC_OPTION_NONE _T("none")
#define FUNC_OPTION_PARAM _T("param")
#define OUT_FORMAT_FUNC _T("func")

#define MACROANALIZER           _T("maext.exe")
#define SEDTOOL                 _T("sedext.exe")
#define DIFF                    _T("diff.exe")
#define STRUCT                  _T("saext.exe")
#define STRUCT_SMP              _T("ncmsmpparser.exe")
#define NKF                     _T("nkf.exe")
#define BEAUTIFIER              _T("uncrustify.exe")
#define NKFDLL                  _T("nkf32.dll")
#define STRUCT_JAVA             _T("ncmjparser.jar")
#define STRUCT_CS               _T("ncmcsparser.exe")
#define STRUCT_VB               _T("ncmvbparser.exe")
#define STRUCT_JS               _T("ncmjsparser.jar")
#define CK_JAVA                 _T("ncmckjparser.jar")
#define JAVA_VERSION_CMD        _T("java_version_cmd")

// Error ID (for Log Message)
#define ERR_LOG_ID_EC_00000081  _T("(EC_00000081)")
#define ERR_LOG_ID_EC_00000082  _T("(EC_00000082)")
#define ERR_LOG_ID_EC_00000089  _T("(EC_00000089)")
#define ERR_LOG_ID_EC_00000090  _T("(EC_00000090)")
#define ERR_LOG_ID_EC_00000093  _T("(EC_00000093)")
#define ERR_LOG_ID_EC_00000094  _T("(EC_00000094)")
#define ERR_LOG_ID_EC_00000095  _T("(EC_00000095)")
#define ERR_LOG_ID_EC_00000096  _T("(EC_00000096)")
#define ERR_LOG_ID_EC_00000100  _T("(EC_00000100)")
#define ERR_LOG_ID_EC_00000101  _T("(EC_00000101)")
#define ERR_LOG_ID_EC_00000102  _T("(EC_00000102)")
#define ERR_LOG_ID_EC_00000103  _T("(EC_00000103)")
#define ERR_LOG_ID_EC_00000187  _T("(EC_00000187)")
#define ERR_LOG_ID_EC_00000190  _T("(EC_00000190)")
#define ERR_LOG_ID_EC_00000194  _T("(EC_00000194)")
#ifdef OSS
#define ERR_LOG_ID_EC_00000816  _T("(EC_00000816)")
#define ERR_LOG_ID_EC_00000817  _T("(EC_00000817)")
#define ERR_LOG_ID_EC_00000818  _T("(EC_00000818)")
#define ERR_LOG_ID_EC_00000819  _T("(EC_00000819)")
#define ERR_LOG_ID_EC_00000821  _T("(EC_00000821)")
#endif //OSS

#define CREATE_TMPFOLDER_RETRY_MAX  10

#define CSV_FORMAT              1
#define XML_FORMAT              2

#define HELP_HIDE               0
#define HELP_SHOW               1

#define RESTYLE_NONE            0
#define RESTYLE_STD             1
#define RESTYLE_BOTH            2

#define NUM_NESTS_COUNT_NONE       0
#define NUM_NESTS_COUNT_INNERBLOCK 1
#define NUM_NESTS_COUNT_ALLBLOCK   2

/* DIFF_MODE_DETAIL_OUTݒp */
#define DIFF_MODE_DETAIL_OUT_NONE   -1

#ifdef OSS
#define TOOL_VER                _T("1.12 OSS")
#else
#define TOOL_VER                _T("1.12")
#endif //OSS

#define DIFF_START_DEL          _T('<')
#define DIFF_START_ADD          _T('>')
#define DIFF_LCDETAIL_CODE      _T('C')
#define DIFF_LCDETAIL_PREP      _T('P')
#define DIFF_LCDETAIL_SKIP      _T('S')
#define DIFF_LCDETAIL_DOC       _T('D')
#define DIFF_LCDETAIL_REM       _T('R')
#define DIFF_LCDETAIL_BLANK     _T('B')

#define DIFF_SEPALATE           _T(",")
#define DIFF_STATUS_EXIST       _T("EQU_FILE")
#define DIFF_STATUS_CHANGED     _T("MOD_FILE")
#define DIFF_STATUS_DEL         _T("DEL_FILE")
#define DIFF_STATUS_NEW         _T("ADD_FILE")
#define DIFF_STATUS_SIZE        10

#define MEASUREMENT_ERROR_OUTPUT    _T('x')

#define DIFF_COUNT_STD             0
#define DIFF_COUNT_EXT             1

#define CK_TYPE_TARGET			0
#define CK_TYPE_OPTION			1

#define DOUBLEQUOTATION_CHAR    _T('\"')
#define DOUBLEQUOTATION         _T("\"")
#define COMMA                   _T(",")

#define DELETE_RETRY_MAX 5

#define PROP_LANG_ATTR_SIZE      6

#define OUT_FILE_NAME           _T("ncmeter.csv")
#define PROPERTY_FILE_NAME      _T("ncmeter.properties")
#define TMP_FOLDER_NAME         _T("ncmeter")
#define OUT_XML_FILE_NAME       _T("ncmeter.xml")

#define NKFDLL_SETOPTION         "SetNkfOption"
#define NKFDLL_FILECONVERT2      "NkfFileConvert2SafeW"

#define DEFAULT_EXEC_JAVA_APP        _T("java -Xss1024k -Dfile.encoding=utf-8 -jar ")
#define EXEC_JAVA_APP_OPTION         _T(" -Xss1024k -Dfile.encoding=utf-8 -jar ")
#define EXEC_JAVA_VERSION_CMD        _T("java -version ")
#define EXEC_JAVA_VERSION_CMD_OPTION _T(" -version ")

#define STRUCT_JAVA_OPT_TARGETFILE  _T("\" --target_file_path \"")
#define STRUCT_JAVA_OPT_HEXFILE     _T("\" --hex_file_path \"")

#define EXEC_CK_JAVA_APP            _T("java -Dfile.encoding=utf-8")
#define EXEC_CK_JAVA_APP_OPTION_XSS _T(" -Xss1024k")
#define EXEC_CK_JAVA_APP_OPTION_XMX _T(" -Xmx")
#define EXEC_CK_JAVA_APP_OPTION_JAR _T(" -jar ")
#define JAVA_APP_OPTION_XMX_DEFAULT _T("512m")

#define BEAUTIFIER_CFG_OPTION   _T(" -c ")
#define BEAUTIFIER_CFG          _T("uncrustify.cfg")
#define HELP                    _T("ncmeter_hlp")
#define WIN_EXETOOL_EXT         _T(".exe")
#define ENVIRONMENT_PATH        _T("\\..\\etc\\ncmeter\\")
#define TOOL_PATH               _T("\\..\\etc\\ncmeter\\bin\\")
#define NKF_DLL_PATH            _T("\\..\\etc\\ncmeter\\bin\\")

#define CNT_STR_TRUE _T("true")
#define CNT_STR_FALSE _T("false")
#define CNT_STR_STANDARD _T("standard")
#define CNT_STR_SMP _T("simple")
#define CNT_STR_DIFF_FILE _T("file")
#define CNT_STR_DIFF_FUNC _T("func")
#define CNT_STR_OLD _T("old")
#define CNT_STR_NEW _T("new")
#define CNT_STR_MODE_A _T("MODE_A")
#define CNT_STR_MODE_B _T("MODE_B")
#define CNT_STR_STD _T("STD")
#define CNT_STR_EXT _T("EXT")

#define LOG_ERREXE_START _T("Start outputting external tool log.\n")  //* MSG_LOG_ID_C_00000431
#define LOG_ERREXE_END _T("Finished outputting external tool log.\n") //* MSG_LOG_ID_C_00000432
 
#define OPTION_SEP_SPACE _T(" ")
#define OPTION_I_INCLUDE _T(" -I")
#define EDG_OPT_C _T(" -m ")
#define EDG_OPT_CPP _T(" -p ")
 
#define COMPVER_WIN_DEFALT _T("VC70")
 
#define SYSINC_WIN_DEFAULT _T("")
 
#define PLATFORM_TYPE_UNKNOW (0)
#define PLATFORM_TYPE_WIN (1)
 
#define OUTPUT_EXECUTE_MODE         _T("Execute Mode,")
#define OUTPUT_TOOL_NAME            _T("Tool Name,")
#define OUTPUT_VERSION              _T("Version,")
#define OUTPUT_START_DATE           _T("Start Date,")
#define OUTPUT_END_DATE             _T("End   Date,")
#define OUTPUT_COMMAND_PARAM        _T("Command Parameter,")
#define OUTPUT_PROP_NAME            _T("Property File Name,")
#define OUTPUT_STYLE                _T("Output STYLE,")
#define OUTPUT_CNT_DOC              _T("Output DOC,")
#define OUTPUT_CNT_UNDEF            _T("Output DEF,")
#define OUTPUT_CNT_SKIP             _T("Output SKIP,")
#define OUTPUT_DIFF_BLANK           _T("Output DIFF_BLANK,")
#define OUTPUT_DIFF_COUNT_MODE      _T("Output DIFF_COUNT_MODE,")
 
#define OUTPUT_XML_INIT_DECLARATION _T("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n")
 
#define OUTPUT_XML_TAGS_STRT_CRL_FORM _T("<%s>\n")
#define OUTPUT_XML_TAGS_STRT_FORM _T("<%s>")
#define OUTPUT_XML_TAGS_END_FORM _T("</%s>\n")
#define OUTPUT_XML_EMPTY_FORM _T("<%s></%s>\n")
#define OUTPUT_XML_NOT_TARGETS_FORM _T("<%s>-</%s>\n")
#define OUTPUT_XML_LINES_TARGET_FORM _T("<%s>%lu</%s>\n")
#define OUTPUT_XML_STR_TARGET_FORM _T("<%s>%s</%s>\n")
#define OUTPUT_XML_STR_TARGET_FORM_UTF8 _T("<%s>%s</%s>\n")
 
#define METRICS_NG_STRING _T("NG")
#define METRICS_OK_STRING _T("OK")
 
#define RET_FAIL_XREF (101)
 
#define LOCALE_LANGUAGE_CULTURE_ENGLISH _T("en")
 
#define OUTPUT_FILE_TOTAL           _T("total number of Files,")
#define OUTPUT_FILE_SUCCESS         _T("success number of Files,")
#define OUTPUT_FILE_ERROR           _T("error number of Files,")
 
#define OUTPUT_STYLE_NONE _T("RESTYLE NONE")
#define OUTPUT_STYLE_STD _T("RESTYLE STD")
#define OUTPUT_STYLE_BOTH _T("RESTYLE BOTH")
 
#define OUTPUT_ROW_HEADER_PLOC _T("\
DIR,FILE,FUNC,LANG,STMT,TLOC,ELOC,CLOC,BLOC,SKIP,ICLOC,CODE,PREP,DOC,REM,STATE,\
EQU_ELOC,ADD_ELOC,DEL_ELOC,EQU_CLOC,ADD_CLOC,DEL_CLOC,OLDDIR,OLDFILE\n")
 
#define OUTPUT_ROW_HEADER_PLOC_M _T("\
DIR,FILE,FUNC,LANG,STMT,TLOC,ELOC,CLOC,BLOC,MSKIP,ICLOC,CODE,PREP,DOC,REM,STATE,\
EQU_ELOC,ADD_ELOC,DEL_ELOC,EQU_CLOC,ADD_CLOC,DEL_CLOC,OLDDIR,OLDFILE\n")
 
#define OUTPUT_ROW_HEADER_RLOC _T("\
DIR,FILE,FUNC,LANG,STMT,RTLOC,RELOC,RCLOC,RBLOC,RSKIP,RICLOC,RCODE,RPREP,RDOC,RREM,STATE,\
EQU_RELOC,ADD_RELOC,DEL_RELOC,EQU_RCLOC,ADD_RCLOC,DEL_RCLOC,OLDDIR,OLDFILE\n")
 
#define OUTPUT_ROW_HEADER_RLOC_M _T("\
DIR,FILE,FUNC,LANG,STMT,RTLOC,RELOC,RCLOC,RBLOC,RMSKIP,RICLOC,RCODE,RPREP,RDOC,RREM,STATE,\
EQU_RELOC,ADD_RELOC,DEL_RELOC,EQU_RCLOC,ADD_RCLOC,DEL_RCLOC,OLDDIR,OLDFILE\n")
 
#define OUTPUT_ROW_B_HEADER_PLOC _T("\
DIR,FILE,FUNC,LANG,STMT,TLOC,ELOC,CLOC,BLOC,SKIP,ICLOC,CODE,PREP,DOC,REM,STATE,\
EQU_TOTAL,ADD_TOTAL,DEL_TOTAL,MODADD_TOTAL,MODDEL_TOTAL,\
EQU_ELOC,ADD_ELOC,DEL_ELOC,MODADD_ELOC,MODDEL_ELOC,\
EQU_CLOC,ADD_CLOC,DEL_CLOC,MODADD_CLOC,MODDEL_CLOC,\
EQU_BLOC,ADD_BLOC,DEL_BLOC,MODADD_BLOC,MODDEL_BLOC,\
EQU_SKIP,ADD_SKIP,DEL_SKIP,MODADD_SKIP,MODDEL_SKIP,\
OLDDIR,OLDFILE\n")
 
#define OUTPUT_ROW_B_HEADER_PLOC_M _T("\
DIR,FILE,FUNC,LANG,STMT,TLOC,ELOC,CLOC,BLOC,MSKIP,ICLOC,CODE,PREP,DOC,REM,STATE,\
EQU_TOTAL,ADD_TOTAL,DEL_TOTAL,MODADD_TOTAL,MODDEL_TOTAL,\
EQU_ELOC,ADD_ELOC,DEL_ELOC,MODADD_ELOC,MODDEL_ELOC,\
EQU_CLOC,ADD_CLOC,DEL_CLOC,MODADD_CLOC,MODDEL_CLOC,\
EQU_BLOC,ADD_BLOC,DEL_BLOC,MODADD_BLOC,MODDEL_BLOC,\
EQU_MSKIP,ADD_MSKIP,DEL_MSKIP,MODADD_MSKIP,MODDEL_MSKIP,\
OLDDIR,OLDFILE\n")
 
#define OUTPUT_ROW_B_HEADER_RLOC _T("\
DIR,FILE,FUNC,LANG,STMT,RTLOC,RELOC,RCLOC,RBLOC,RSKIP,RICLOC,RCODE,RPREP,RDOC,RREM,STATE,\
EQU_TOTAL,ADD_TOTAL,DEL_TOTAL,MODADD_TOTAL,MODDEL_TOTAL,\
EQU_RELOC,ADD_RELOC,DEL_RELOC,MODADD_RELOC,MODDEL_RELOC,\
EQU_RCLOC,ADD_RCLOC,DEL_RCLOC,MODADD_RCLOC,MODDEL_RCLOC,\
EQU_RBLOC,ADD_RBLOC,DEL_RBLOC,MODADD_RBLOC,MODDEL_RBLOC,\
EQU_RSKIP,ADD_RSKIP,DEL_RSKIP,MODADD_RSKIP,MODDEL_RSKIP,\
OLDDIR,OLDFILE\n")
 
#define OUTPUT_ROW_B_HEADER_RLOC_M _T("\
DIR,FILE,FUNC,LANG,STMT,RTLOC,RELOC,RCLOC,RBLOC,RMSKIP,RICLOC,RCODE,RPREP,RDOC,RREM,STATE,\
EQU_TOTAL,ADD_TOTAL,DEL_TOTAL,MODADD_TOTAL,MODDEL_TOTAL,\
EQU_RELOC,ADD_RELOC,DEL_RELOC,MODADD_RELOC,MODDEL_RELOC,\
EQU_RCLOC,ADD_RCLOC,DEL_RCLOC,MODADD_RCLOC,MODDEL_RCLOC,\
EQU_RBLOC,ADD_RBLOC,DEL_RBLOC,MODADD_RBLOC,MODDEL_RBLOC,\
EQU_RMSKIP,ADD_RMSKIP,DEL_RMSKIP,MODADD_RMSKIP,MODDEL_RMSKIP,\
OLDDIR,OLDFILE\n")
 
#define OUTPUT_STRUCT_HEADER_PLOC _T("\
DIR,FILE,FUNC,LANG,FLOC,ELOC,CLOC,BLOC,CYCLO,CYCLOWC,BRANCHS,CNDOPS,\
NESTS,EVALR,EVALS,AVALS,PARMS,FANIN,FANOUT,FANIN_FUNC,FANIN_PARAM,FANIN_GVAL,\
FANOUT_FUNC,FANOUT_PARAM,FANOUT_GVAL\n")
 
#define OUTPUT_STRUCT_HEADER_RLOC _T("\
DIR,FILE,FUNC,LANG,RFLOC,RELOC,RCLOC,RBLOC,CYCLO,CYCLOWC,BRANCHS,CNDOPS,\
NESTS,EVALR,EVALS,AVALS,PARMS,FANIN,FANOUT,FANIN_FUNC,FANIN_PARAM,FANIN_GVAL,\
FANOUT_FUNC,FANOUT_PARAM,FANOUT_GVAL\n")
 
#define OUTPUT_CK_HEADER _T("DIR,FILE,PACKAGE,CLASS,LANG,WMC,RFC,LCOM,DIT,NOC,CBO\n")
 
#define OUT_FORMAT_COUNTRESULT _T("%lu,%lu,%lu,%lu,%lu,%lu,%lu,%lu,%lu,%lu")
#define OUTPUT_FILE_INFO _T("\"%s\",\"%s\",%s,%s,")
#define OUTPUT_DIFF_BASEONLY_ROW _T("x,,,,,,,,,,")
#define OUTPUT_BIN_FORMAT_ROW _T("%lu,-,-,-,-,-,-,-,-,-")
#define OUTPUT_DIFF_FUNCDEL_INVALID _T("-,-,-,-,-,-,-,-,-,-,-")
 
#define OUTPUT_BIN_FORMAT_DIFF_A _T(",%s,-,-,-,-,-,-,\"%s\",\"%s\"\n")
#define OUTPUT_DIFF_A_FORMAT _T(",%s,%lu,%lu,%lu,%lu,%lu,%lu,\"%s\",\"%s\"\n")
#define OUTPUT_DIFF_A_NONE _T(",-,-,-,-,-,-,-,-,-\n")
 
#define OUTPUT_TXT_FORMAT_DIFF_B _T(",%s,%lu,%lu,%lu,%lu,%lu,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,\"%s\",\"%s\"\n") \
 
#define OUTPUT_BIN_FORMAT_DIFF_B _T(",%s,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,\"%s\",\"%s\"\n") \
 
#define OUTPUT_DIFF_B_FORMAT_STATE _T(",%s,")
#define OUTPUT_DIFF_B_FORMAT_LINES _T("%lu,%lu,%lu,%lu,%lu,")
#define OUTPUT_DIFF_B_FORMAT_NONE  _T("-,-,-,-,-,")
#define OUTPUT_DIFF_B_FORMAT_OLDPATH _T("\"%s\",\"%s\"\n")
#define OUTPUT_DIFF_B_FORMATFUNC_INVALID _T("-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,")
#define OUTPUT_DIFF_B_NONE _T(",-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-,-\n")\
 
 
#define OUTPUT_CVS_SEP _T(",")
#define OUTPUT_NOT_TARGET _T("-")
#define OUTPUT_ERROR_FORMAT _T("\"%s\",\"%s\",%s,%s,x\n")
#define OUTPUT_ERROR_FORMAT_CK _T("\"%s\",\"%s\",%s,%s,%s,x\n")
 
#define NKF_OUTENC_UNI     _T(" -w80 ")
 
#define UNC_LANGOPT_CPP     _T("CPP")
#define UNC_LANGOPT_C       _T("C")
#define UNC_LANGOPT_JAVA    _T("JAVA")
 
#define STRUCT_DEFAULT_CHARSET  ENCODING_UTF_8
#define STRUCT_OPTION_DEBUG     _T(" --debug ")
#define STRUCT_OPTION_DEBUG2    _T(" --debug2 ")
 
#define MSG_INVALID_OPTION      _T("Invalid option specified.%s : %s\n")                    //* MSG_LOG_ID_C_00000433
#define MSG_INVALID_PARAM       _T("Invalid optional parameter specified.%s : %s\n")        //* MSG_LOG_ID_C_00000434
#define MSG_INVALID_MUSTPARAM   _T("Optional parameter not specified.%s : %s\n")            //* MSG_LOG_ID_C_00000436
#define MSG_SHOW_MOREINFO       _T("For more information, execute  'ncmeter --help'.%s\n")  //* MSG_LOG_ID_C_00000437
#define MSG_INVALID_DLL         _T("DLL File not found.%s : %s\n")                          //* MSG_LOG_ID_C_00000438
#define MSG_INVALID_CHARSET     _T("Optional parameter not specified.%s : -charset\n")      //* MSG_LOG_ID_C_00000441
#define MSG_UNKNOWN_OPTION      _T("Invalid option specified.%s : -%s\n")                   //* MSG_LOG_ID_C_00000442
#define MSG_WARNING             _T("")                                                      //* MSG_LOG_ID_C_00000445
#define MSG_INVALID_PROPERTY    _T("This property attribute cannot be specified.%s : %s\n") //* MSG_LOG_ID_C_00000820
 
#define SOURCEID_LEN             8
#define SOURCEID_FMT             _T("%08d")
#define MAX_PATH				 260
 
 
#define OPTION_STR_EXECUTION_ROW        _T("row")
#define OPTION_STR_EXECUTION_DIFF       _T("diff")
#define OPTION_STR_EXECUTION_STRUCT     _T("struct")
#define OPTION_STR_EXECUTION_CK			_T("ck")
#define OPTION_STR_STRUCT_STD           _T("struct_std")
#define OPTION_STR_STRUCT_SMP           _T("struct_smp")
#define OPTION_STR_DIFF_FILE            _T("diff_file")
#define OPTION_STR_DIFF_FUNC            _T("diff_func")
#define OPTION_STR_F_OUTPUT_MODE        _T("F")
#define OPTION_STR_TFO_OUTFILE          _T("Tfo")
#define OPTION_STR_TFP_PROPFILE         _T("Tfp")
#define OPTION_STR_D_MACRO              _T("D")
#define OPTION_STR_U_MACRO              _T("U")
#define OPTION_STR_I_DIR                _T("I")
#define OPTION_STR_OPT_CLASS            _T("optclass")
#define OPTION_STR_V_SHOWDETAILS        _T("v")
#define OPTION_STR_HELP_USAGE           _T("-help")
#define OPTION_STR_RESTYLE              _T("RESTYLE")
#define OPTION_STR_STMT                 _T("STMT")
#define OPTION_STR_TTC                  _T("Ttc")
#define OPTION_STR_LCDEBUG              _T("detail")
#define OPTION_STR_SPS_DEBUG            _T("debug2")
#define OPTION_STR_DEBUG                _T("debug")
#define OPTION_STR_HEADER_ADD           _T("header_add")
#define OPTION_STR_HEADER               _T("header")
#define OPTION_STR_MAKE                 _T("make")
#define OPTION_STR_FOOTER               _T("footer")
#define OPTION_STR_STDATE               _T("STDATE")
#define OPTION_STR_EDDATE               _T("EDDATE")
#define OPTION_STR_CHARSET              _T("charset")
#define OPTION_STR_DIFFBLANK            _T("diff_blank")
#define OPTION_STR_RESULT_CODE          _T("Qrc")
#define OPTION_STR_LOG_CODE             _T("Qlg")
#define OPTION_STR_PERFORMANCE          _T("-performance")
 
#define OPTION_SEPARATE_HYPHEN          _T(" -")
#define OPTION_SEPARATE_SPACE           _T(" ")
#define OPTION_HYPHEN                   _T("-")     //!<nCt
#define OPTION_EQUAL                    _T("=")     //!<L
 
 
#define DEBUG_PRINT_LOG  1
#define DEBUG_PRINT_CSV  2
#define DEBUG_PRINT_XML  3
 
#define STRUCT_ITEM_NUM_FIFO 25
#define STRUCT_ITEM_DIR 1
#define STRUCT_ITEM_NESTS 13
 
#define STRUCT_NESTS_STR_LEN 12
 
#define CMP_V_TYPE_C (1)
#define CMP_V_TYPE_J (2)
 
#define JAVA_VERSION_STR_1_4 _T("JDK_1_4")
#define JAVA_VERSION_STR_1_5 _T("JDK_1_5")
 
#define QRT_LITERAL_STR_ADD _T("excel")
#define QRT_LITERAL_STR_NOTHING _T("none")
 
#define CNT_STR_NESTS_COUNT_ALLBLOCK _T("allblock")
#define CNT_STR_NESTS_COUNT_INNERBLOCK _T("innerblock")
 
#define OUT_FORMAT_STR_CSV _T("csv")
#define OUT_FORMAT_STR_XML _T("xml")
 
#define RESTYLE_MODE_STR_NONE _T("NONE")
#define RESTYLE_MODE_STR_STD  _T("STD")
#define RESTYLE_MODE_STR_BOTH _T("BOTH")
 
/* e|tH_pX쐬p */
#define TMPDIR_NAME_TMP         _T("TMP")
#define TMPDIR_NAME_TEMP        _T("TEMP")
#define TMPDIR_NAME_USERPROFILE _T("USERPROFILE")
#define TMPDIR_NAME_WINDIR      _T("windir")

/* enum */
/*! @enum */
typedef enum OUTPUT_TAG_ID {
    TAG_PEAR_NUMBER, TAG_PEAR_STRING, TAG_PEAR_STRING_UTF,
    TAG_START, TAG_START_CRL, TAG_END,
    TAG_EMPTY, TAG_NO_TARGET, TAG_PEAR_STRING_EUCtoUTF
} tag_OUTPUT_TAG_ID;

typedef enum XML_TAG_TYPE {
    TAG_TYPE_VALUE, TAG_TYPE_STRING, TAG_TYPE_STRING_UTF
} tag_XML_TAG_TYPE;

typedef enum stXMLTableType {
    TAG_OUTLINE, TAG_COM_TYPE, TAG_ROW_TYPE, TAG_DIFF_STD, TAG_DIFF_EXT, TAG_DIFF_TYPE, TAG_STRUCT, TAG_CK_TYPE, TAG_CK
} tag_stXMLTableType;

typedef enum XML_Enum_OutLine {
    EXE_PROP_TAG_NAME = 0,  EXE_MODE_TAG_NAME,  MODE_DETL_TAG_NAME, TOOL_PATH_TAG_NAME, TOOL_VRSN_TAG_NAME,
    CMD_PARAM_TAG_NAME, PRP_FILE_TAG_NAME,  STYL_TYPE_TAG_NAME, DOC_CNT_TAG_NAME, MCR_DEF_TAG_NAME,
    SKIP_TYPE_TAG_NAME, DIFF_BLNK_TAG_NAME, DIFF_CNTM_TAG_NAME, RSLT_SMM_TAG_NAME,
    STRT_DATE_TAG_NAME,  END_DATE_TAG_NAME, TOTL_FLS_TAG_NAME,  SCS_FLS_TAG_NAME,
    ERR_FLS_TAG_NAME, ROOT_TAG_NAME, REPT_TAG_NAME, FILE_UNIT_TAG_NAME, FUNC_UNIT_TAG_NAME, CLASS_UNIT_TAG_NAME
    , NCM_DEBUG_TAG_NAME, NCM_DEBUG_INFO_TAG_NAME
} tag_XML_Enum_OutLine;

typedef enum XML_Enum_Com {
    METRICS_TAG_NAME = 0,
    RESTYLE_TAG_NAME,  DIR_TAG_NAME, FILE_TAG_NAME,
    LANG_TAG_NAME,     FUNC_TAG_NAME
} tag_XML_Enum_Com;

typedef enum XML_Enum_diff_type {
    TAG_TYPE_DIFF_NONE = 0,  TAG_TYPE_DIFF_STD,  TAG_TYPE_DIFF_EXT,
} tag_XML_Enum_diff_type;

typedef enum XML_Enum_Row {
    STMT_TAG_NAME = 0,
    TLOC_TAG_NAME, ELOC_TAG_NAME, CLOC_TAG_NAME, BLOC_TAG_NAME,
    SKIP_TAG_NAME, ICLOC_TAG_NAME, CODE_TAG_NAME, PREP_TAG_NAME, DOC_TAG_NAME, REM_TAG_NAME
} tag_XML_Enum_Row;

typedef enum XML_Enum_Diff_std {
    STATE_STD = 0,
    EQU_ELOC_STD, ADD_ELOC_STD, DEL_ELOC_STD,
    EQU_CLOC_STD, ADD_CLOC_STD, DEL_CLOC_STD,
    OLD_DIR_STD,  OLD_FILE_STD
} tag_XML_Enum_Diff_std;

typedef enum XML_Enum_Diff_ext {
    STATE_EXT = 0,
    EQU_TOTAL_EXT, ADD_TOTAL_EXT, DEL_TOTAL_EXT, MODADD_TOTAL_EXT, MODDEL_TOTAL_EXT,
    EQU_ELOC_EXT,  ADD_ELOC_EXT,  DEL_ELOC_EXT,  MODADD_ELOC_EXT,  MODDEL_ELOC_EXT,
    EQU_CLOC_EXT,  ADD_CLOC_EXT,  DEL_CLOC_EXT,  MODADD_CLOC_EXT,  MODDEL_CLOC_EXT,
    EQU_BLOC_EXT,  ADD_BLOC_EXT,  DEL_BLOC_EXT,  MODADD_BLOC_EXT,  MODDEL_BLOC_EXT,
    EQU_SKIP_EXT,  ADD_SKIP_EXT,  DEL_SKIP_EXT,  MODADD_SKIP_EXT,  MODDEL_SKIP_EXT,
    OLD_DIR_EXT,   OLD_FILE_EXT
} tag_XML_Enum_Diff_ext;

typedef enum XML_Enum_STRUCT {
    FLOC_TAG_STRUCT = 0,
    ELOC_TAG_STRUCT,  CLOC_TAG_STRUCT,    BLOC_TAG_STRUCT,
    CYCLO_TAG_STRUCT, CYCLOWC_TAG_STRUCT, BRANCHS_TAG_STRUCT,
    CNDOPS_TAG_STRUCT, NESTS_TAG_STRUCT,
    EVALR_TAG_STRUCT, EVALS_TAG_STRUCT,   AVALS_TAG_STRUCT, PARMS_TAG_STRUCT,
    FANIN_TAG_STRUCT, FANOUT_TAG_STRUCT,
    FIN_FUNC_TAG_STRUCT, FIN_PARA_TAG_STRUCT, FIN_GVAL_TAG_STRUCT,
    FOUT_FUNC_TAG_STRUCT, FOUT_PARA_TAG_STRUCT, FOUT_GVAL_TAG_STRUCT
} tag_XML_Enum_STRUCT;

typedef enum CSV_Enum_STRUCT {
    DIR_VALUE = 0, FILE_VALUE, FUNC_VALUE, LANG_VALUE, FLOC_VALUE, ELOC_VALUE,
    CLOC_VALUE, BLOC_VALUE, CYCLO_VALUE, CYCLOWC_VALUE,
    BRANCHS_VALUE, CNDOPS_VALUE, NNESTS_VALUE, EVALR_VALUE,
    EVALS_VALUE, AVALS_VALUE, PARMS_VALUE, FANIN_VALUE, FANOUT_VALUE,
    FIN_FUNC_VALUE, FIN_PARA_VALUE, FIN_GVAL_VALUE,
    FOUT_FUNC_VALUE, FOUT_PARA_VARLUE, FOUT_GVAL_VALUE
} tag_CSV_Enum_STRUCT;

typedef enum XML_Enum_CkCom {
    METRICS_CK_TAG_NAME = 0,
    DIR_CK_TAG_NAME, FILE_CK_TAG_NAME,
    PACKAGE_CK_TAG_NAME, CLASS_CK_TAG_NAME, LANG_CK_TAG_NAME
} tag_XML_Enum_CkCom;

typedef enum CSV_Enum_CK {
    CK_DIR_VALUE = 0, CK_FILE_VALUE, CK_PACKAGE_VALUE, CK_CLASS_VALUE, CK_LANG_VALUE, CK_WMC_VALUE,
    CK_RFC_VALUE, CK_LCOM_VALUE, CK_DIT_VALUE, CK_NOC_VALUE, CK_CBO_VALUE
} tag_CSV_Enum_CK;

typedef enum XML_Enum_CK {
    WMC_TAG_CK = 0,
    RFC_TAG_CK,  LCOM_TAG_CK,    DIT_TAG_CK,  NOC_TAG_CKT, CBO_TAG_CK
} tag_XML_Enum_CK;

typedef enum METRICS_TYPE {
    METRICS_NG,
    METRICS_NO_FUNC,
    METRICS_OK
} tag_METRICS_TYPE;

/* struct */
typedef struct tag_OPTFLAGS {
    unsigned bOpt_ExecutionMode: 1;
    unsigned bOpt_F_OutputMode: 1;
    unsigned bOpt_Tfo_Outfile: 1;
    unsigned bOpt_Tfp_Propfile: 1;
    unsigned bOpt_RESTYLE: 1;
} _OPTFLAGS;


typedef struct tag_LCEXT_OPT {
    _TCHAR *pcTargetFile;
    _TCHAR *pcLangName;
    _TCHAR *pcDiffFuncPath;
} _LCEXT_OPT;

typedef struct tag_PLAT_INFO {
    _TCHAR *pcPlatVer;
    _TCHAR *pcPlatOpt;
} _PLAT_INFO;

typedef struct tag_FileTree {
    _TCHAR *pFileName;
    _TCHAR *pLangName;
    struct tag_FileTree *pNext;
} _FileTree;

/* type */
typedef int (__stdcall *funcSetNkfOption)(LPSTR);
typedef BOOL (__stdcall *funcNkfConvert2SafeW)(LPCWSTR, DWORD, LPCWSTR, DWORD);


typedef struct tag_RESULTINFO_FILEITEMS {
    _TCHAR *pcDIR;      //!< 茋DIRڂɏo͂
    _TCHAR *pcFILE;     //!< 茋FILEڂɏo͂
    _TCHAR *pcOLDDIR;   //!< 茋OLDDIRڂɏo͂
    _TCHAR *pcOLDFILE;  //!< 茋OLDFILEڂɏo͂
} RESULTINFO_FILEITEMS;

typedef struct tag_RESULTINFO_ITEMS {
    const _TCHAR *pcFUNC;       //!< 茋FUNCڂɏo͂
    const _TCHAR *pcLANG;       //!< 茋LANGڂɏo͂
    const _TCHAR *pcSTATE;      //!< 茋STATEڂɏo͂
    long *plSTMT;               //!< STMT茋
    int iLangType;              //!< 
} RESULTINFO_ITEMS;

/* extern */
extern _TCHAR *pcNkfDllPath;
extern _TCHAR *pcCharSet;
extern _TCHAR *pcStartDate;
extern _TCHAR *pcEndDate;
extern _TCHAR *pcCommandOptions;
extern _TCHAR *pcCommandOptions_MODE;
extern _TCHAR *pcCommandOptions_OTHER;
extern _TCHAR *pcKnownOptsCmdBuf;
extern size_t szKnownOptsCmdBufSize;
extern int iExecuteMode;
extern int iStructMode;
extern int iDiffMode;
extern int giRestyleMode;
extern int giRestyleBothFlg;
extern int giBothHeadFlg;
extern int iSkipChangeFlg;
extern int iOutFileFormat;
extern int giDiffBlankFlg;
extern int giDiffCountMode;
extern int giExceptBinaryMode;
extern int giStmtMode;;
extern int giFANIOMode;
extern _TCHAR *pcObjectName;
extern _TCHAR *pcObjectPath;
extern _TCHAR *pcOutFileName;
extern const _TCHAR *pcOutFileNameLogOut;
extern _TCHAR *pcProfFileName;
extern const _TCHAR *pcProfFileNameLogOut;
extern int iProfileFlag;
extern int giProfileNKFEXESetting;
extern int giDocFlag;
extern int giCmntCaseFlag;
extern FILE *spcOutFile;
extern FILE *fp_diff_ret_file;
extern _TCHAR *pcKnownOpts;
extern int iShowDetails;
extern int iShowHelp;
extern int iDebug;
extern long giPerformance;
extern int iSpsDebug;
extern int giMoreDebug;
extern _TCHAR *pcResultCodeOpts;
extern _TCHAR *pcLogCodeOpts;

extern int globaliLangType;

extern _TCHAR *pcDoc;
extern _TCHAR *pcDef;
extern _TCHAR *pcParse;
extern _TCHAR *pcSkip;
extern _TCHAR *pcNkf;
extern _TCHAR *pcNkfExe;
extern _TCHAR *pcNkfExeDefault;
extern _TCHAR *pcBeautifier;
extern _TCHAR *pcBeautifierExe;
extern _TCHAR *pcBeautifierExeDefault;
extern _TCHAR *pcBeautifierCfgDefault;
extern _TCHAR *pcDiffParse;
extern _TCHAR *pcDiffOpMode;
extern _TCHAR *pcDiffBlank;
extern _TCHAR *pcDiffCountMode;
extern _TCHAR *pcExceptBinary;
extern _TCHAR *pcFuncOpt;
extern _TCHAR *pcJAVAExe;
extern _TCHAR *pcJAVAVmOptionXmx;
extern _TCHAR *pcCmntCase;
extern _TCHAR *pcStmtMode;
extern _TCHAR *pcFanIOMode;
extern _TCHAR *pcTempFio;
extern _TCHAR *pcTempXref;
extern _TCHAR *pcCharsetOutCsv_prop;
extern _TCHAR *pcQrc_option;
extern _TCHAR *pcCharsetOutLog_prop;
extern _TCHAR *pcQlg_option;
extern _TCHAR *pcNcmDebugProp;
extern int iNestsCount;
extern int iDiffModeDetailOut;
extern int iNumOfFiles;
extern int iNumOfSuccess;
extern int iNumOfUnrecognized;
extern _TCHAR *pcTempFolderName;
extern _TCHAR *pcMacroAnalizerPath;
extern _TCHAR *pcSedToolPath;
extern _TCHAR *pcDiffPath;
extern _TCHAR *pcStructPath;
extern _TCHAR *pcStructSmpPath;
extern _TCHAR *pcStructJAVAPath;
extern _TCHAR *pcStructCSPath;
extern _TCHAR *pcStructVBPath;
extern _TCHAR *pcStructJSPath;
extern _TCHAR *pcCkJAVAPath;
extern _TCHAR *pcHelpPath;
extern int iSourceID;
#if NEED_SOURCE_ID
extern _TCHAR chSourceID[];
#else
extern _TCHAR *chSourceID;
#endif
extern _TCHAR *pcJAVAExeVersion;
extern _TCHAR *pcProcessID;
extern _TCHAR *gpcCompType;
extern _TCHAR *gpcCompOpt;
extern _TCHAR *gpcSysInc;
extern int giPlType;
extern _TCHAR *gpcCompTypeForC;
extern _TCHAR *gpcCompTypeForJava;
extern _TCHAR *gpcQrtLiteral;
extern int giQrtOutFlg;
extern _TCHAR *gpcOutputFormat;
extern int globaliLangType;
extern int giOutFileAdd;
extern int giOutHeaderFlg;
extern int giOutFooterFlg;

extern int CDMtrCntMainShowFile(const _TCHAR *pcFileName);

#endif
