/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef CDMTRCNTXREFDATAUTIL_H_
#define CDMTRCNTXREFDATAUTIL_H_

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include "CDMtrCntXrefData.h"
#include "CDMtrCmn.h"
#include "CDMtrLibCmnW.h"
#define ERR_LOG stderr
#define DEB_LOG stdout

#define _CRT_SECURE_NO_DEPRECATE 1

extern int iSpsDebug ;
//* MSG_LOG_ID_C_00000475, MSG_LOG_ID_C_00000476, MSG_LOG_ID_C_00000477, MSG_LOG_ID_C_00000478
#define ERROR_LOG(MSG) { \
        CDMtrLibCmnLogOut(_T("")); \
        CDMtrLibCmnLogOut MSG; \
        iSpsDebug == DEBUG_ON ? \
        CDMtrLibCmnLogOut(_T(" <%s:%d> \n"), _METHOD_LABEL_, __LINE__ ): \
        CDMtrLibCmnLogOut(_T("\n")); \
    }

//* MSG_LOG_ID_C_00000479, MSG_LOG_ID_C_00000480, MSG_LOG_ID_C_00000481, MSG_LOG_ID_C_00000482
#define WARNING_LOG(MSG) { \
        CDMtrLibCmnLogOut(_T("")); \
        CDMtrLibCmnLogOut MSG; \
        iSpsDebug == DEBUG_ON ? \
        CDMtrLibCmnLogOut(_T(" <%s:%d> \n"), _METHOD_LABEL_, __LINE__ ): \
        CDMtrLibCmnLogOut(_T("\n")); \
    }

//* MSG_LOG_ID_C_00000483, MSG_LOG_ID_C_00000484, MSG_LOG_ID_C_00000485, MSG_LOG_ID_C_00000486
#define DEBUG_LOG(MSG) { \
        if(iDebug == DEBUG_ON){ \
            CDMtrLibCmnLogOut(_T("")); \
            CDMtrLibCmnLogOut MSG; \
            iSpsDebug == DEBUG_ON ? \
            CDMtrLibCmnLogOut(_T(" <%s:%d> \n"), _METHOD_LABEL_, __LINE__ ): \
            CDMtrLibCmnLogOut(_T("\n")); \
        } \
    }

#define RET_UTIL_ERROR				-1
#define RET_UTIL_NEWREGISTERED		0
#define RET_UTIL_DUPLICATE_ABORT	1
#define RET_UTIL_DUPLICATE_SKIP		2

typedef struct fanXrefDataList {

    xrefData *pSrcList;

    int numOfSrcList;

    xrefData **ppStaticList;

    int numOfStaticList;
} fanXrefDataList;

typedef struct fanCounter {

    xrefData *pXrefData;


    int finNumOfCallThisProc;

    int finNumOfGlobalVariablesRead;

    int finNumOfParametersRead;


    int foutNumOfProcCall;

    int foutNumOfGlobalVariablesWrittenTo;

    int foutNumOfByRefParamWrittenTo;

    unsigned int csvHashKey;

} fanCounter;

typedef struct fanCounterList {
    fanCounter *pFanCounter;
    int iListSize;
} fanCounterList;

typedef struct nameStack {

    _TCHAR *pNameStack;
    xrefData **ppXrefData;
    unsigned int *pHashStack;

    int numOfStack;

    int numOfAlloced;

} nameStack;



#define HASH_SIZE 100000
#define HASH_LIST_BASE 100

typedef struct xrefHash {
    xrefData **ppXrefDataList;
    int xrefDataNum;
    int allocNum;
} xrefHash;

extern xrefHash *gXrefAfuncHashTable;
extern xrefHash *gXrefSnameHashTable;
extern xrefData *CDMtrCntXrefDataUtilLoadXrefByFileAndMakeHashTable(_TCHAR *filename, int *structSize);

void CDMtrCntXrefDataUtilInitHashTable();

void CDMtrCntXrefDataUtilFreeHashTable();
int CDMtrCntXrefDataUtilSetHashTable(xrefData *);
unsigned int getHashNumber(_TCHAR *key);


extern int CDMtrCntXrefDataUtilIsSameSid(xrefData **ppXrefDataList, int dataSize, _TCHAR *id, unsigned int hash_id);

extern void CDMtrCntXrefDataUtilInitNameStack(nameStack *pStack);
extern void CDMtrCntXrefDataUtilFreeNameStackData(nameStack *pStack);

extern int CDMtrCntXrefDataUtilPushNameStack(nameStack *pStack, _TCHAR *name);

extern int CDMtrCntXrefDataUtilIsStacked(nameStack *pStack, _TCHAR *name);


extern fanCounter *CDMtrCntXrefDataUtilGetFunctionList(fanXrefDataList *xrefDataList, int *funcListSize);

void CDMtrCntXrefDataUtilFreeXrefData();
void CDMtrCntXrefDataUtilFreeStaticList();
void CDMtrCntXrefDataUtilFreeAllXrefTables();

extern xrefData *CDMtrCntXrefDataUtilLoadXrefByFile(_TCHAR *filename, int *structSize);

extern int CDMtrCntXrefMerge(_TCHAR *csvfile, fanCounterList *fanCountList, _TCHAR *outfile);
_TCHAR *CDMtrCntXrefDataUtilGetNextCsvToken(_TCHAR *strToken, int tokenMax, const _TCHAR *strCsvLineData);

#endif
