/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include "CDMtrCmn.h"
#include "CDMtrExtCmn.h"
#include "CDMtrLibCmnW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrLibSystemW.h"
#include "CDMtrCntMain.h"
#include "CDMtrCntCompileEnv.h"
#include "CDMtrMessage.h"

/*----------------------------------------------------------------------------*/
/* static variable declaration                                                */
/*----------------------------------------------------------------------------*/
static _PLAT_INFO stPlatWinTable[] = {
    { _T("VC40"),     _T("--microsoft --microsoft_version 1000") },
    { _T("VC41"),     _T("--microsoft --microsoft_version 1010") },
    { _T("VC42"),     _T("--microsoft --microsoft_version 1020") },
    { _T("VC50"),     _T("--microsoft --microsoft_version 1100") },
    { _T("VC60"),     _T("--microsoft --microsoft_version 1200") },
    { _T("VC70"),     _T("--microsoft --microsoft_version 1300") },
    { _T("VC71"),     _T("--microsoft --microsoft_version 1310") },
    { _T("VC80"),     _T("--microsoft --microsoft_version 1400") },
};

static const _TCHAR *stJavaTable[] = {JAVA_VERSION_STR_1_4, JAVA_VERSION_STR_1_5};

/*----------------------------------------------------------------------------*/
/* static function declaration                                                */
/*----------------------------------------------------------------------------*/
static int cdmtrCntCompileEnvGetLangVersionType(_TCHAR *pstrbuff);
static int cdmtrCntCompileEnvGetSysOption(int iPlType, _TCHAR *pcCompVer, _TCHAR **ppcCompOpt, _TCHAR **ppcSysInc);
static int cdmtrCntCompileEnvGetWinOption(_TCHAR *pcCompVer, _TCHAR **ppcCompOpt, _TCHAR **ppcSysInc);

/*----------------------------------------------------------------------------*/
/* global function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief          EDG͗pIvVݒ肷

*/
int CDMtrCntCompileEnvGetEDGOption(_TCHAR *pcCompilerType)
{
    int iRet = RET_NG;
    int iFuncRet;
    _TCHAR *pcInc;
    pcInc = NULL;
    iFuncRet = cdmtrCntCompileEnvGetSysOption(giPlType, pcCompilerType, &gpcCompOpt, &pcInc);
    if (iFuncRet != RET_OK) {
        if (pcCompilerType != NULL) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000183, pcCompilerType); //* MSG_LOG_ID_C_00000183
        }
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibUtilCreateStringW(&gpcSysInc, OPTION_SEP_SPACE, pcInc, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcInc);
    return iRet;
}

/*!
    @brief          RpCEo[W(-Ttc)C/C++pJavapɕĐݒ肷
*/
int CDMtrCntCompileEnvSeparateTTCVersion(_TCHAR *pcCompilerType,
        _TCHAR **pstrCompTypeForC,
        _TCHAR **pstrCompTypeForJava)
{
#define SEPARATE_STR _T(";")
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    _TCHAR *pcSep;
    _TCHAR *buff;
    _TCHAR *pStr1;
    _TCHAR *pStr2;
    int RetStr1 = 0;
    int RetStr2 = 0;
    pcSep = NULL;
    buff  = NULL;
    CDMtrLibUtilFreeW((void **)pstrCompTypeForC);
    CDMtrLibUtilFreeW((void **)pstrCompTypeForJava);
    if (pcCompilerType == NULL) {
        iRet = RET_OK;
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibUtilMallocW((void **)&buff, (_tcslen(pcCompilerType) + 1) * sizeof(_TCHAR));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    _tcscpy(buff, pcCompilerType);
    pcSep = _tcsstr(buff, SEPARATE_STR);
    if (pcSep != NULL) {
        pStr1 = buff;
        pStr2 = (pcSep + 1);
        *pcSep = _T('\0');
        RetStr1 = cdmtrCntCompileEnvGetLangVersionType(pStr1);
        RetStr2 = cdmtrCntCompileEnvGetLangVersionType(pStr2);
        if (RetStr1 == RetStr2 ||
                RetStr1 == 0       ||
                RetStr2 == 0) {
            goto FUNC_END;
        } else {
            if (RetStr1 == CMP_V_TYPE_J) {
                iFuncRet = CDMtrLibUtilMallocW((void **)pstrCompTypeForJava, (_tcslen(pStr1) + 1) * sizeof(_TCHAR));
                if (iFuncRet != RET_OK) {
                    goto FUNC_END;
                }
                _tcscpy(*pstrCompTypeForJava, pStr1);
                iFuncRet = CDMtrLibUtilMallocW((void **)pstrCompTypeForC, (_tcslen(pStr2) + 1) * sizeof(_TCHAR));
                if (iFuncRet != RET_OK) {
                    goto FUNC_END;
                }
                _tcscpy(*pstrCompTypeForC, pStr2);
                iRet = RET_OK;
            } else {
                iFuncRet = CDMtrLibUtilMallocW((void **)pstrCompTypeForJava, (_tcslen(pStr2) + 1) * sizeof(_TCHAR));
                if (iFuncRet != RET_OK) {
                    goto FUNC_END;
                }
                _tcscpy(*pstrCompTypeForJava, pStr2);
                iFuncRet = CDMtrLibUtilMallocW((void **)pstrCompTypeForC, (_tcslen(pStr1) + 1) * sizeof(_TCHAR));
                if (iFuncRet != RET_OK) {
                    goto FUNC_END;
                }
                _tcscpy(*pstrCompTypeForC, pStr1);
                iRet = RET_OK;
            }
        }
    } else {
        pStr1 = buff;
        RetStr1 = cdmtrCntCompileEnvGetLangVersionType(pStr1);
        if (RetStr1 == CMP_V_TYPE_C) {
            iFuncRet = CDMtrLibUtilMallocW((void **)pstrCompTypeForC, (_tcslen(pStr1) + 1) * sizeof(_TCHAR));
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            _tcscpy(*pstrCompTypeForC, pStr1);
            iRet = RET_OK;
        } else if (RetStr1 == CMP_V_TYPE_J) {
            iFuncRet = CDMtrLibUtilMallocW((void **)pstrCompTypeForJava, (_tcslen(pStr1) + 1) * sizeof(_TCHAR));
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            _tcscpy(*pstrCompTypeForJava, pStr1);
            iRet = RET_OK;
        } else {
        }
    }
FUNC_END:
    if (buff) free(buff);
    return iRet;
}

/*!
    @brief          JAVÃRpCEo[W擾
*/
int CDMtrCntCompileEnvGetJavaOption(_TCHAR **pstrJavaVersion)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    int i = 0;
    if (*pstrJavaVersion == NULL) {
        iFuncRet = CDMtrLibUtilMallocW((void **)pstrJavaVersion, (_tcslen(JAVA_VERSION_STR_1_5) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(*pstrJavaVersion, JAVA_VERSION_STR_1_5);
        iRet = RET_OK;
        goto FUNC_END;
    }
    CDMtrLibUtilToupperW(*pstrJavaVersion);
    for (i = 0; i < sizeof(stJavaTable) / sizeof(_TCHAR *); i++) {
        if (_tcscmp(*pstrJavaVersion, stJavaTable[i]) == 0) {
            iRet = RET_OK;
            goto FUNC_END;
        }
    }
FUNC_END:
    return iRet;
}

/*----------------------------------------------------------------------------*/
/* static function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief          RpCEo[W(-Ttc)̎ʂ𔻒fĐݒ肷B
*/
static int cdmtrCntCompileEnvGetLangVersionType(_TCHAR *pstrbuff)
{
    int iRet = 0;
    int i;
    CDMtrLibUtilToupperW(pstrbuff);
    for (i = 0; i < sizeof(stJavaTable) / sizeof(_TCHAR *); i++) {
        if (_tcscmp(pstrbuff, stJavaTable[i]) == 0) {
            iRet = CMP_V_TYPE_J;
            goto FUNC_END;
        }
    }
    iRet = CMP_V_TYPE_C;
FUNC_END:
    return iRet;
}

/*!
    @brief          RpCEo[WRpCIvVƃVXeCN[hpX擾
*/
static int cdmtrCntCompileEnvGetSysOption(int iPlType, _TCHAR *pcCompVer, _TCHAR **ppcCompOpt, _TCHAR **ppcSysInc)
{
    int iRet = RET_NG;
    switch (iPlType) {
    case PLATFORM_TYPE_WIN:
        iRet = cdmtrCntCompileEnvGetWinOption(pcCompVer, ppcCompOpt, ppcSysInc);
        break;
    case PLATFORM_TYPE_UNKNOW:
    default:
        break;
    }
    return iRet;
}

/*!
    @brief          RpCEo[WRpCIvVƃVXeCN[hpX擾(WindowsvbgtH[)
*/
static int cdmtrCntCompileEnvGetWinOption(_TCHAR *pcCompVer, _TCHAR **ppcCompOpt, _TCHAR **ppcSysInc)
{
    int iRet = RET_NG;
    int iFuncRet;
    int i;
    unsigned int uiLen;
    _TCHAR *pcCompileVer;
    _TCHAR *pcOpt;
    _TCHAR *pcInc;
    pcOpt = NULL;
    pcInc = NULL;
    if (pcCompVer == NULL) {
        pcCompileVer = COMPVER_WIN_DEFALT;
    } else {
        pcCompileVer = pcCompVer;
    }
    for (i = 0; i < (sizeof(stPlatWinTable) / sizeof(_PLAT_INFO)); i++) {
        if (_tcscmp(pcCompileVer, stPlatWinTable[i].pcPlatVer) == 0) {
            pcOpt = stPlatWinTable[i].pcPlatOpt;
            break;
        }
    }
    if (pcOpt == NULL) {
        goto FUNC_END;
    }
    uiLen = _tcslen(stPlatWinTable[i].pcPlatOpt);
    iFuncRet = CDMtrLibUtilMallocW((void **)&pcOpt, (uiLen + 1) * sizeof(_TCHAR));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    _tcsncpy(pcOpt, stPlatWinTable[i].pcPlatOpt, uiLen);
    pcOpt[uiLen] = _T('\0');
    uiLen = _tcslen(SYSINC_WIN_DEFAULT);
    iFuncRet = CDMtrLibUtilMallocW((void **)&pcInc, (uiLen + 1) * sizeof(_TCHAR));
    if (iFuncRet != RET_OK) {
        CDMtrLibUtilFreeW((void **)&pcOpt);
        goto FUNC_END;
    }
    _tcsncpy(pcInc, SYSINC_WIN_DEFAULT, uiLen);
    pcInc[uiLen] = _T('\0');
    *ppcCompOpt = pcOpt;
    *ppcSysInc = pcInc;
    iRet = RET_OK;
FUNC_END:
    return iRet;
}


