/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <tchar.h>

#include "CDMtrCmn.h"
#include "CDMtrExtCmn.h"
#include "CDMtrLibCmnW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrLibSystemW.h"
#include "CDMtrCntMain.h"
#include "CDMtrCntLang.h"
#include "CDMtrCntCallProc.h"
#include "CDMtrCntExtTool.h"
#include "CDMtrCntLog.h"
#include "CDMtrLibFileW.h"
#include "CDMtrLibOptW.h"
#include "CDMtrMessage.h"

/*----------------------------------------------------------------------------*/
/* static variable declaration                                                */
/*----------------------------------------------------------------------------*/
static funcSetNkfOption     glpfnDllFuncNKFSetOpt = NULL;
static funcNkfConvert2SafeW glpfnDllFuncNKFConvert = NULL;

/*----------------------------------------------------------------------------*/
/* global function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief          }NAiCU[R}h쐬
*/
int CDMtrCntExtToolCreateMacroAnalizerCommand(_TCHAR **pcCommand, _TCHAR *pcInfileName, _TCHAR *pcTemp1, _TCHAR *pcTemp2, _TCHAR *pcTemp3, _TCHAR *pcOutFile)
{
    int iRet = RET_NG;
    int iFuncRet;
    _TCHAR *pcDirPath = NULL;
    _TCHAR *pcWorkPath = NULL;
    iFuncRet = CDMtrLibUtilMallocW((void **)&pcWorkPath, (_tcslen(pcInfileName) + 1) * sizeof(_TCHAR));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibFileGetDirName(pcInfileName, pcWorkPath);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibFileGetShortPathWithinMaxpathW(pcWorkPath, &pcDirPath);
    if (iFuncRet != RET_OK) {
        pcDirPath = CDMtrLibUtilCopyString(pcWorkPath);
    }
    switch (iExecuteMode) {
    case ROW_MODE:
    case DIFF_MODE:
        iFuncRet = CDMtrLibUtilCreateStringW(pcCommand,
                                             pcMacroAnalizerPath,
                                             _T(" -P -o \""),
                                             pcTemp1,
                                             _T("\" --error_output \""),
                                             pcTemp2,
                                             _T("\" -F \""),
                                             pcTemp3,
                                             _T("\" -I\""),
                                             pcDirPath,
                                             _T("\" "),
                                             pcKnownOpts,
                                             OPTION_SEP_SPACE,
                                             gpcSysInc,
                                             _T(" \""),
                                             pcOutFile,
                                             _T("\""),
                                             NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        break;
    case STRUCT_MODE:
        break;
    default:
        break;
    }
    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcWorkPath);
    CDMtrLibUtilFreeW((void **)&pcDirPath);
    return iRet;
}

/*!
    @brief          sedR}h쐬
*/
int CDMtrCntExtToolCreateSedCommand(_TCHAR **pcCommand, _TCHAR *pcTemp3, _TCHAR *pcTemp4, _TCHAR *pcOutFile)
{
    int iRet = RET_NG;
    int iFuncRet;
    switch (iExecuteMode) {
    case ROW_MODE:
    case DIFF_MODE:
        iFuncRet = CDMtrLibUtilCreateStringW(pcCommand,
                                             pcSedToolPath,
                                             _T(" -u -f \""),
                                             pcTemp3,
                                             _T("\" -o \""),
                                             pcTemp4,
                                             _T("\" \""),
                                             pcOutFile,
                                             _T("\""),
                                             NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        break;
    case STRUCT_MODE:
        break;
    default:
        break;
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}

/*!
    @brief          uncrustifyR}h쐬
*/
int CDMtrCntExtToolCreateBeautifierCommand(_TCHAR **pcCommand, _TCHAR *pcInfileName, _TCHAR *pcLangName)
{
    int iRet = RET_NG;
    int iFuncRet;
    int iLangType;
    _TCHAR *pcLangOpt;
    pcLangOpt = NULL;
    iLangType = CDMtrCntLangGetTypeFromLangName(pcLangName);
    switch (iLangType) {
    case LANG_TYPE_CPP:
    case LANG_TYPE_CPPH:
        pcLangOpt = UNC_LANGOPT_CPP;
        break;
    case LANG_TYPE_C:
    case LANG_TYPE_CH:
        pcLangOpt = UNC_LANGOPT_C;
        break;
    case LANG_TYPE_JAVA:
        pcLangOpt = UNC_LANGOPT_JAVA;
        break;
    default:
        goto FUNC_END;
        break;
    }
    iFuncRet = CDMtrLibUtilCreateStringW(pcCommand, pcBeautifierExe,
                                         _T(" -l "), pcLangOpt,
                                         _T(" -f "), _T("\""), pcInfileName, _T("\""),
                                         NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}

/*!
    @brief          Oc[̑݊mFƎs\t@C̊mFs
*/
int CDMtrCntExtToolIsExtTool(_TCHAR *pcToolPath)
{
    int iRet;
    int iFuncRet;
    _TCHAR *pcPath;
    _TCHAR *p;
    _TCHAR *pcStart, *pcEnd;
    unsigned int uiPathLen;
    DWORD lpBinaryType;
    iRet = RET_FALSE;
    pcPath = NULL;
    if (pcToolPath == NULL) {
        goto FUNC_END;
    }
    uiPathLen = _tcslen(pcToolPath);
    p = pcToolPath;
    if (*p == DOUBLEQUOTATION_CHAR) {
        p++;
        pcStart = p;
        p = _tcsstr(p, DOUBLEQUOTATION);
        if (p == NULL) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000181, pcToolPath); //* MSG_LOG_ID_C_00000181
            goto FUNC_END;
        }
    } else {
        pcStart = p;
        p = _tcsstr(p, _T(" "));
    }
    if (p != NULL) {
        pcEnd = p - 1;
    } else {
        pcEnd = pcToolPath + uiPathLen;
    }
    iFuncRet = CDMtrLibUtilSetString(&pcPath, pcStart, pcEnd);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    if (GetBinaryType(pcPath, &lpBinaryType) == 0) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000182, pcPath); //* MSG_LOG_ID_C_00000182
        goto FUNC_END;
    }
    iRet = RET_TRUE;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcPath);
    return iRet;
}

/*!
    @brief          NKF̎sfs
*/
int CDMtrCntExtToolIsExecNkf(int iLangType)
{
    int iRet;
    iRet = RET_FALSE;
    switch (iLangType) {
    case LANG_TYPE_CPP:
    case LANG_TYPE_CPPH:
    case LANG_TYPE_C:
    case LANG_TYPE_CH:
    case LANG_TYPE_JAVA:
    case LANG_TYPE_CS:
    case LANG_TYPE_VB:
    case LANG_TYPE_JS:
    case LANG_TYPE_TXT:
    case LANG_TYPE_ETC:
        if (_tcscmp(pcNkf, _T("true")) == 0) {
            iRet = RET_TRUE;
        }
        break;
    case LANG_TYPE_BIN:
    case LANG_TYPE_UNKNOW:
    default:
        break;
    }
    return iRet;
}

/*!
    @brief          \[XR[h`̎sfs
*/
int CDMtrCntExtToolIsExecBeautifier(int iLangType)
{
    int iRet;
    iRet = RET_FALSE;

    switch (iLangType) {
    case LANG_TYPE_CPP:
    case LANG_TYPE_CPPH:
    case LANG_TYPE_C:
    case LANG_TYPE_CH:
    case LANG_TYPE_JAVA:
        if (_tcscmp(pcBeautifier, _T("true")) == 0) {
            iRet = RET_TRUE;
        }
        break;
    case LANG_TYPE_CS:
    case LANG_TYPE_VB:
    case LANG_TYPE_JS:
    case LANG_TYPE_TXT:
    case LANG_TYPE_BIN:
    case LANG_TYPE_ETC:
    case LANG_TYPE_UNKNOW:
    default:
        break;
    }
    return iRet;
}

/*!
    @brief          MacroAnalyzer̎sfs
*/
int CDMtrCntExtToolIsExecDef(int iLangType)
{
    int iRet;
    iRet = RET_FALSE;
    switch (iLangType) {
    case LANG_TYPE_CPP:
    case LANG_TYPE_CPPH:
    case LANG_TYPE_C:
    case LANG_TYPE_CH:
        if (_tcscmp(pcDef, _T("true")) == 0) {
            iRet = RET_TRUE;
        }
        break;
    case LANG_TYPE_JAVA:
    case LANG_TYPE_CS:
    case LANG_TYPE_VB:
    case LANG_TYPE_JS:
    case LANG_TYPE_TXT:
    case LANG_TYPE_BIN:
    case LANG_TYPE_ETC:
    case LANG_TYPE_UNKNOW:
    default:
        break;
    }
    return iRet;
}

/*!
    @brief          茋ʃt@C̋NuCommand Parametervo͏𐶐
*/
int CDMtrCntExtToolCreateCommandParameter(_OPTFLAGS *ptOptFlags)
{
    int iRet;
    int iFuncRet;
    _TCHAR *pcOpt;
    _TCHAR *pcParam;
    _TCHAR tcPerPbuf[16] = {0};
    iRet = RET_NG;
    pcOpt = NULL;
    pcParam = NULL;
    if (ptOptFlags->bOpt_ExecutionMode) {
        switch (iExecuteMode) {
        case ROW_MODE:
            pcOpt = OPTION_STR_EXECUTION_ROW;
            break;
        case DIFF_MODE:
            if (iDiffMode == OPTION_DIFF_FILE) {
                pcOpt = OPTION_STR_DIFF_FILE;
            } else if (iDiffMode == OPTION_DIFF_FUNC) {
                pcOpt = OPTION_STR_DIFF_FUNC;
            }
            break;
        case STRUCT_MODE:
            if (iStructMode == OPTION_STRUCT_STD) {
                pcOpt = OPTION_STR_STRUCT_STD;
            } else if (iStructMode == OPTION_STRUCT_SMP) {
                pcOpt = OPTION_STR_STRUCT_SMP;
            }
            break;
        case CK_MODE:
            pcOpt = OPTION_STR_EXECUTION_CK;
            break;
        default:
            goto FUNC_END;
            break;
        }
        if (pcOpt != NULL) {
            iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_MODE, OPTION_SEPARATE_HYPHEN, pcOpt, NULL);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
        }
    }
    if (ptOptFlags->bOpt_RESTYLE) {
        switch (giRestyleMode) {
        case RESTYLE_NONE:
            pcParam = RESTYLE_MODE_STR_NONE;
            break;
        case RESTYLE_STD:
            pcParam = RESTYLE_MODE_STR_STD;
            break;
        case RESTYLE_BOTH:
            pcParam = RESTYLE_MODE_STR_BOTH;
            break;
        default:
            goto FUNC_END;
            break;
        }
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_HYPHEN, OPTION_STR_RESTYLE, OPTION_SEPARATE_SPACE, pcParam, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    if (ptOptFlags->bOpt_F_OutputMode) {
        switch (iOutFileFormat) {
        case CSV_FORMAT:
            pcParam = OUT_FORMAT_STR_CSV;
            break;
        case XML_FORMAT:
            pcParam = OUT_FORMAT_STR_XML;
            break;
        default:
            goto FUNC_END;
            break;
        }
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_HYPHEN, OPTION_STR_F_OUTPUT_MODE, OPTION_SEPARATE_SPACE, pcParam,  NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    if (ptOptFlags->bOpt_Tfo_Outfile) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_HYPHEN, OPTION_STR_TFO_OUTFILE, OPTION_SEPARATE_SPACE, pcOutFileNameLogOut, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    if (ptOptFlags->bOpt_Tfp_Propfile) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_HYPHEN, OPTION_STR_TFP_PROPFILE, OPTION_SEPARATE_SPACE, pcProfFileNameLogOut, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    if (pcCharSet != NULL) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_HYPHEN, OPTION_STR_CHARSET, OPTION_SEPARATE_SPACE, pcCharSet, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    if (pcKnownOptsCmdBuf != NULL) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_SPACE, pcKnownOptsCmdBuf, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    if (gpcCompType != NULL) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_HYPHEN, OPTION_STR_TTC, OPTION_SEPARATE_SPACE, gpcCompType, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    if (pcQrc_option != NULL) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_HYPHEN, OPTION_STR_RESULT_CODE, OPTION_SEPARATE_SPACE, pcQrc_option, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    if (pcQlg_option != NULL) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_HYPHEN, OPTION_STR_LOG_CODE, OPTION_SEPARATE_SPACE, pcQlg_option, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    if (iShowDetails == DETAILS_SHOW) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_HYPHEN, OPTION_STR_V_SHOWDETAILS, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    if (giMoreDebug == DEBUG_ON) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_HYPHEN, OPTION_STR_LCDEBUG,  NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    if (iDebug == DEBUG_ON) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_HYPHEN, OPTION_STR_DEBUG,  NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    if (giPerformance != PERFORMANCE_OFF) {
        if (_itot_s(giPerformance, tcPerPbuf, 16, 10) == 0) {
            iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_HYPHEN, OPTION_STR_PERFORMANCE, OPTION_SEPARATE_SPACE, tcPerPbuf, NULL);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
        }
    }
    if (iSpsDebug == DEBUG_ON) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_HYPHEN, OPTION_STR_SPS_DEBUG,  NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    if (iShowHelp == HELP_SHOW) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_HYPHEN, OPTION_STR_HELP_USAGE, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}

/*!
    @brief          NKF DLL[h
*/
int CDMtrCntExtToolLoadNKFDLL(HINSTANCE *hDLL)
{
    int iRet = RET_NG;
    if (pcNkfDllPath == NULL) {
        CDMtrLibCmnErrLogOut(MSG_INVALID_DLL, ERR_LOG_ID_EC_00000187, pcNkfDllPath); //* MSG_LOG_ID_C_00000187
    } else {
        *hDLL = LoadLibrary(pcNkfDllPath);
        if (*hDLL != NULL) {
            glpfnDllFuncNKFSetOpt = (funcSetNkfOption)(GetProcAddress(*hDLL, NKFDLL_SETOPTION));
            if (glpfnDllFuncNKFSetOpt == NULL) {
                CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000188, GetLastError()); //* MSG_LOG_ID_C_00000188
            } else {
                glpfnDllFuncNKFConvert = (funcNkfConvert2SafeW)(GetProcAddress(*hDLL, NKFDLL_FILECONVERT2));
                if (glpfnDllFuncNKFConvert == NULL) {
                    CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000189, GetLastError()); //* MSG_LOG_ID_C_00000189
                } else {
                    iRet = RET_OK;
                }
            }
        } else {
            CDMtrLibCmnErrLogOut(MSG_INVALID_DLL, ERR_LOG_ID_EC_00000190, pcNkfDllPath); //* MSG_LOG_ID_C_00000190
        }
    }
    return iRet;
}

/*!
    @brief          NKF DLL
*/
void CDMtrCntExtToolFreeNKFDLL(HINSTANCE hDLL)
{
    BOOL iFuncRet = FALSE;
    if (hDLL != NULL) {
        iFuncRet = FreeLibrary(hDLL);
        if (iFuncRet == TRUE) {
            hDLL = NULL ;
        } else {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000191, GetLastError()); //* MSG_LOG_ID_C_00000191
        }
    } else {
    }
}

/*!
    @brief          NKFs
*/
int CDMtrCntExtToolDoNKFProcess(_TCHAR *psFilePath, _TCHAR *pcErrOutFile, _TCHAR *psNkfFileName, _TCHAR **ppsNkfFilePath)
{
    int iRet = RET_NG;
    int iFuncRet;
    _TCHAR *pcNkfFile = NULL;
    _TCHAR *pcCommand = NULL;
    if (psFilePath == NULL || pcErrOutFile == NULL || psNkfFileName == NULL || ppsNkfFilePath == NULL) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibUtilCreateStringW(&pcNkfFile, pcTempFolderName, FOLDER_SEPALATE, psNkfFileName, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    if (giProfileNKFEXESetting != CDMTR_TRUE) {
        glpfnDllFuncNKFSetOpt("-Lw -w80");
        iFuncRet = glpfnDllFuncNKFConvert(psFilePath, _tcslen(psFilePath) + 1, pcNkfFile, _tcslen(pcNkfFile) + 1);
        if (iFuncRet != TRUE) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000192, pcNkfDllPath); //* MSG_LOG_ID_C_00000192
            goto FUNC_END;
        }
    } else {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommand, pcNkfExe, _T(" "), _T("\""), psFilePath, _T("\""), NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        iFuncRet = CDMtrCntCallCreateProcess(NKF, pcCommand, pcNkfFile, pcErrOutFile, NULL);
        if (iFuncRet != RET_OK) {
            if (iDebug == DEBUG_ON) {
                CDMtrCntLogLogOutErrExec(pcErrOutFile);
            }
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000193, pcNkfExe); //* MSG_LOG_ID_C_00000193
            goto FUNC_END;
        }
    }
    *ppsNkfFilePath = pcNkfFile;
    iRet = RET_OK;
FUNC_END:
    if (iRet != RET_OK) {
        CDMtrLibUtilFreeW((void **)&pcNkfFile);
    }
    CDMtrLibUtilFreeW((void **)&pcCommand);
    return iRet;
}

/*!
    @brief          NKF̎s𔻒fKvȏꍇNKFs
*/
int CDMtrCntExtToolExecNkf(_TCHAR *pcFileName, int iKind, int iLangType, int iShortPathFlag, int iCharsetFlg, _TCHAR **ppcNkfFile, _TCHAR *pcErrOutFile)
{
    int iFuncRet = RET_NG;

    /** NKFs */
    if (CDMtrCntExtToolIsExecNkf(iLangType) && !iCharsetFlg) {
        iFuncRet = CDMtrCntExtToolDoNKFProcess(
                       pcFileName,
                       pcErrOutFile,
                       ((DIFF_BASE == iKind)
                        ? TEMP_FILE_NKF_BASE
                        : ((DIFF_DIST == iKind)
                           ? TEMP_FILE_NKF_DIST
                           : TEMP_FILE_NKF)
                       ),
                       ppcNkfFile
                   );
    } else {
        iFuncRet = CDMtrLibFileConvertAccessiblePathW(
                       pcFileName,
                       ((DIFF_BASE == iKind)
                        ? TEMP_FILE_BASE
                        : ((DIFF_DIST == iKind)
                           ? TEMP_FILE_DIST
                           : TEMP_FILE_SOURCE)
                       ),
                       pcTempFolderName,
                       iShortPathFlag,
                       ppcNkfFile
                   );
    }
    if (iFuncRet != RET_OK) {
        return RET_NG;
    }

    return RET_OK;
}

/*!
    @brief          \[XR[h`s
*/
int CDMtrCntExtToolExecBeautifier(int iKind, _TCHAR *pcLangName, _TCHAR **ppcFileName, _TCHAR *pcErrOutFile)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    _TCHAR *pcCommand = NULL;
    _TCHAR *pcBeautiFile = NULL;

    /** o͂t@C쐬 */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcBeautiFile,
                                         pcTempFolderName,
                                         FOLDER_SEPALATE,
                                         ((DIFF_BASE == iKind)
                                          ? TEMP_FILE_BEAUTIFILE_BASE
                                          : ((DIFF_DIST == iKind)
                                                  ? TEMP_FILE_BEAUTIFILE_DIST
                                                  : TEMP_FILE_BEAUTIFILE)
                                         ),
                                         NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** \[X`p̃R}h쐬 */
    iFuncRet = CDMtrCntExtToolCreateBeautifierCommand(&pcCommand, *ppcFileName, pcLangName);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** \[X`R}hs */
    iFuncRet = CDMtrCntCallCreateProcess(BEAUTIFIER, pcCommand, pcBeautiFile, pcErrOutFile, NULL);
    if (iFuncRet != RET_OK) {
        if (iDebug == DEBUG_ON) {
            CDMtrCntLogLogOutErrExec(pcErrOutFile);
        }
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000132, pcBeautifierExe); //* MSG_LOG_ID_C_00000132 (MSG_LOG_ID_C_00000140, MSG_LOG_ID_C_00000141, MSG_LOG_ID_C_00000150)
        goto FUNC_END;
    }

    CDMtrLibUtilFreeW((void **)ppcFileName);
    *ppcFileName = pcBeautiFile;
    pcBeautiFile = NULL;

    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcCommand);
    CDMtrLibUtilFreeW((void **)&pcBeautiFile);

    return iRet;
}
