/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <tchar.h>

#include "CDMtrCmn.h"
#include "CDMtrExtCmn.h"
#include "CDMtrLibCmnW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrLibSystemW.h"
#include "CDMtrCntMain.h"
#include "CDMtrCntLog.h"
#include "CDMtrCntOutputXML.h"
#include "CDMtrMessage.h"

/*----------------------------------------------------------------------------*/
/* static function declaration                                                */
/*----------------------------------------------------------------------------*/
static void cdmtrCntLogVaPrintDebugInfos(int iFlg, const _TCHAR *format, ...);

/*----------------------------------------------------------------------------*/
/* global function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief          Oc[sG[̃Oo͂
*/
void CDMtrCntLogLogOutErrExec(const _TCHAR *pcFileName)
{
    if (pcFileName == NULL) {
        goto FUNC_END;
    }
    CDMtrLibCmnLogOut(_T("\n")); //* MSG_LOG_ID_C_00000294
    CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000295); //* MSG_LOG_ID_C_00000295
    CDMtrCntMainShowFile(pcFileName);
    CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000296); //* MSG_LOG_ID_C_00000296
    CDMtrLibCmnLogOut(_T("\n")); //* MSG_LOG_ID_C_00000297
FUNC_END:
    return;
}

/*!
    @brief      Oo͗pZbgOɏo͂
*/
void CDMtrCntLogPrintLogCharset(_SysLocale *ptSysLocale)
{
    _TCHAR *cpTmp = NULL;
    int isInvalidLog = CDMTR_FALSE;
    if (0 == _tcscmp(ENCODING_SYSTEM, pcLogCodeOpts)) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000300, ptSysLocale->pcSysANSICodePage); //* MSG_LOG_ID_C_00000300
    } else {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000301, pcLogCodeOpts); //* MSG_LOG_ID_C_00000301
    }
    if (pcQlg_option != NULL) {
        cpTmp = CDMtrLibUtilCheckOutputCharsetW(pcQlg_option);
        if (NULL != cpTmp) {
            goto FUNC_END;
        } else {
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000302); //* MSG_LOG_ID_C_00000302
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000303, pcQlg_option); //* MSG_LOG_ID_C_00000303
            isInvalidLog = CDMTR_TRUE;
        }
    }
    if (pcCharsetOutLog_prop != NULL) {
        CDMtrLibUtilFreeW((void **)&cpTmp);
        cpTmp = CDMtrLibUtilCheckOutputCharsetW(pcCharsetOutLog_prop);
        if (NULL != cpTmp) {
            goto FUNC_END;
        } else {
            if (CDMTR_TRUE != isInvalidLog) {
                CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000304); //* MSG_LOG_ID_C_00000304
            }
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000305, pcCharsetOutLog_prop); //* MSG_LOG_ID_C_00000305
        }
    }
FUNC_END:
    CDMtrLibUtilFreeW((void **)&cpTmp);
    return;
}

/*!
    @brief      CSV`茋ʃt@CpZbgOɏo͂
*/
void CDMtrCntLogPrintCsvOutCharset(_SysLocale *ptSysLocale)
{
    _TCHAR *cpTmp = NULL;
    int isInvalidLog = CDMTR_FALSE;
    if (0 == _tcscmp(ENCODING_SYSTEM, pcResultCodeOpts)) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000306, ptSysLocale->pcSysANSICodePage); //* MSG_LOG_ID_C_00000306
    } else {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000307, pcResultCodeOpts); //* MSG_LOG_ID_C_00000307
    }
    if (pcQrc_option != NULL) {
        cpTmp = CDMtrLibUtilCheckOutputCharsetW(pcQrc_option);
        if (NULL != cpTmp) {
            goto FUNC_END;
        } else {
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000308); //* MSG_LOG_ID_C_00000308
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000309, pcQrc_option); //* MSG_LOG_ID_C_00000309
            isInvalidLog = CDMTR_TRUE;
        }
    }
    if (pcCharsetOutCsv_prop != NULL) {
        CDMtrLibUtilFreeW((void **)&cpTmp);
        cpTmp = CDMtrLibUtilCheckOutputCharsetW(pcCharsetOutCsv_prop);
        if (NULL != cpTmp) {
            goto FUNC_END;
        } else {
            if (CDMTR_TRUE != isInvalidLog) {
                CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000310); //* MSG_LOG_ID_C_00000310
            }
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000311, pcCharsetOutCsv_prop); //* MSG_LOG_ID_C_00000311
        }
    }
FUNC_END:
    CDMtrLibUtilFreeW((void **)&cpTmp);
    return;
}

/*!
    @brief      so͂
*/
void CDMtrCntLogPrintDebugInfos(int iFlg, _SysLocale *ptSysLocale)
{
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000313); //* MSG_LOG_ID_C_00000313
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000314, iExecuteMode); //* MSG_LOG_ID_C_00000314
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000315); //* MSG_LOG_ID_C_00000315
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000316, iOutFileFormat); //* MSG_LOG_ID_C_00000316
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000317); //* MSG_LOG_ID_C_00000317
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000318, pcOutFileNameLogOut); //* MSG_LOG_ID_C_00000318
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000319, pcProfFileNameLogOut); //* MSG_LOG_ID_C_00000319
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000320, pcKnownOpts); //* MSG_LOG_ID_C_00000320
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000321, giOutFileAdd); //* MSG_LOG_ID_C_00000321
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000322); //* MSG_LOG_ID_C_00000322
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000323, giOutHeaderFlg); //* MSG_LOG_ID_C_00000323
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000324, giOutFooterFlg); //* MSG_LOG_ID_C_00000324
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000325, pcObjectName); //* MSG_LOG_ID_C_00000325
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000326, pcTempFolderName); //* MSG_LOG_ID_C_00000326
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000327, pcMacroAnalizerPath); //* MSG_LOG_ID_C_00000327
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000328, pcSedToolPath); //* MSG_LOG_ID_C_00000328
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000329, pcDiffPath); //* MSG_LOG_ID_C_00000329
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000330, pcStructPath); //* MSG_LOG_ID_C_00000330
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000331, pcStructSmpPath); //* MSG_LOG_ID_C_00000331
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000332, pcStructJAVAPath); //* MSG_LOG_ID_C_00000332
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000333, pcStructCSPath); //* MSG_LOG_ID_C_00000333
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000334, pcStructVBPath); //* MSG_LOG_ID_C_00000334
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000335, pcStructJSPath); //* MSG_LOG_ID_C_00000335
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000336, pcCkJAVAPath); //* MSG_LOG_ID_C_00000336
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000337, pcHelpPath);			//* MSG_LOG_ID_C_00000337
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000338, pcProcessID); //* MSG_LOG_ID_C_00000338
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000339, gpcCompType); //* MSG_LOG_ID_C_00000339
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000340, gpcCompOpt); //* MSG_LOG_ID_C_00000340
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000341, gpcSysInc); //* MSG_LOG_ID_C_00000341
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000343, pcResultCodeOpts); //* MSG_LOG_ID_C_00000343
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000344, pcLogCodeOpts); //* MSG_LOG_ID_C_00000344
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000345, ptSysLocale->pcUserLang); //* MSG_LOG_ID_C_00000345
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000346, ptSysLocale->pcUserCountry); //* MSG_LOG_ID_C_00000346
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000347, ptSysLocale->pcUserOEMCodePage); //* MSG_LOG_ID_C_00000347
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000348, ptSysLocale->pcUserANSICodePage); //* MSG_LOG_ID_C_00000348
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000349, ptSysLocale->pcUserDispLang); //* MSG_LOG_ID_C_00000349
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000350, ptSysLocale->pcSysLang); //* MSG_LOG_ID_C_00000350
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000351, ptSysLocale->pcSysCountry); //* MSG_LOG_ID_C_00000351
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000352, ptSysLocale->pcSysOEMCodePage); //* MSG_LOG_ID_C_00000352
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000353, ptSysLocale->pcSysANSICodePage); //* MSG_LOG_ID_C_00000353
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000354, ptSysLocale->pcSysDispLang); //* MSG_LOG_ID_C_00000354
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000355, pcProfFileNameLogOut); //* MSG_LOG_ID_C_00000355
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000356, pcDoc); //* MSG_LOG_ID_C_00000356
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000357, pcDef); //* MSG_LOG_ID_C_00000357
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000358, pcParse); //* MSG_LOG_ID_C_00000358
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000359, pcSkip); //* MSG_LOG_ID_C_00000359
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000360, pcNkf); //* MSG_LOG_ID_C_00000360
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000361, pcNkfExe); //* MSG_LOG_ID_C_00000361
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000362, giProfileNKFEXESetting); //* MSG_LOG_ID_C_00000362
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000363, pcBeautifier); //* MSG_LOG_ID_C_00000363
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000364, pcBeautifierExe); //* MSG_LOG_ID_C_00000364
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000365, pcJAVAExe); //* MSG_LOG_ID_C_00000365
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000366, gpcOutputFormat); //* MSG_LOG_ID_C_00000366
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000367, pcDiffOpMode); //* MSG_LOG_ID_C_00000367
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000368, pcDiffBlank); //* MSG_LOG_ID_C_00000368
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000369, pcDiffCountMode); //* MSG_LOG_ID_C_00000369
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000370, pcExceptBinary); //* MSG_LOG_ID_C_00000370
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000371, pcFuncOpt); //* MSG_LOG_ID_C_00000371
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000372, gpcCompTypeForC); //* MSG_LOG_ID_C_00000372
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000373, gpcCompTypeForJava); //* MSG_LOG_ID_C_00000373
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000374, gpcSysInc); //* MSG_LOG_ID_C_00000374
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000375, pcCmntCase); //* MSG_LOG_ID_C_00000375
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000376, pcStmtMode); //* MSG_LOG_ID_C_00000376
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000377, giFANIOMode); //* MSG_LOG_ID_C_00000377
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000378, pcResultCodeOpts); //* MSG_LOG_ID_C_00000378
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000379, pcLogCodeOpts); //* MSG_LOG_ID_C_00000379
    cdmtrCntLogVaPrintDebugInfos(iFlg, MSG_LOG_ID_C_00000380, iNestsCount); //* MSG_LOG_ID_C_00000380
    return ;
}

/*----------------------------------------------------------------------------*/
/* static function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief          so͂
*/
static void cdmtrCntLogVaPrintDebugInfos(int iFlg, const _TCHAR *format, ...)
{
    va_list list;
    int wLength = 0;
    int wBufSize = 0;
    wchar_t *wcBuf = NULL;
    char *cBuf = NULL;
    int iFuncRet = RET_NG;
    va_start(list, format);
    wLength = _vscwprintf(format, list);
    wBufSize = (wLength + 1) * sizeof(wchar_t);
    wcBuf = (wchar_t *)malloc(wBufSize);
    if (NULL == wcBuf) {
        goto FUNC_END;
    }
    memset(wcBuf, 0x00, wBufSize);
    vswprintf(wcBuf, wBufSize, format, list);
    switch (iFlg) {
    case DEBUG_PRINT_CSV:
        iFuncRet = CDMtrLibUtilUNICODEtoMBCSW(&cBuf, &wcBuf, pcResultCodeOpts);
        if (iFuncRet == RET_NG) {
            goto FUNC_END;
        }
        fputs(cBuf, spcOutFile);
        break;
    case DEBUG_PRINT_XML:
        CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_PEAR_STRING, TAG_OUTLINE, NCM_DEBUG_INFO_TAG_NAME, wcBuf);
        break;
    case DEBUG_PRINT_LOG:
    default:
        CDMtrLibCmnLogOut(wcBuf); //* MSG_LOG_ID_C_00000312
        break;
    }
    va_end(list);
FUNC_END:
    if (cBuf != NULL) {
        free((void *)cBuf);
    }
    if (wcBuf != NULL) {
        free((void *)wcBuf);
    }
    return;
}
