/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <tchar.h>

#include "CDMtrCmn.h"
#include "CDMtrExtCmn.h"
#include "CDMtrLibCmnW.h"
#include "CDMtrLibFileW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrLibSystemW.h"
#include "CDMtrLibOptW.h"
#include "CDMtrCntMain.h"
#include "CDMtrCntFunc.h"
#include "CDMtrCntLang.h"
#include "CDMtrCntOutputCSV.h"
#include "CDMtrCntLog.h"
#include "CDMtrCntOutputXML.h"
#include "CDMtrCntStructure.h"
#include "CDMtrMessage.h"

/*----------------------------------------------------------------------------*/
/* define                                                                     */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* structure definition                                                       */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* global variable declaration                                                */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* static variable declaration                                                */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* static function  declaration                                               */
/*----------------------------------------------------------------------------*/
static int cdmtrCntOutputCSVStructFileToOutCSVFile(_TCHAR *pBuffer, int nLineSize);
static _TCHAR *cdmtrCntOutputCSVGetNextCsvToken(_TCHAR **strToken, int tokenMax, const _TCHAR *strCsvLineData, int nEofFlg);
static int cdmtrCntOutputCSVCreateFilename(const _TCHAR *pcBaseName, const _TCHAR *pcDistName, const _TCHAR *pcResStatus, RESULTINFO_FILEITEMS *tOutputFileItems);
static int cdmtrCntOutputCSVOutputBasicLineCount(RESULTINFO_FILEITEMS *ptFileItems, RESULTINFO_ITEMS *ptItems, _LINECOUNT *ptCountLines, int iFuncMatchStatus);
static int cdmtrCntOutputCSVOutputLineChangeCount(RESULTINFO_FILEITEMS *ptFileItems, RESULTINFO_ITEMS *ptItems, _DIFFLINES *ptDiffLines, int iInvalidFlg);

/*----------------------------------------------------------------------------*/
/* global function declaration                                                */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* global function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief      茋ʂɋ󔒍so͂(CSV)
*/
int CDMtrCntOutputCSVWriteBlank(void)
{
    int iRet = RET_NG;
    if (spcOutFile != NULL) {
        _fputts(_T("\n"), spcOutFile);
        iRet = RET_OK;
    }
    return iRet;
}

/*!
    @brief      茋ʂɃwb_[o͂(CSV)
*/
int CDMtrCntOutputCSVWriteHeader(void)
{
    int iRet = RET_NG;
    _TCHAR *pcExecuteMode;
    if (spcOutFile == NULL) {
        iRet = RET_NG;
        goto FUNC_END;
    }

    if (giOutFileAdd) {
        CDMtrCntOutputCSVWriteBlank();
    }
    switch (iExecuteMode) {
    case ROW_MODE:
        pcExecuteMode = EXEC_ROW_MODE;
        break;
    case DIFF_MODE:
        if (iDiffMode == OPTION_DIFF_FUNC) {
            pcExecuteMode = EXEC_DIFF_FUNC_MODE;
        } else {
            pcExecuteMode = EXEC_DIFF_FILE_MODE;
        }
        break;
    case STRUCT_MODE:
        if (iStructMode == OPTION_STRUCT_STD) {
            pcExecuteMode = EXEC_STRUCT_STD_MODE;
        } else {
            pcExecuteMode = EXEC_STRUCT_SMP_MODE;
        }
        break;
    case CK_MODE:
        pcExecuteMode = EXEC_CK_MODE;
        break;
    default:
        goto FUNC_END;
        break;
    }
    _fputts(OUTPUT_EXECUTE_MODE, spcOutFile);
    if (iExecuteMode == STRUCT_MODE) {
        if (_tcscmp(pcExecuteMode, EXEC_STRUCT_STD_MODE) == 0) {
            _fputts(_T("STRUCT,STANDARD"), spcOutFile);
        } else {
            _fputts(_T("STRUCT,SIMPLE"), spcOutFile);
        }
    } else if (iExecuteMode == DIFF_MODE) {
        if (iDiffModeDetailOut != CDMTR_TRUE) {
            _fputts(_T("DIFF"), spcOutFile);
        } else {
            if (_tcscmp(pcExecuteMode, EXEC_DIFF_FUNC_MODE) == 0) {
                _fputts(_T("DIFF,FUNC"), spcOutFile);
            } else {
                _fputts(_T("DIFF,FILE"), spcOutFile);
            }
        }
    } else {
        _fputts(pcExecuteMode, spcOutFile);
    }
    _fputts(_T("\n"), spcOutFile);
    if (iExecuteMode == CK_MODE) {
        _fputts(OUTPUT_CK_HEADER, spcOutFile);
    } else if (iExecuteMode != STRUCT_MODE) {
        if (giDiffCountMode == DIFF_COUNT_EXT) {
            if (_tcscmp(pcDef, _T("true")) == 0) {
                if (_tcscmp(pcBeautifier, _T("true")) == 0) {
                    _fputts(OUTPUT_ROW_B_HEADER_RLOC_M, spcOutFile);
                } else {
                    _fputts(OUTPUT_ROW_B_HEADER_PLOC_M, spcOutFile);
                }
            } else {
                if (_tcscmp(pcBeautifier, _T("true")) == 0) {
                    _fputts(OUTPUT_ROW_B_HEADER_RLOC, spcOutFile);
                } else {
                    _fputts(OUTPUT_ROW_B_HEADER_PLOC, spcOutFile);
                }
            }
        } else {
            if (_tcscmp(pcDef, _T("true")) == 0) {
                if (_tcscmp(pcBeautifier, _T("true")) == 0) {
                    _fputts(OUTPUT_ROW_HEADER_RLOC_M, spcOutFile);
                } else {
                    _fputts(OUTPUT_ROW_HEADER_PLOC_M, spcOutFile);
                }
            } else {
                if (_tcscmp(pcBeautifier, _T("true")) == 0) {
                    _fputts(OUTPUT_ROW_HEADER_RLOC, spcOutFile);
                } else {
                    _fputts(OUTPUT_ROW_HEADER_PLOC, spcOutFile);
                }
            }
        }
    } else {
        if (_tcscmp(pcBeautifier, _T("true")) == 0) {
            _fputts(OUTPUT_STRUCT_HEADER_RLOC, spcOutFile);
        } else {
            _fputts(OUTPUT_STRUCT_HEADER_PLOC, spcOutFile);
        }
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}

/*!
    @brief      茋ʂɋNƏIo͂(CSV)
*/
int CDMtrCntOutputCSVWriteInfomation(_SysLocale *ptSysLocal)
{
    int iRet = RET_NG;
    int iFuncRet;
    _TCHAR *cNum = NULL;
    int iBufLength = 0;
    char *cBuffer = NULL;
    if (spcOutFile == NULL) {
        goto FUNC_END;
    }
    _fputts(_T("\n"), spcOutFile);
    _fputts(OUTPUT_TOOL_NAME, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(pcObjectName, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(_T("\n"), spcOutFile);
    _fputts(OUTPUT_VERSION, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(TOOL_VER, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(_T("\n"), spcOutFile);
    _fputts(OUTPUT_START_DATE, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(pcStartDate, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(_T("\n"), spcOutFile);
    _fputts(OUTPUT_END_DATE, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(pcEndDate, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(_T("\n"), spcOutFile);
    _fputts(OUTPUT_COMMAND_PARAM, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    cBuffer = CDMtrLibUtilConvertStringW(pcResultCodeOpts, _T("%s"), pcCommandOptions);
    if (cBuffer != NULL) {
        fputs(cBuffer, spcOutFile);
    }
    CDMtrLibCmnFree((void **)&cBuffer);
    if (pcCommandOptions_MODE != NULL) {
        _fputts(pcCommandOptions_MODE, spcOutFile);
    }
    cBuffer = CDMtrLibUtilConvertStringW(pcResultCodeOpts, _T("%s"), pcCommandOptions_OTHER);
    if (cBuffer != NULL) {
        fputs(cBuffer, spcOutFile);
    }
    CDMtrLibCmnFree((void **)&cBuffer);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(_T("\n"), spcOutFile);
    _fputts(OUTPUT_PROP_NAME, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    if (iProfileFlag == CDMTR_TRUE) {
        if (pcProfFileNameLogOut != NULL) {
            cBuffer = CDMtrLibUtilConvertStringW(pcResultCodeOpts, _T("%s"), pcProfFileNameLogOut);
            if (cBuffer != NULL) {
                fputs(cBuffer, spcOutFile);
            }
            CDMtrLibCmnFree((void **)&cBuffer);
        }
    }
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(_T("\n"), spcOutFile);
    _fputts(OUTPUT_STYLE, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    switch (giRestyleMode) {
    case RESTYLE_BOTH:
        _fputts(OUTPUT_STYLE_BOTH, spcOutFile);
        break;
    case RESTYLE_STD:
        _fputts(OUTPUT_STYLE_STD, spcOutFile);
        break;
    case RESTYLE_NONE:
    default:
        _fputts(OUTPUT_STYLE_NONE, spcOutFile);
        break;
    }
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(_T("\n"), spcOutFile);
    _fputts(OUTPUT_CNT_DOC, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    if (pcDoc != NULL) {
        _fputts(pcDoc, spcOutFile);
    }
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(_T("\n"), spcOutFile);
    _fputts(OUTPUT_CNT_UNDEF, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    if (pcDef != NULL) {
        _fputts(pcDef, spcOutFile);
    }
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(_T("\n"), spcOutFile);
    _fputts(OUTPUT_CNT_SKIP, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    if (pcSkip != NULL) {
        CDMtrLibUtilToupperW(pcSkip);
        _fputts(pcSkip, spcOutFile);
    }
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(_T("\n"), spcOutFile);
    _fputts(OUTPUT_DIFF_BLANK, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    if (giDiffBlankFlg) {
        _fputts(CNT_STR_TRUE, spcOutFile);
    } else {
        _fputts(CNT_STR_FALSE, spcOutFile);
    }
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(_T("\n"), spcOutFile);
    _fputts(OUTPUT_DIFF_COUNT_MODE, spcOutFile);
    _fputts(DOUBLEQUOTATION, spcOutFile);
    if (giDiffCountMode == DIFF_COUNT_EXT) {
        _fputts(CNT_STR_EXT, spcOutFile);
    } else {
        _fputts(CNT_STR_STD, spcOutFile);
    }
    _fputts(DOUBLEQUOTATION, spcOutFile);
    _fputts(_T("\n"), spcOutFile);
    _fputts(_T("\n"), spcOutFile);
    _fputts(OUTPUT_FILE_TOTAL, spcOutFile);
    if (giOutFileAdd) {
        _fputts(OUTPUT_NOT_TARGET, spcOutFile);
    } else {
        iBufLength = (CDMtrLibUtilGetNumSizeW(iNumOfFiles) + 1);
        iFuncRet = CDMtrLibUtilMallocW((void **)&cNum, iBufLength * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        swprintf_s(cNum, iBufLength, _T("%d"), iNumOfFiles);
        _fputts(cNum, spcOutFile);
        CDMtrLibUtilFreeW((void **)&cNum);
    }
    _fputts(_T("\n"), spcOutFile);
    _fputts(OUTPUT_FILE_SUCCESS, spcOutFile);
    if (giOutFileAdd) {
        _fputts(OUTPUT_NOT_TARGET, spcOutFile);
    } else {
        iBufLength = (CDMtrLibUtilGetNumSizeW(iNumOfSuccess) + 1);
        iFuncRet = CDMtrLibUtilMallocW((void **)&cNum, iBufLength * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        swprintf_s(cNum, iBufLength, _T("%d"), iNumOfSuccess);
        _fputts(cNum, spcOutFile);
        CDMtrLibUtilFreeW((void **)&cNum);
    }
    _fputts(_T("\n"), spcOutFile);
    _fputts(OUTPUT_FILE_ERROR, spcOutFile);
    if (giOutFileAdd) {
        _fputts(OUTPUT_NOT_TARGET, spcOutFile);
    } else {
        iBufLength = (CDMtrLibUtilGetNumSizeW(iNumOfFiles - iNumOfSuccess) + 1);
        iFuncRet = CDMtrLibUtilMallocW((void **)&cNum, iBufLength * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        swprintf_s(cNum, iBufLength, _T("%d"), (iNumOfFiles - iNumOfSuccess));
        _fputts(cNum, spcOutFile);
        CDMtrLibUtilFreeW((void **)&cNum);
    }
    _fputts(_T("\n"), spcOutFile);
    if (pcNcmDebugProp) {
        _fputts(_T("\n"), spcOutFile);
        CDMtrCntLogPrintDebugInfos(DEBUG_PRINT_CSV, ptSysLocal);
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}

/*!
    @brief          {s/s̑茋ʂo͂
*/
int CDMtrCntOutputCSVCountFileToOutFile(const _TCHAR *pcDistName, const _TCHAR *pcBaseName, const _TCHAR *pcFuncName, const _TCHAR *pcLangName, long *plStmt, _LINECOUNT *ptCountLines, _DIFFLINES *ptDiffLines, const _TCHAR *pcResStatus, int iFuncMatchStatus)
{
    int iRet = RET_OK;
    int iFuncRet = RET_NG;
    int iLangType = LANG_TYPE_UNKNOW;           // 
    int iInvalidFlg_BaseLC = CDMTR_FALSE;       // {sgNXo͌tO
    int iInvalidFlg_ChangeLC = CDMTR_FALSE;     // sgNXo͌tO
    RESULTINFO_FILEITEMS tOutputFileItems;      // o͗pΏۃt@C
    RESULTINFO_ITEMS tOutputItems;              // o͗p

    memset(&tOutputFileItems, 0x00, sizeof(RESULTINFO_FILEITEMS));
    memset(&tOutputItems, 0x00, sizeof(RESULTINFO_ITEMS));

    if (spcOutFile == NULL) {
        goto FUNC_END;
    }

    /* ʂ擾 */
    iLangType = CDMtrCntLangGetTypeFromLangName(pcLangName);

    /** o͗pΏۃt@Cݒ肷 */
    iFuncRet = cdmtrCntOutputCSVCreateFilename(pcBaseName, pcDistName, pcResStatus, &tOutputFileItems);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /* o͗pݒ肷 */
    tOutputItems.pcFUNC = pcFuncName;
    tOutputItems.pcLANG = pcLangName;
    tOutputItems.iLangType = iLangType;
    tOutputItems.pcSTATE = pcResStatus;
    tOutputItems.plSTMT = plStmt;

    /*tOݒ肷 */
    if (iDiffMode == OPTION_DIFF_FUNC) {
        switch (iFuncMatchStatus) {
        case FUNC_INVALID:
        case FUNC_INVALID_DEL:
        case FUNC_INVALID_ADD:
            iInvalidFlg_ChangeLC = CDMTR_TRUE;  // sgNXo͌tOON
        /* FALLTHROUGH */
        case FUNC_DEL:
        case FUNC_DEL_VS_INVALID:
        case FUNC_DEL_VS_NONE:
            iInvalidFlg_BaseLC = CDMTR_TRUE;    // {sgNXo͌tOON
            break;
        default:
            break;
        }
    }

    if (iOutFileFormat == CSV_FORMAT) {
        /** Ώۃt@CƊ{sgNXo͂ */
        iFuncRet = cdmtrCntOutputCSVOutputBasicLineCount(&tOutputFileItems, &tOutputItems, ptCountLines, iInvalidFlg_BaseLC);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        /** sgNXo͂ */
        iFuncRet = cdmtrCntOutputCSVOutputLineChangeCount(&tOutputFileItems, &tOutputItems, ptDiffLines, iInvalidFlg_ChangeLC);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    } else {
        /** Ώۃt@CƊ{sgNXo͂(XML) */
        iFuncRet = CDMtrCntOutputXMLOutputBasicLineCount(&tOutputFileItems, &tOutputItems, ptCountLines, iInvalidFlg_BaseLC);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        /** sgNXo͂(XML) */
        iFuncRet = CDMtrCntOutputXMLOutputLineChangeCount(&tOutputFileItems, &tOutputItems, ptDiffLines, iInvalidFlg_ChangeLC);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **) & (tOutputFileItems.pcDIR));
    CDMtrLibUtilFreeW((void **) & (tOutputFileItems.pcFILE));
    CDMtrLibUtilFreeW((void **) & (tOutputFileItems.pcOLDDIR));
    CDMtrLibUtilFreeW((void **) & (tOutputFileItems.pcOLDFILE));
    return iRet;
}

/*!
    @brief          \gNX̑茋ʂo͂
*/
int CDMtrCntOutputCSVStructFileToOutFile(_TCHAR *pcInName, int iLangType)
{
    int iRet = RET_NG;
    int iFuncRet;
    FILE *fpIn = NULL;
    _TCHAR *tReadBuffer = NULL;
    _TCHAR *pcRet = NULL;
    long lSize;
    int iLineCount = 0;
    _TCHAR *p;
    _TCHAR *csvDir = NULL;
    _TCHAR *csvFile = NULL;
    _TCHAR *csvName = NULL;
    _TCHAR *csvLang = NULL;
    int iLen = 0;
    int i = 0;
    int iErrorResult = CDMTR_FALSE;
    char *cOutBuffer = NULL;
    int bomOffset = 0;
    if (spcOutFile == NULL) {
        goto FUNC_END;
    }
    if ((fpIn = _tfopen(pcInName, _T("r, ccs=UTF-8"))) == NULL) {
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000381, pcInName); //* MSG_LOG_ID_C_00000381
        goto FUNC_END;
    }
    bomOffset = ftell(fpIn);
    if (fseek(fpIn, 0L, SEEK_END) != 0) {
        goto FUNC_END;
    }
    lSize = ftell(fpIn);
    if (lSize <= 0) {
        goto FUNC_END;
    }
    lSize++;
    if (fseek(fpIn, bomOffset, SEEK_SET) != 0) {
        goto FUNC_END;
    }
    lSize += 6 * 8;
    iFuncRet = CDMtrLibUtilMallocW((void **)&tReadBuffer, (lSize + 1) * sizeof(_TCHAR));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    while (1) {
        pcRet = _fgetts(tReadBuffer, (int)lSize, fpIn);
        if (pcRet == NULL) {
            break;
        }
        iLen = _tcslen(tReadBuffer);
        for (i = 1; i <= 3; i++) {
            if (iLen > i && tReadBuffer[iLen - i] == MEASUREMENT_ERROR_OUTPUT) {
                iErrorResult = CDMTR_TRUE;
                break;
            }
        }
        if (iErrorResult == CDMTR_TRUE) {
            if (iOutFileFormat == XML_FORMAT) {
                cdmtrCntOutputCSVGetNextCsvToken(&csvDir, (int)lSize, tReadBuffer, CDMTR_FALSE);
                if (csvDir == NULL) {
                    CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000169); //* MSG_LOG_ID_C_00000169
                    goto FUNC_END;
                }
                cdmtrCntOutputCSVGetNextCsvToken(&csvFile, (int)lSize, NULL, CDMTR_FALSE);
                if (csvFile == NULL) {
                    CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000170); //* MSG_LOG_ID_C_00000170
                    goto FUNC_END;
                }
                cdmtrCntOutputCSVGetNextCsvToken(&csvName, (int)lSize, NULL, CDMTR_FALSE);
                if (csvName == NULL) {
                    CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000171); //* MSG_LOG_ID_C_00000171
                    goto FUNC_END;
                }
                cdmtrCntOutputCSVGetNextCsvToken(&csvLang, (int)lSize, NULL, CDMTR_FALSE);
                if (csvLang == NULL) {
                    CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000172, csvName); //* MSG_LOG_ID_C_00000172
                    goto FUNC_END;
                }
                CDMtrCntOutputXMLStructFileToFanOutXMLFile(csvDir, csvFile, csvLang);
            } else {
                iFuncRet = CDMtrLibUtilUNICODEtoMBCSW(&cOutBuffer, &tReadBuffer, pcResultCodeOpts);
                if (iFuncRet != RET_OK) {
                    goto FUNC_END;
                }
                if (cOutBuffer != NULL) {
                    fputs(cOutBuffer, spcOutFile);
                    CDMtrLibUtilFreeW((void **)&cOutBuffer);
                }
            }
        } else {
            if (giFANIOMode != CDMTR_TRUE || iStructMode != OPTION_STRUCT_STD) {
                p = _tcschr(tReadBuffer, _T('\n'));
                if (p != NULL) {
                    *p = _T('\0');
                }
                _tcscat(tReadBuffer, _T(",-,-,-,-,-,-,-,-\n"));
            }
            iFuncRet = CDMtrCntStructureStructRecordCheckAndMod(tReadBuffer);
            if (iFuncRet != RET_OK) {
                CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000173); //* MSG_LOG_ID_C_00000173
                goto FUNC_END;
            }
            if (iOutFileFormat == CSV_FORMAT) {
                cdmtrCntOutputCSVStructFileToOutCSVFile(tReadBuffer, (int)lSize);
            } else if (iOutFileFormat == XML_FORMAT) {
                CDMtrCntOutputXMLStructFileToOutXMLFile(tReadBuffer);
            } else {
                cdmtrCntOutputCSVStructFileToOutCSVFile(tReadBuffer, (int)lSize);
            }
        }
        CDMtrLibUtilFreeW((void **)&csvDir);
        CDMtrLibUtilFreeW((void **)&csvFile);
        CDMtrLibUtilFreeW((void **)&csvName);
        CDMtrLibUtilFreeW((void **)&csvLang);
        iErrorResult = CDMTR_FALSE;
        iLineCount++;
    }
    iRet = RET_OK;
FUNC_END:
    if (fpIn) {
        fclose(fpIn);
        fpIn = NULL;
    }
    CDMtrLibUtilFreeW((void **)&csvDir);
    CDMtrLibUtilFreeW((void **)&csvFile);
    CDMtrLibUtilFreeW((void **)&csvName);
    CDMtrLibUtilFreeW((void **)&csvLang);
    if (tReadBuffer != NULL) {
        CDMtrLibUtilFreeW((void **)&tReadBuffer);
    }
    return iRet;
}

/*!
    @brief          CKgNX̑茋ʂo͂
*/
int CDMtrCntOutputCSVCkFileToOutFile(_TCHAR *pcInName)
{
    int iRet = RET_NG;
    int iFuncRet;
    FILE *fpIn = NULL;
    _TCHAR *pcReadBuffer = NULL;
    _TCHAR *pcToken = NULL;
    _TCHAR *pcRet = NULL;
    long lSize;
    _TCHAR chNumofFiles[MAX_PATH];
    _TCHAR chNumofSucess[MAX_PATH];
    long lNum = 0;
    _TCHAR *e = NULL;
    int bomOffset = 0;
    char *cOutBuffer = NULL;
    if ((spcOutFile == NULL) || (pcInName == NULL)) {
        goto FUNC_END;;
    }
    memset(chNumofFiles, 0x00, sizeof(_TCHAR) * MAX_PATH);
    memset(chNumofSucess, 0x00, sizeof(_TCHAR) * MAX_PATH);
    if ((fpIn = _tfopen(pcInName, _T("r, ccs=UTF-8"))) == NULL) {
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000382, pcInName); //* MSG_LOG_ID_C_00000382
        goto FUNC_END;
    }
    bomOffset = ftell(fpIn);
    if (fseek(fpIn, 0L, SEEK_END) != 0) {
        goto FUNC_END;
    }
    lSize = ftell(fpIn);
    if (lSize <= 0) {
        goto FUNC_END;
    }
    lSize++;
    if (fseek(fpIn, bomOffset, SEEK_SET) != 0) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibUtilMallocW((void **)&pcReadBuffer, (lSize + 1) * sizeof(_TCHAR));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    pcRet = _fgetts(pcReadBuffer, (int)lSize, fpIn);
    if (pcRet == NULL) {
        goto FUNC_END;
    }
    pcToken = _tcstok(pcReadBuffer, _T(","));
    if ((pcToken == NULL) || (_tcslen(pcToken) >= MAX_PATH)) {
        goto FUNC_END;
    }
    _tcsncpy(chNumofFiles, pcToken, _tcslen(pcToken));
    pcToken = _tcstok(NULL, _T(","));
    if ((pcToken == NULL) || (_tcslen(pcToken) >= MAX_PATH)) {
        goto FUNC_END;
    }
    _tcsncpy(chNumofSucess, pcToken, _tcslen(pcToken));
    lNum = _tcstol(chNumofFiles, &e, 10);
    if (errno != ERANGE) {
        if (*e != _T('\0')) {
            CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000383, e); //* MSG_LOG_ID_C_00000383
            goto FUNC_END;
        } else {
            iNumOfFiles = (long)lNum;
        }
    } else {
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000384); //* MSG_LOG_ID_C_00000384
        goto FUNC_END;
    }
    lNum = _tcstol(chNumofSucess, &e, 10);
    if (errno != ERANGE) {
        if (*e != _T('\0')) {
            CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000385, e); //* MSG_LOG_ID_C_00000385
            goto FUNC_END;
        } else {
            iNumOfSuccess = (long)lNum;
        }
    } else {
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000386); //* MSG_LOG_ID_C_00000386
        goto FUNC_END;
    }
    while (1) {
        pcRet = _fgetts(pcReadBuffer, (int)lSize, fpIn);
        if (pcRet == NULL) {
            break;
        }
        if (iOutFileFormat == CSV_FORMAT) {
            cOutBuffer = CDMtrLibUtilConvertStringW (pcResultCodeOpts, _T("%s"), pcReadBuffer);
            fputs(cOutBuffer, spcOutFile);
        } else if (iOutFileFormat == XML_FORMAT) {
            CDMtrCntOutputXMLCkFileToOutFile(pcReadBuffer);
        } else {
            cOutBuffer = CDMtrLibUtilConvertStringW (pcResultCodeOpts, _T("%s"), pcReadBuffer);
            fputs(cOutBuffer, spcOutFile);
        }
        CDMtrLibUtilFreeW((void **)&cOutBuffer);
    }
    iRet = RET_OK;
FUNC_END:
    if (fpIn) {
        fclose(fpIn);
        fpIn = NULL;
    }
    CDMtrLibUtilFreeW((void **)&pcReadBuffer);
    return iRet;
}

/*!
    @brief          w肳ꂽ񒆂2dquot1ɒu
*/
_TCHAR *CDMtrCntOutputCSVDelQuot(_TCHAR *pstrBuff)
{
    _TCHAR *p = NULL;
    int iLength = 0;
    if (pstrBuff) {
        iLength = _tcslen(pstrBuff);
        p = _tcsstr(pstrBuff, _T("\"\""));
        if (p) {
            _tcscpy(p, p + 1);
            pstrBuff[iLength - 1] = _T('\0');
            return CDMtrCntOutputCSVDelQuot(p + 1);
        } else {
            return NULL;
        }
    }
    return NULL;
}

/*!
    @brief          \gNX̑茋ʂo͂(CSV)
*/
static int cdmtrCntOutputCSVStructFileToOutCSVFile(_TCHAR *pBuffer, int nLineSize)
{
    int iRet = RET_NG;
    int iFuncRet;
    _TCHAR *chCsvDir = NULL;
    _TCHAR *chCsvFile = NULL;
    _TCHAR *chCsvFunc = NULL;
    _TCHAR *chCsvInfo = NULL;
    _TCHAR *str_buff = NULL;
    _TCHAR *pcBuffer = NULL;
    char *cOutBuffer = NULL;
    if (spcOutFile == NULL) {
        goto FUNC_END;;
    }
    if (pBuffer ==  NULL) {
        goto FUNC_END;
    }
    cdmtrCntOutputCSVGetNextCsvToken(&chCsvDir, nLineSize, pBuffer, CDMTR_FALSE);
    if (chCsvDir == NULL) {
        goto FUNC_END;
    }
    cdmtrCntOutputCSVGetNextCsvToken(&chCsvFile, nLineSize, NULL, CDMTR_FALSE);
    if (chCsvFile == NULL) {
        goto FUNC_END;
    }
    cdmtrCntOutputCSVGetNextCsvToken(&chCsvFunc, nLineSize, NULL, CDMTR_FALSE);
    if (chCsvFunc == NULL) {
        goto FUNC_END;
    }
    if (_tcscmp(chCsvFunc, _T("-")) == 0) {
        iRet = CDMtrLibUtilCreateStringW(&pcBuffer, _T("\""), chCsvDir, _T("\",\""), chCsvFile, _T("\","), chCsvFunc, _T(","), NULL);
        if (iRet != RET_OK) {
            goto FUNC_END;
        }
    } else {
        iRet = CDMtrLibUtilCreateStringW(&pcBuffer, _T("\""), chCsvDir, _T("\",\""), chCsvFile, _T("\",\""), chCsvFunc, _T("\","), NULL);
        if (iRet != RET_OK) {
            goto FUNC_END;
        }
    }
    cdmtrCntOutputCSVGetNextCsvToken(&chCsvInfo, nLineSize, NULL, CDMTR_TRUE);
    if (chCsvInfo == NULL) {
        goto FUNC_END;
    }
    iRet = CDMtrLibUtilCreateStringW(&pcBuffer, chCsvInfo, _T("\n"), NULL);
    if (iRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibUtilUNICODEtoMBCSW(&cOutBuffer, &pcBuffer, pcResultCodeOpts);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    if (cOutBuffer != NULL) {
        fputs(cOutBuffer, spcOutFile);
        CDMtrLibUtilFreeW((void **)&cOutBuffer);
    }
FUNC_END:
    if (pcBuffer != NULL) {
        CDMtrLibUtilFreeW((void **)&pcBuffer);
    }
    if (str_buff != NULL) {
        CDMtrLibUtilFreeW((void **)&str_buff);
    }
    if (chCsvDir != NULL) {
        CDMtrLibUtilFreeW((void **)&chCsvDir);
    }
    if (chCsvFile != NULL) {
        CDMtrLibUtilFreeW((void **)&chCsvFile);
    }
    if (chCsvFunc != NULL) {
        CDMtrLibUtilFreeW((void **)&chCsvFunc);
    }
    if (chCsvInfo != NULL) {
        CDMtrLibUtilFreeW((void **)&chCsvInfo);
    }
    return iRet;
}


/*!
    @brief          茋ʂɉ͎so͂(CSV)
*/
int CDMtrCntOutputCSVErrFileToOutFile(const _TCHAR *pcInName, _TCHAR *pcLangName)
{
    int iRet = RET_NG;
    int iFuncRet;
    unsigned int uiPathLen;
    _TCHAR *pcDirName;
    _TCHAR *pcFileName;
    int i;
    char *cBuff = NULL;
    pcDirName = NULL;
    pcFileName = NULL;
    if (spcOutFile == NULL) {
        goto FUNC_END;
    }
    if (pcInName == NULL) {
        goto FUNC_END;
    }
    uiPathLen = _tcslen(pcInName);
    iFuncRet = CDMtrLibUtilMallocW((void **)&pcDirName, (uiPathLen + 1) * sizeof(_TCHAR));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibFileGetDirName(pcInName, pcDirName);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibUtilMallocW((void **)&pcFileName, (uiPathLen + 1) * sizeof(_TCHAR));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibFileGetFileName(pcInName, pcFileName);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    if (iOutFileFormat != XML_FORMAT) {
        if (pcLangName != NULL) {
            if (iExecuteMode == CK_MODE) {
                cBuff = CDMtrLibUtilConvertStringW (pcResultCodeOpts, OUTPUT_ERROR_FORMAT_CK,
                                                    pcDirName,
                                                    pcFileName,
                                                    OUTPUT_NOT_TARGET,
                                                    OUTPUT_NOT_TARGET,
                                                    pcLangName
                                                   );
            } else {
                cBuff = CDMtrLibUtilConvertStringW (pcResultCodeOpts, OUTPUT_ERROR_FORMAT,
                                                    pcDirName,
                                                    pcFileName,
                                                    OUTPUT_NOT_TARGET,
                                                    pcLangName
                                                   );
            }
        } else {
            if (iExecuteMode == CK_MODE) {
                cBuff = CDMtrLibUtilConvertStringW (pcResultCodeOpts, OUTPUT_ERROR_FORMAT_CK,
                                                    pcDirName,
                                                    pcFileName,
                                                    OUTPUT_NOT_TARGET,
                                                    OUTPUT_NOT_TARGET,
                                                    OUTPUT_NOT_TARGET
                                                   );
            } else {
                cBuff = CDMtrLibUtilConvertStringW (pcResultCodeOpts, OUTPUT_ERROR_FORMAT,
                                                    pcDirName,
                                                    pcFileName,
                                                    OUTPUT_NOT_TARGET,
                                                    OUTPUT_NOT_TARGET
                                                   );
            }
        }
        if (cBuff != NULL) {
            fputs(cBuff, spcOutFile);
        }
        CDMtrLibUtilFreeW((void **)&cBuff);
    } else {
        switch (iExecuteMode) {
        case ROW_MODE:
            CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_START_CRL, TAG_OUTLINE, FILE_UNIT_TAG_NAME, NULL);
            iFuncRet = CDMtrCntOutputXMLComOutPrint(spcOutFile, 6, pcBeautifier, METRICS_NG_STRING, pcDirName, pcFileName,
                                                    pcLangName, NULL);
            if (iFuncRet == RET_NG) goto FUNC_END;
            for (i = STMT_TAG_NAME; i <= REM_TAG_NAME; i++) {
                CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_EMPTY, TAG_ROW_TYPE, i, NULL);
            }
            CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_EMPTY, TAG_DIFF_TYPE, TAG_TYPE_DIFF_NONE, NULL);
            CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_END, TAG_OUTLINE, FILE_UNIT_TAG_NAME, NULL);
            break;
        case DIFF_MODE:
            CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_START_CRL, TAG_OUTLINE, FILE_UNIT_TAG_NAME, NULL);
            iFuncRet = CDMtrCntOutputXMLComOutPrint(spcOutFile, 6, pcBeautifier, METRICS_NG_STRING, pcDirName, pcFileName,
                                                    pcLangName, NULL);
            if (iFuncRet == RET_NG) goto FUNC_END;
            for (i = STMT_TAG_NAME; i <= REM_TAG_NAME; i++) {
                CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_EMPTY, TAG_ROW_TYPE, i, NULL);
            }
            if (giDiffCountMode == DIFF_COUNT_EXT) {
                CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_START_CRL, TAG_DIFF_TYPE, TAG_TYPE_DIFF_EXT, NULL);
                for (i = STATE_EXT; i < OLD_FILE_EXT + 1; i++) {
                    CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_EMPTY, TAG_DIFF_EXT, i, NULL);
                }
                CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_END, TAG_DIFF_TYPE, TAG_TYPE_DIFF_EXT, NULL);
            } else {
                CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_START_CRL, TAG_DIFF_TYPE, TAG_TYPE_DIFF_STD, NULL);
                for (i = STATE_EXT; i < OLD_FILE_STD + 1; i++) {
                    CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_EMPTY, TAG_DIFF_STD, i, NULL);
                }
                CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_END, TAG_DIFF_TYPE, TAG_TYPE_DIFF_STD, NULL);
            }
            CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_END, TAG_OUTLINE, FILE_UNIT_TAG_NAME, NULL);
            break;
        case STRUCT_MODE:
            CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_START_CRL, TAG_OUTLINE, FUNC_UNIT_TAG_NAME, NULL);
            iFuncRet = CDMtrCntOutputXMLComOutPrint(spcOutFile, 6, pcBeautifier, METRICS_NG_STRING, pcDirName, pcFileName,
                                                    pcLangName, NULL);
            if (iFuncRet) goto FUNC_END;
            for (i = FLOC_TAG_STRUCT; i <= FOUT_GVAL_TAG_STRUCT; i++) {
                CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_EMPTY, TAG_STRUCT, i,  NULL);
            }
            CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_END, TAG_OUTLINE, FUNC_UNIT_TAG_NAME, NULL);
            break;
        case CK_MODE:
            CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_START_CRL, TAG_OUTLINE, CLASS_UNIT_TAG_NAME, NULL);
            iFuncRet = CDMtrCntOutputXMLComOutPrint(spcOutFile, 5, pcBeautifier,
                                                    METRICS_NG_STRING, pcDirName, pcFileName, pcLangName);
            if (iFuncRet == RET_NG) {
                goto FUNC_END;
            }
            iFuncRet = CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_EMPTY, TAG_CK_TYPE, PACKAGE_CK_TAG_NAME, NULL);
            if (iFuncRet == RET_NG) {
                goto FUNC_END;
            }
            iFuncRet = CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_EMPTY, TAG_CK_TYPE, CLASS_CK_TAG_NAME, NULL);
            if (iFuncRet == RET_NG) {
                goto FUNC_END;
            }
            for (i = WMC_TAG_CK; i <= CBO_TAG_CK; i++) {
                CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_EMPTY, TAG_CK, i, NULL);
            }
            CDMtrCntOutputXMLOutPrint(spcOutFile, TAG_END, TAG_OUTLINE, CLASS_UNIT_TAG_NAME, NULL);
        }
    }
    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcDirName);
    CDMtrLibUtilFreeW((void **)&pcFileName);
    return iRet;
}

/*!
    @brief          CSVf[^Token؂o
*/
static _TCHAR *cdmtrCntOutputCSVGetNextCsvToken(_TCHAR **strToken, int tokenMax, const _TCHAR *strCsvLineData, int nEofFlg)
{
    static const _TCHAR *strSourceData = NULL;
    static int readCount = 0;
    int startPos = 0, endPos = 0;
    int doubleQuot = 0;
    _TCHAR *p = NULL;
    if (strToken == NULL || tokenMax == 0) {
        return NULL;
    }
    *strToken = NULL;
    if (strCsvLineData != NULL) {
        strSourceData = strCsvLineData;
        readCount = 0;
    }
    if (strSourceData == NULL) {
        return NULL;
    }
    startPos = readCount;
    if (strSourceData[readCount] == _T('"' )) {
        doubleQuot = 1;
        startPos++;
        readCount++;
    }
    if (nEofFlg == CDMTR_TRUE) {
        for (; readCount < startPos + tokenMax; readCount++) {
            endPos = readCount;
            if (strSourceData[readCount] == _T('\r') || strSourceData[readCount] == _T('\n') || strSourceData[readCount] == _T('\0')) {
                readCount++;
                break;
            }
        }
    } else {
        for (; readCount < startPos + tokenMax; readCount++) {
            endPos = readCount;
            if (strSourceData[readCount] == _T('"') && doubleQuot == 1 && strSourceData[readCount + 1] == _T(',')) {
                if (giQrtOutFlg == CDMTR_TRUE) {
                    if ( readCount > 0 && strSourceData[readCount - 1] != _T('"') ) {
                        readCount += 2;
                        break;
                    }
                } else {
                    readCount += 2;
                    break;
                }
            } else if ( (strSourceData[readCount] == _T(',')) && (doubleQuot == 0) ) {
                readCount++;
                break;
            } else if ( strSourceData[readCount] == _T('\r') || strSourceData[readCount] == _T('\n') || strSourceData[readCount] == _T('\0') ) {
                if (doubleQuot == 0) {
                    readCount++;
                    break;
                } else {
                    return NULL;
                }
            }
        }
    }
    if (startPos == endPos) {
        *strToken = NULL;
    } else {
        p = (_TCHAR *)CDMtrLibCmnMalloc(endPos - startPos + 1);
        if (p == NULL) {
            return NULL;
        }
        _tcsncpy(p, strSourceData + startPos, endPos - startPos);
        p[endPos - startPos] = _T('\0');
        *strToken = p;
    }
    return *strToken;
}

/*!
    @brief          ǉ/폜t@C̍s茋ʂo͂
*/
int CDMtrCntOutputCSVDiffListToOutfile( const _TCHAR *OutputLogBase, const _TCHAR *OutputLogDist, const _TCHAR *pcLangName, _TCHAR *cResStatus, _LINECOUNT_LIST *ptList)
{
    int iRet = RET_OK;
    int (*pFunc)(_LINECOUNT_LIST * ptList);
    int iFuncSts = FUNC_NONE;
    int iFuncStsTmp = FUNC_NONE;
    int iInvFuncSts = FUNC_NONE;
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL3, _T("DiffMetrics (for ADD/DEL File) ,33,1")); //* MSG_LOG_ID_C_00000429
    if ( _tcscmp( cResStatus, DIFF_STATUS_DEL )  == 0) {
        pFunc = CDMtrCntFuncSetDeleteDiffLineCount;
        iFuncStsTmp = FUNC_DEL;
        iInvFuncSts = FUNC_INVALID_DEL;
    } else {
        pFunc = CDMtrCntFuncSetAddDiffLineCount;
        iFuncStsTmp = FUNC_ADD;
        iInvFuncSts = FUNC_INVALID_ADD;
    }
    while (ptList != NULL ) {
        iRet = (*pFunc)(ptList);
        if (iRet == RET_NG) {
            break;
        }
        if (ptList->iInvalidFlg == CDMTR_TRUE) {
            iFuncSts = iInvFuncSts;
        } else {
            iFuncSts = iFuncStsTmp;
        }
        iRet = CDMtrCntOutputCSVCountFileToOutFile( OutputLogBase,
                OutputLogDist,
                ptList->tFuncData.pcName,
                pcLangName,
                NULL,
                &ptList->tLCData,
                ptList->ptDiffData,
                cResStatus,
                iFuncSts
                                                  );
        if (iRet == RET_NG) {
            break;
        }
        ptList = ptList->next;
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL3, _T("Completed output (for ADD/DEL File),33,3")); //* MSG_LOG_ID_C_00000430
    return iRet;
}

/*!
    @brief          s̑茋ʂo͂(}b`OXg̏o)
*/
int CDMtrCntOutputCSVMatchingListToOutfile( const _TCHAR *OutputLogBase, const _TCHAR *OutputLogDist, const _TCHAR *pcLangName, _TCHAR *pcResStatus, _FUNC_MATCHING_LIST *ptMatchList)
{
    int iRet = RET_OK;
    _FUNC_MATCHING_LIST *ptCurrent;
    _LINECOUNT_LIST *ptOutLineList;
    _DIFFLINES *ptDiffData;
    ptCurrent = ptMatchList;
    while (ptCurrent != NULL) {
        switch (ptCurrent->iFlg) {
        case FUNC_DEL:
        case FUNC_DEL_VS_NONE:
        case FUNC_DEL_VS_INVALID:
        case FUNC_INVALID_DEL:
            ptOutLineList = ptCurrent->ptBaseList;
            break;
        default:
            ptOutLineList = ptCurrent->ptDistList;
        }
        ptDiffData = ptOutLineList->ptDiffData;
        iRet = CDMtrCntOutputCSVCountFileToOutFile( OutputLogBase,
                OutputLogDist,
                ptOutLineList->tFuncData.pcName,
                pcLangName,
                NULL,
                &ptOutLineList->tLCData,
                ptDiffData,
                pcResStatus,
                ptCurrent->iFlg
                                                  );
        if (iRet == RET_NG) {
            return iRet;
        }
        ptCurrent = ptCurrent->next;
    }
    return RET_OK;
}

/*!
    @brief          茋ʂ̃t@C񍀖(DIR,FILE,OLDDIR,OLDFILE)擾
*/
static int cdmtrCntOutputCSVCreateFilename(const _TCHAR *pcBaseName, const _TCHAR *pcDistName, const _TCHAR *pcResStatus, RESULTINFO_FILEITEMS *tOutputFileItems)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    unsigned int uiPathLen;         // t@CpX
    _TCHAR *pcDirName = NULL;       // DIRڏ
    _TCHAR *pcFileName = NULL;      // FILEڏ
    _TCHAR *pcOldDirName = NULL;    // OLDDIRڏ
    _TCHAR *pcOldFileName = NULL;   // OLDFILEڏ

    if (pcDistName != NULL) {
        /** DIRڂɏo͂ύX̑Ώۃt@CpX擾 */
        uiPathLen = _tcslen(pcDistName);
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcDirName, (uiPathLen + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        iFuncRet = CDMtrLibFileGetDirName(pcDistName, pcDirName);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        /** FILEڂɏo͂ύX̑Ώۃt@CpX擾 */
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcFileName, (uiPathLen + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        iFuncRet = CDMtrLibFileGetFileName(pcDistName, pcFileName);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    } else {
        /* DIRڂɏo͂"-"ݒ肷 */
        pcDirName = CDMtrLibUtilCopyString(OUTPUT_NOT_TARGET);
        if (pcDirName == NULL) {
            goto FUNC_END;
        }
        /* FILEڂɏo͂"-"ݒ肷 */
        pcFileName = CDMtrLibUtilCopyString(OUTPUT_NOT_TARGET);
        if (pcFileName == NULL) {
            goto FUNC_END;
        }
    }

    if (pcBaseName != NULL && (pcResStatus != NULL && _tcscmp(pcResStatus, DIFF_STATUS_NEW) != 0)) {
        /** OLDDIRڂɏo͂IWȋΏۃt@CpX擾 */
        uiPathLen = _tcslen(pcBaseName);
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcOldDirName, (uiPathLen + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        iFuncRet = CDMtrLibFileGetDirName(pcBaseName, pcOldDirName);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        /** OLDFILEڂɏo͂IWȋΏۃt@CpX擾 */
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcOldFileName, (uiPathLen + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        iFuncRet = CDMtrLibFileGetFileName(pcBaseName, pcOldFileName);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    } else {
        /* OLDDIRڂɏo͂"-"ݒ肷 */
        pcOldDirName = CDMtrLibUtilCopyString(OUTPUT_NOT_TARGET);
        if (pcOldDirName == NULL) {
            goto FUNC_END;
        }
        /* OLDFILEڂɏo͂"-"ݒ肷 */
        pcOldFileName = CDMtrLibUtilCopyString(OUTPUT_NOT_TARGET);
        if (pcOldFileName == NULL) {
            goto FUNC_END;
        }
    }
    iRet = RET_OK;

FUNC_END:
    if (iRet == RET_OK) {
        /* ԋplɏݒ肷 */
        tOutputFileItems->pcDIR = pcDirName;
        tOutputFileItems->pcFILE = pcFileName;
        tOutputFileItems->pcOLDDIR = pcOldDirName;
        tOutputFileItems->pcOLDFILE = pcOldFileName;
    } else {
        /* 擾Ɏsߗ̈s */
        CDMtrLibCmnFree((void **)&pcDirName);
        CDMtrLibCmnFree((void **)&pcFileName);
        CDMtrLibCmnFree((void **)&pcOldDirName);
        CDMtrLibCmnFree((void **)&pcOldFileName);
    }
    return iRet;
}

/*!
    @brief          {s̃gNXo͂(CSV)
*/
static int cdmtrCntOutputCSVOutputBasicLineCount(RESULTINFO_FILEITEMS *ptFileItems, RESULTINFO_ITEMS *ptItems, _LINECOUNT *ptCountLines, int iInvalidFlg)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    char *cOutBuffer = NULL;
    _TCHAR *pcOutputFuncName = NULL;

    /** FUNCڂɏo͂ݒ肷 */
    if (ptItems->pcFUNC == NULL) {
        /* FUNCڂɏo͂񂪂Ȃꍇ */
        pcOutputFuncName = CDMtrLibUtilCopyString(OUTPUT_NOT_TARGET);
        if (pcOutputFuncName == NULL) {
            goto FUNC_END;
        }
    } else {
        /* FUNCڂ""ň͂ */
        iFuncRet = CDMtrLibUtilCreateStringW(&pcOutputFuncName, DOUBLEQUOTATION, ptItems->pcFUNC, DOUBLEQUOTATION, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }

    /** ͑Ώۂ̃t@Co͑Ώۂ̕R[hɕϊ */
    cOutBuffer = CDMtrLibUtilConvertStringW(pcResultCodeOpts, OUTPUT_FILE_INFO,
                                            ptFileItems->pcDIR,
                                            ptFileItems->pcFILE,
                                            pcOutputFuncName,
                                            ((ptItems->pcLANG) ? ptItems->pcLANG : OUTPUT_NOT_TARGET));

    /** ͑Ώۂ̃t@Co͂ */
    if (cOutBuffer != NULL) {
        fputs(cOutBuffer, spcOutFile);
    }

    /** {sgNXo͂ */
    if (ptItems->pcSTATE != NULL && _tcscmp(ptItems->pcSTATE, DIFF_STATUS_DEL) == 0) {
        /* sŁAA폜t@C(DEL_FILE)̏ꍇ */
        /* {sgNX͏o͂Ȃ(STMTڂ'x'o) */
        _fputts(OUTPUT_DIFF_BASEONLY_ROW, spcOutFile);

    } else {
        /* s̍폜t@C(DEL_FILE)ȊȌꍇ */
        if (iInvalidFlg == CDMTR_TRUE) {
            /* s(֐P)ŁAAΏۂ̊֐폜֐܂͖֐̏ꍇ */
            /* {sgNX'-'o͂ */
            _fputts(OUTPUT_DIFF_FUNCDEL_INVALID, spcOutFile);

        } else {
            /* STMTڂ̏o͂ */
            if (ptItems->plSTMT != NULL) {
                _ftprintf(spcOutFile, _T("%ld"), *(ptItems->plSTMT));
            } else {
                _fputts(OUTPUT_NOT_TARGET, spcOutFile);
            }
            _fputts(OUTPUT_CVS_SEP, spcOutFile);

            /* {sgNX̏o͂ */
            switch (ptItems->iLangType) {
            case LANG_TYPE_TXT:
            case LANG_TYPE_BIN:
                _ftprintf(spcOutFile, OUTPUT_BIN_FORMAT_ROW, ptCountLines->ulTLOC);
                break;

            case LANG_TYPE_CPP:
            case LANG_TYPE_CPPH:
            case LANG_TYPE_C:
            case LANG_TYPE_CH:
            case LANG_TYPE_JAVA:
            case LANG_TYPE_CS:
            case LANG_TYPE_VB:
            case LANG_TYPE_JS:
            default:
                _ftprintf(spcOutFile, OUT_FORMAT_COUNTRESULT,
                          ptCountLines->ulTLOC,
                          ptCountLines->ulELOC,
                          ptCountLines->ulCLOC,
                          ptCountLines->ulBlank,
                          ptCountLines->ulUndef,
                          ptCountLines->ulICLOC,
                          ptCountLines->ulLine,
                          ptCountLines->ulPre,
                          ptCountLines->ulDoc,
                          ptCountLines->ulCmnt);
                break;
            }
        }
    }
    iRet = RET_OK;

FUNC_END:
    CDMtrLibUtilFreeW((void **)&cOutBuffer);
    CDMtrLibCmnFree((void **)&pcOutputFuncName);
    return iRet;
}

/*!
    @brief          s̃gNXo͂(CSV)
*/
static int cdmtrCntOutputCSVOutputLineChangeCount(RESULTINFO_FILEITEMS *ptFileItems, RESULTINFO_ITEMS *ptItems, _DIFFLINES *ptDiffLines, int iInvalidFlg)
{
    int iRet = RET_NG;
    char *cOutBuffer = NULL;

    /** @mF */
    if (ptItems->pcSTATE == NULL) {
        /** {s̑茋ʏo͂̏ꍇAsgNX͏o͂Ȃ */
        if (giDiffCountMode == DIFF_COUNT_EXT) {
            _fputts(OUTPUT_DIFF_B_NONE, spcOutFile);
        } else {
            _fputts(OUTPUT_DIFF_A_NONE, spcOutFile);
        }
        iRet = RET_OK;
        goto FUNC_END;
    }

    /** s̑茋ʏo͂̏ꍇAsgNXo͂ */
    if (giDiffCountMode == DIFF_COUNT_EXT) {
        /* vpeB̐ݒ肪DIFF_COUNT_MODE=EXT̏ꍇ */
        switch (ptItems->iLangType) {
        case LANG_TYPE_BIN:
            cOutBuffer = CDMtrLibUtilConvertStringW(pcResultCodeOpts, OUTPUT_BIN_FORMAT_DIFF_B,
                                                    ptItems->pcSTATE,
                                                    ptFileItems->pcOLDDIR,
                                                    ptFileItems->pcOLDFILE);
            break;

        case LANG_TYPE_TXT:
            cOutBuffer = CDMtrLibUtilConvertStringW(pcResultCodeOpts, OUTPUT_TXT_FORMAT_DIFF_B,
                                                    ptItems->pcSTATE,
                                                    ptDiffLines->tDiffTotal.ulEqu,
                                                    ptDiffLines->tDiffTotal.ulAdd,
                                                    ptDiffLines->tDiffTotal.ulDel,
                                                    ptDiffLines->tDiffTotal.ulModAdd,
                                                    ptDiffLines->tDiffTotal.ulModDel,
                                                    ptFileItems->pcOLDDIR,
                                                    ptFileItems->pcOLDFILE);
            break;

        case LANG_TYPE_CPP:
        case LANG_TYPE_CPPH:
        case LANG_TYPE_C:
        case LANG_TYPE_CH:
        case LANG_TYPE_JAVA:
        case LANG_TYPE_CS:
        case LANG_TYPE_VB:
        case LANG_TYPE_JS:
        default:
            if (iInvalidFlg == CDMTR_TRUE) {
                /* STATEڂo͂ */
                _ftprintf(spcOutFile, OUTPUT_DIFF_B_FORMAT_STATE, ptItems->pcSTATE);
                /* o͑Ώۂ֐̏ꍇAsgNX͏o͂Ȃ */
                _ftprintf(spcOutFile, OUTPUT_DIFF_B_FORMATFUNC_INVALID);

            } else {
                if (ptDiffLines == NULL) {
                    goto FUNC_END;
                }
                /* STATEڂo͂ */
                _ftprintf(spcOutFile, OUTPUT_DIFF_B_FORMAT_STATE, ptItems->pcSTATE);

                /* sgNXo͂ */
                _ftprintf(spcOutFile, OUTPUT_DIFF_B_FORMAT_LINES,
                          ptDiffLines->tDiffTotal.ulEqu,
                          ptDiffLines->tDiffTotal.ulAdd,
                          ptDiffLines->tDiffTotal.ulDel,
                          ptDiffLines->tDiffTotal.ulModAdd,
                          ptDiffLines->tDiffTotal.ulModDel);

                _ftprintf(spcOutFile, OUTPUT_DIFF_B_FORMAT_LINES,
                          ptDiffLines->tDiffEloc.ulEqu,
                          ptDiffLines->tDiffEloc.ulAdd,
                          ptDiffLines->tDiffEloc.ulDel,
                          ptDiffLines->tDiffEloc.ulModAdd,
                          ptDiffLines->tDiffEloc.ulModDel);

                _ftprintf(spcOutFile, OUTPUT_DIFF_B_FORMAT_LINES,
                          ptDiffLines->tDiffCloc.ulEqu,
                          ptDiffLines->tDiffCloc.ulAdd,
                          ptDiffLines->tDiffCloc.ulDel,
                          ptDiffLines->tDiffCloc.ulModAdd,
                          ptDiffLines->tDiffCloc.ulModDel);

                if (giDiffBlankFlg) {
                    _ftprintf(spcOutFile, OUTPUT_DIFF_B_FORMAT_LINES,
                              ptDiffLines->tDiffBloc.ulEqu,
                              ptDiffLines->tDiffBloc.ulAdd,
                              ptDiffLines->tDiffBloc.ulDel,
                              ptDiffLines->tDiffBloc.ulModAdd,
                              ptDiffLines->tDiffBloc.ulModDel);
                } else {
                    _ftprintf(spcOutFile, OUTPUT_DIFF_B_FORMAT_NONE);
                }

                if (iSkipChangeFlg) {
                    _ftprintf(spcOutFile, OUTPUT_DIFF_B_FORMAT_LINES,
                              ptDiffLines->tDiffSkip.ulEqu,
                              ptDiffLines->tDiffSkip.ulAdd,
                              ptDiffLines->tDiffSkip.ulDel,
                              ptDiffLines->tDiffSkip.ulModAdd,
                              ptDiffLines->tDiffSkip.ulModDel);
                } else {
                    _ftprintf(spcOutFile, OUTPUT_DIFF_B_FORMAT_NONE);
                }
            }

            /* IWȋΏۃt@C̏o͂ */
            cOutBuffer = CDMtrLibUtilConvertStringW(pcResultCodeOpts, OUTPUT_DIFF_B_FORMAT_OLDPATH,
                                                    ptFileItems->pcOLDDIR, ptFileItems->pcOLDFILE);

            break;
        }

    } else {
        /* vpeB̐ݒ肪DIFF_COUNT_MODE=STD̏ꍇ */
        switch (ptItems->iLangType) {
        case LANG_TYPE_BIN:
        case LANG_TYPE_TXT:
            cOutBuffer = CDMtrLibUtilConvertStringW(pcResultCodeOpts, OUTPUT_BIN_FORMAT_DIFF_A,
                                                    ptItems->pcSTATE,
                                                    ptFileItems->pcOLDDIR,
                                                    ptFileItems->pcOLDFILE);
            break;

        case LANG_TYPE_CPP:
        case LANG_TYPE_CPPH:
        case LANG_TYPE_C:
        case LANG_TYPE_CH:
        case LANG_TYPE_JAVA:
        case LANG_TYPE_CS:
        case LANG_TYPE_VB:
        case LANG_TYPE_JS:
        default:
            if (iInvalidFlg == CDMTR_TRUE) {
                /* o͑Ώۂ֐̏ꍇAsgNX͏o͂Ȃ */
                cOutBuffer = CDMtrLibUtilConvertStringW(pcResultCodeOpts, OUTPUT_BIN_FORMAT_DIFF_A,
                                                        ptItems->pcSTATE,
                                                        ptFileItems->pcOLDDIR,
                                                        ptFileItems->pcOLDFILE);
            } else {
                if (ptDiffLines == NULL) {
                    goto FUNC_END;
                }
                /* sgNXo͂ */
                cOutBuffer = CDMtrLibUtilConvertStringW(pcResultCodeOpts, OUTPUT_DIFF_A_FORMAT,
                                                        ptItems->pcSTATE,
                                                        ptDiffLines->tDiffEloc.ulEqu,
                                                        ptDiffLines->tDiffEloc.ulAdd,
                                                        ptDiffLines->tDiffEloc.ulDel,
                                                        ptDiffLines->tDiffCloc.ulEqu,
                                                        ptDiffLines->tDiffCloc.ulAdd,
                                                        ptDiffLines->tDiffCloc.ulDel,
                                                        ptFileItems->pcOLDDIR,
                                                        ptFileItems->pcOLDFILE);
            }
            break;
        }
    }
    if (cOutBuffer != NULL) {
        fputs(cOutBuffer, spcOutFile);
    }
    iRet = RET_OK;

FUNC_END:
    CDMtrLibUtilFreeW((void **)&cOutBuffer);
    return iRet;
}


