/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "CDMtrCmn.h"
#include "CDMtrExtCmn.h"
#include "CDMtrLibCmnW.h"
#include "CDMtrLibFileW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrLibSystemW.h"
#include "CDMtrCntMain.h"
#include "CDMtrCntFormat.h"
#include "CDMtrExtCmn.h"
#include "CDMtrMessage.h"

static int cdmtrCntPreFormatGetFileData(_TCHAR *pcFolderName, _TCHAR *pcSourceID, _TCHAR *pcFileName, _TCHAR **ppcData, int *pisize);
static int cdmtrCntPreFormatGetFuncInfoData(_TCHAR **ppCurPtr, _TCHAR *pEndPtr, FUNCINFO_T *pFuncTbl);
static int cdmtrCntPreFormatGetLineInfoData(_TCHAR **ppCurPtr, _TCHAR *pEndPtr, LINEINFO_T *pMtcTbl);
static void cdmtrCntPreFormatLineCount(LINEINFO_T *strLineTbl, OUTINFO_T *strOutTbl);
static void cdmtrCntPreFormatLineTbl(int iOldLine, LINEINFO_T *pLineTbl, LINEINFO_T *pCurLineTbl, OUTINFO_T *pOutTbl);
static void cdmtrCntPreFormatLineMerge(LINEINFO_T *pLineTbl, LINEINFO_T *pCurLineTbl);
static void cdmtrOutputCSV(FILE *fp, _TCHAR *pcDirPath, _TCHAR *pcFName, _TCHAR *pcLangName, FUNCINFO_T *pFuncTbl, OUTINFO_T *pOutTbl);
/*!
    @brief      Oc[(p[T)o͂Xe[gg茋ʂ擾
*/
int CDMtrCntPreFormatAggregateFile(_TCHAR *pcTempFolderName,
                                   _TCHAR *pcSourceID,
                                   OUTINFO_T *pcCntTbl)
{
    _TCHAR *pclinedata = NULL;
    int ilinedata_size = 0;
    _TCHAR *pclinedata_cur = NULL;
    _TCHAR *pclinedata_end = NULL;
    int ilen = 0;
    int iret = RET_NG;
    int iretvalue = RET_NG;
    LINEINFO_T strLineTbl;
    OUTINFO_T strOutTbl;
    memset(&strLineTbl, 0x00, sizeof(LINEINFO_T));
    memset(&strOutTbl, 0x00, sizeof(OUTINFO_T));
    iret = cdmtrCntPreFormatGetFileData(pcTempFolderName,
                                        pcSourceID,
                                        LINEINFO_NAME,
                                        &pclinedata,
                                        &ilinedata_size);
    if (iret != RET_OK) {
        goto FUNC_END;
    }
    pclinedata_cur = pclinedata;
    pclinedata_end = pclinedata + ilinedata_size - 1;
    ilen = _tcslen(pclinedata_cur);
    pclinedata_cur += ilen + 1;
    while (pclinedata_cur <= pclinedata_end) {
        memset(&strLineTbl, 0x00, sizeof(LINEINFO_T));
        iret = cdmtrCntPreFormatGetLineInfoData(&pclinedata_cur, pclinedata_end, &strLineTbl);
        cdmtrCntPreFormatLineCount(&strLineTbl, &strOutTbl);
    }
    if (!iSkipChangeFlg) {
        strOutTbl.iCnt[OUTINFO_FLOC] = strOutTbl.iCnt[OUTINFO_ELOC] +
                                       strOutTbl.iCnt[OUTINFO_CLOC] +
                                       strOutTbl.iCnt[OUTINFO_BLOC] ;
    } else {
        strOutTbl.iCnt[OUTINFO_FLOC] = strOutTbl.iCnt[OUTINFO_ELOC] +
                                       strOutTbl.iCnt[OUTINFO_CLOC] +
                                       strOutTbl.iCnt[OUTINFO_BLOC] +
                                       strOutTbl.iCnt[OUTINFO_SKIP] ;
    }
    iretvalue = RET_OK;
    memcpy(pcCntTbl, &strOutTbl, sizeof(OUTINFO_T));
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pclinedata);
    return iretvalue;
}


/*!
    @brief          Oc[(p[T)o͂\gNX茋ʂWv
*/
int CDMtrCntPreFormatAggregate(_TCHAR *pcTempFolderName,
                               _TCHAR *pcSourceID,
                               _TCHAR *pcDirPath,
                               _TCHAR *pcFName,
                               _TCHAR *pcLangName,
                               _TCHAR *pcTemp5,
                               int iLangType)
{
    _TCHAR *pcfuncdata = NULL;
    _TCHAR *pclinedata = NULL;
    int ifuncdata_size = 0;
    int ilinedata_size = 0;
    _TCHAR *pcfuncdata_cur = NULL;
    _TCHAR *pcfuncdata_end = NULL;
    _TCHAR *pclinedata_cur = NULL;
    _TCHAR *pclinedata_end = NULL;
    int ilen = 0;
    int iret = RET_NG;
    int iretvalue = RET_NG;
    int iInFuncOldLine = 0;
    int iOutFuncOldLine = 0;
    LINEINFO_T strLineTbl;
    FUNCINFO_T strFuncTbl;
    LINEINFO_T strInFuncLineTbl;
    OUTINFO_T strInFuncOutTbl;
    LINEINFO_T strOutofFuncLineTbl;
    OUTINFO_T strOutofFuncOutTbl;
    FILE *fp = NULL;
    memset(&strFuncTbl, 0x00, sizeof(FUNCINFO_T));
    memset(&strLineTbl, 0x00, sizeof(LINEINFO_T));
    memset(&strInFuncLineTbl, 0x00, sizeof(LINEINFO_T));
    memset(&strInFuncOutTbl, 0x00, sizeof(OUTINFO_T));
    memset(&strOutofFuncLineTbl, 0x00, sizeof(LINEINFO_T));
    memset(&strOutofFuncOutTbl, 0x00, sizeof(OUTINFO_T));
    fp = _tfopen(pcTemp5, _T("w, ccs=UTF-8"));
    if (fp == NULL) {
        return RET_NG;
    }
    iret = cdmtrCntPreFormatGetFileData(pcTempFolderName,
                                        pcSourceID,
                                        FUNCINFO_NAME,
                                        &pcfuncdata,
                                        &ifuncdata_size);
    if (iret != RET_OK) {
        goto FUNC_END;
    }
    pcfuncdata_cur = pcfuncdata;
    pcfuncdata_end = pcfuncdata + ifuncdata_size - 1;
    ilen = _tcslen(pcfuncdata_cur);
    pcfuncdata_cur += ilen + 1;
    if (iLangType != LANG_TYPE_JS) {
        if (pcfuncdata_cur > pcfuncdata_end) {
            _ftprintf(fp, _T("\"%s\","), pcDirPath);
            _ftprintf(fp, _T("\"%s\","), pcFName);
            _ftprintf(fp, _T("-,"));
            _ftprintf(fp, _T("%s,"), pcLangName);
            _ftprintf(fp, _T("-,-,-,-,-,-,-,-,-,-,-,-,-\n"));
            iretvalue = RET_OK;
            goto FUNC_END;
        }
    }
    iret = cdmtrCntPreFormatGetFileData(pcTempFolderName,
                                        pcSourceID,
                                        LINEINFO_NAME,
                                        &pclinedata,
                                        &ilinedata_size);
    if (iret != RET_OK) {
        goto FUNC_END;
    }
    pclinedata_cur = pclinedata;
    pclinedata_end = pclinedata + ilinedata_size - 1;
    ilen = _tcslen(pclinedata_cur);
    pclinedata_cur += ilen + 1;
    while (pclinedata_cur <= pclinedata_end) {
        memset(&strLineTbl, 0x00, sizeof(LINEINFO_T));
        iret = cdmtrCntPreFormatGetLineInfoData(&pclinedata_cur, pclinedata_end, &strLineTbl);
        if (iret != RET_OK) {
            goto FUNC_END;
        }
        if (strLineTbl.iCnt[LINEINFO_STATUS] != LINEDTL_STATUS_NORMAL) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000446, pcFName, strLineTbl.iCnt[LINEINFO_LINE_NUMBER]); //* MSG_LOG_ID_C_00000446
            goto FUNC_END;
        }
        if (strLineTbl.iCnt[LINEINFO_FUNC_LINE] == LINEDTL_FUNC_LINE_IN) {
            cdmtrCntPreFormatLineTbl(iInFuncOldLine, &strInFuncLineTbl, &strLineTbl, &strInFuncOutTbl);
            iInFuncOldLine = strLineTbl.iCnt[LINEINFO_LINE_NUMBER];
            if (strLineTbl.iCnt[LINEINFO_FUNC_DELIM] & LINEDTL_FUNC_DELIM_START) {
                memset (&strFuncTbl, 0x00, sizeof(FUNCINFO_T));
                iret = cdmtrCntPreFormatGetFuncInfoData(&pcfuncdata_cur, pcfuncdata_end, &strFuncTbl);
                if (iret != RET_OK) {
                    goto FUNC_END;
                }
                if (strFuncTbl.iCnt[FUNCINFO_STATUS] != FUNCDTL_STATUS_NORMAL) {
                    CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000447, pcFName, strFuncTbl.pcStr[FUNCINFO_FUNC_NAME]); //* MSG_LOG_ID_C_00000447
                    goto FUNC_END;
                }
                strInFuncOutTbl.iCnt[OUTINFO_FLOC] = strFuncTbl.iCnt[FUNCINFO_FUNC_ENDLINE]
                                                     - strFuncTbl.iCnt[FUNCINFO_FUNC_STARTLINE] + 1;
            }
            if (strLineTbl.iCnt[LINEINFO_FUNC_DELIM] & LINEDTL_FUNC_DELIM_END) {
                cdmtrCntPreFormatLineCount(&strInFuncLineTbl, &strInFuncOutTbl);
                cdmtrOutputCSV(fp, pcDirPath, pcFName, pcLangName, &strFuncTbl, &strInFuncOutTbl);
                iInFuncOldLine = 0;
                memset(&strInFuncLineTbl, 0x00, sizeof(LINEINFO_T));
                memset(&strInFuncOutTbl, 0x00, sizeof(OUTINFO_T));
            }
        } else {
            cdmtrCntPreFormatLineTbl(iOutFuncOldLine, &strOutofFuncLineTbl, &strLineTbl, &strOutofFuncOutTbl);
            iOutFuncOldLine = strLineTbl.iCnt[LINEINFO_LINE_NUMBER];
        }
    }
    if (iLangType == LANG_TYPE_JS) {
        cdmtrCntPreFormatLineCount(&strOutofFuncLineTbl, &strOutofFuncOutTbl);
        strOutofFuncOutTbl.iCnt[OUTINFO_FLOC] = strOutofFuncOutTbl.iCnt[OUTINFO_ELOC] +
                                                strOutofFuncOutTbl.iCnt[OUTINFO_CLOC] +
                                                strOutofFuncOutTbl.iCnt[OUTINFO_BLOC];
        if (strOutofFuncOutTbl.iCnt[OUTINFO_FLOC] != 0) {
            strFuncTbl.pcStr[FUNCINFO_FUNC_NAME] = _T("\"anonymous_0_0\"");
            strFuncTbl.pcStr[FUNCINFO_PARAM_NAME] = _T("\"\"");
            cdmtrOutputCSV(fp, pcDirPath, pcFName, pcLangName, &strFuncTbl, &strOutofFuncOutTbl);
        }
    }
    iretvalue = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcfuncdata);
    CDMtrLibUtilFreeW((void **)&pclinedata);
    if (fp != NULL) {
        fclose(fp);
    }
    if (iretvalue != RET_OK) {
        CDMtrLibFileDelete(pcTemp5);
    }
    return iretvalue;
}


/*!
    @brief          FuncInfo.csv1R[hFunc̎擾s
*/
static int cdmtrCntPreFormatGetFuncInfoData(_TCHAR **ppCurPtr, _TCHAR *pEndPtr, FUNCINFO_T *pFuncTbl)
{
    _TCHAR *pcur;
    int i = 0;
    int ilen = 0;
    if ((ppCurPtr == NULL) ||
            (pEndPtr == NULL) ||
            (pFuncTbl == NULL)) {
        return RET_NG;
    }
    pcur = *ppCurPtr;
    memset(pFuncTbl, 0x00, sizeof(FUNCINFO_T));
    for (i = 0; i < FUNCINFO_CSV_END; i++) {
        if (pcur > pEndPtr) {
            return RET_END_FILE;
        }
        ilen = _tcslen(pcur);
        switch (i) {
        case FUNCINFO_CSV_FUNC_NAME:
            pFuncTbl->iState |= (1 << i);
            pFuncTbl->pcStr[FUNCINFO_FUNC_NAME] = pcur;
            break;
        case FUNCINFO_CSV_PARAM_NAME:
            pFuncTbl->iState |= (1 << i);
            pFuncTbl->pcStr[FUNCINFO_PARAM_NAME] = pcur;
            break;
        default:
            if ((ilen == 0) ||
                    (*pcur == _T('"')) ||
                    (*pcur == _T('-'))) {
                break;
            }
            pFuncTbl->iState |= (1 << i);
            switch (i) {
            case FUNCINFO_CSV_FUNC_ID:
                pFuncTbl->iCnt[FUNCINFO_FUNC_ID] = _ttoi(pcur);
                break;
            case FUNCINFO_CSV_FUNC_STARTLINE:
                pFuncTbl->iCnt[FUNCINFO_FUNC_STARTLINE] = _ttoi(pcur);
                break;
            case FUNCINFO_CSV_FUNC_ENDLINE:
                pFuncTbl->iCnt[FUNCINFO_FUNC_ENDLINE] = _ttoi(pcur);
                break;
            case FUNCINFO_CSV_PARAM_CNT:
                pFuncTbl->iCnt[FUNCINFO_PARAM_CNT] = _ttoi(pcur);
                break;
            case FUNCINFO_CSV_INTERNALFUNC:
                pFuncTbl->iCnt[FUNCINFO_INTERNALFUNC] = _ttoi(pcur);
                break;
            case FUNCINFO_CSV_STATUS:
                pFuncTbl->iCnt[FUNCINFO_STATUS] = _ttoi(pcur);
                break;
            default:
                break;
            }
        }
        pcur += ilen + 1;
    }
    *ppCurPtr = pcur;
    return RET_OK;
}

/*!
    @brief          LineInfo.csv1R[hLine̎擾s
*/
static int cdmtrCntPreFormatGetLineInfoData(_TCHAR **ppCurPtr, _TCHAR *pEndPtr, LINEINFO_T *pLineTbl)
{
    _TCHAR *pcur = *ppCurPtr;
    int i = 0;
    int ilen = 0;
    if ((ppCurPtr == NULL) ||
            (pEndPtr == NULL) ||
            (pLineTbl == NULL)) {
        return RET_NG;
    }
    memset(pLineTbl, 0x00, sizeof(LINEINFO_T));
    for (i = 0; i < LINEINFO_CSV_END; i++) {
        if (pcur > pEndPtr) {
            return RET_END_FILE;
        }
        ilen = _tcslen(pcur);
        if ((ilen != 0) &&
                (*pcur != _T('"')) &&
                (*pcur != _T('-'))) {
            pLineTbl->iState |= (1 << i);
            pLineTbl->iCnt[i] = _ttoi(pcur);
        }
        pcur += ilen + 1;
    }
    *ppCurPtr = pcur;
    return RET_OK;
}


/*!
    @brief          p[To͂ԃt@Cǂݍ
*/
static int cdmtrCntPreFormatGetFileData(_TCHAR *pcFolderName, _TCHAR *pcSourceID, _TCHAR *pcFileName, _TCHAR **ppcData, int *piSize)
{
    _TCHAR *pcFile = NULL;
    _TCHAR *pcReadBuffer = NULL;
    int ilen = 0;
    int isize = 0;
    int iret = RET_NG;
    int iretvalue = RET_NG;
    FILE *fpIn = NULL;
    _TCHAR *pcur = NULL;
    _TCHAR *pend = NULL;
    int bomOffset = 0;
    if ((pcFolderName == NULL) ||
            (pcSourceID == NULL) ||
            (pcFileName == NULL) ||
            (ppcData == NULL)) {
        goto FUNC_END;
    }
    *ppcData = NULL;
    *piSize = 0;
    ilen = _tcslen(pcFolderName) + 1 + _tcslen(pcSourceID) + _tcslen(pcFileName) + 1;
    iret = CDMtrLibUtilMallocW((void **)&pcFile, (ilen + 1) * sizeof(_TCHAR));
    if (iret != RET_OK) {
        goto FUNC_END;
    }
    swprintf_s(pcFile, (ilen + 1), _T("%s%s%s%s"), pcFolderName, FOLDER_SEPALATE, pcSourceID, pcFileName);
    if ((fpIn = _tfopen(pcFile, _T("r, ccs=UTF-8"))) == NULL) {
        goto FUNC_END;
    }
    bomOffset = ftell(fpIn);
    fseek(fpIn, 0L, SEEK_END);
    isize = ftell(fpIn);
    if (isize <= 0) {
        goto FUNC_END;
    }
    fseek(fpIn, bomOffset, SEEK_SET);
    iret = CDMtrLibUtilMallocW((void **)&pcReadBuffer, (isize + 1) * sizeof(_TCHAR));
    if (iret != RET_OK) {
        goto FUNC_END;
    }
    iret = fread(pcReadBuffer, sizeof(_TCHAR), (isize + 1), fpIn);
    if (iret == 0 || ferror(fpIn) || !feof(fpIn)) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000448, pcFile);  //* MSG_LOG_ID_C_00000448
        goto FUNC_END;
    }
    pcur = pcReadBuffer;
    pend = pcur + isize - 1;
    while (pcur <= pend) {
        if (*pcur == _T('\n')) {
            *pcur = _T('\0');
            pcur++;
            break;
        }
        pcur++;
    }
    while (pcur <= pend) {
        switch (*pcur) {
        case _T(','):
        case _T('\n'):
            *pcur = _T('\0');
            break;
        case _T('"'):
            pcur++;
            while (pcur <= pend) {
                if (*pcur == _T('"')) {
                    break;
                }
                pcur++;
            }
            break;
        default:
            break;
        }
        pcur++;
    }
    *piSize = isize;
    *ppcData = pcReadBuffer;
    iretvalue = RET_OK;
FUNC_END:
    if (fpIn != NULL) {
        fclose(fpIn);
    }
    CDMtrLibUtilFreeW((void **)&pcFile);
    if (iretvalue != RET_OK) {
        CDMtrLibUtilFreeW((void **)&pcReadBuffer);
    }
    return iretvalue;
}


/*!
    @brief          1R[hLine񂩂烁gNX̃JEgs
*/
static void cdmtrCntPreFormatLineCount(LINEINFO_T *strLineTbl, OUTINFO_T *strOutTbl)
{
    strOutTbl->iCnt[OUTINFO_STMT] += strLineTbl->iCnt[LINEINFO_STATEMENTS];
    if (strLineTbl->iCnt[LINEINFO_CSV_ELOC_KIND] == LINEDTL_ELOC_KIND_SKIP) {
        strOutTbl->iCnt[OUTINFO_SKIP] += strLineTbl->iCnt[LINEINFO_EFFECTIVE_LINE];
        if (!iSkipChangeFlg) {
            strOutTbl->iCnt[OUTINFO_ELOC] ++;
        }
    } else {
        if (strLineTbl->iCnt[LINEINFO_EFFECTIVE_LINE] == LINEDTL_EFFECTIVE_NONE) {
            if (strLineTbl->iCnt[LINEINFO_COMMENT_LINE] == LINEDTL_COMMENT_LINE) {
                strOutTbl->iCnt[OUTINFO_CLOC]++;
            }
            if (strLineTbl->iCnt[LINEINFO_BLANK_LINE] == LINEDTL_BLANK_LINE) {
                strOutTbl->iCnt[OUTINFO_BLOC]++;
            }
        }
        strOutTbl->iCnt[OUTINFO_ELOC] += strLineTbl->iCnt[LINEINFO_EFFECTIVE_LINE];
        strOutTbl->iCnt[OUTINFO_CYCLO] += strLineTbl->iCnt[LINEINFO_CONTROL_STATEMENTS];
        strOutTbl->iCnt[OUTINFO_CYCLOWC] += strLineTbl->iCnt[LINEINFO_CYCLOWC];
        strOutTbl->iCnt[OUTINFO_BRANCHS] += strLineTbl->iCnt[LINEINFO_BRANCHS];
        strOutTbl->iCnt[OUTINFO_CNDOPS] += strLineTbl->iCnt[LINEINFO_CNDOPS];
        if (strOutTbl->iCnt[OUTINFO_NESTS] < strLineTbl->iCnt[LINEINFO_NEST_LEVEL]) {
            strOutTbl->iCnt[OUTINFO_NESTS] = strLineTbl->iCnt[LINEINFO_NEST_LEVEL];
        }
    }
    return ;
}

/*!
    @brief      sԍLinẽ}[WA܂́AWv{
*/
static void cdmtrCntPreFormatLineTbl(int iOldLine,
                                     LINEINFO_T *pLineTbl,
                                     LINEINFO_T *pCurLineTbl,
                                     OUTINFO_T *pOutTbl)
{
    if (iOldLine == 0 ) {
        memcpy(pLineTbl, pCurLineTbl, sizeof(LINEINFO_T));
    } else if (iOldLine == pCurLineTbl->iCnt[LINEINFO_LINE_NUMBER]) {
        cdmtrCntPreFormatLineMerge(pLineTbl, pCurLineTbl);
    } else {
        cdmtrCntPreFormatLineCount(pLineTbl, pOutTbl);
        memcpy(pLineTbl, pCurLineTbl, sizeof(LINEINFO_T));
    }
    return;
}


/*!
    @brief          Linẽ}[Ws
*/
static void cdmtrCntPreFormatLineMerge(LINEINFO_T *pLineTbl,
                                       LINEINFO_T *pCurLineTbl)
{
    int i;
    for (i = 0; i < LINEINFO_CSV_END; i++) {
        switch (i) {
        case LINEINFO_CSV_EFFECTIVE_LINE:
        case LINEINFO_CSV_COMMENT_LINE:
        case LINEINFO_CSV_BLANK_LINE:
            pLineTbl->iCnt[i] |=  pCurLineTbl->iCnt[i];
            break;
        case LINEINFO_CSV_STATEMENTS:
        case LINEINFO_CSV_CONTROL_STATEMENTS:
        case LINEINFO_CSV_CYCLOWC:
        case LINEINFO_CSV_BRANCHES:
        case LINEINFO_CSV_CNDOPS:
            pLineTbl->iCnt[i] += pCurLineTbl->iCnt[i];
            break;
        case LINEINFO_CSV_NEST_LEVEL:
            if (pLineTbl->iCnt[i] < pCurLineTbl->iCnt[i]) {
                pLineTbl->iCnt[i] = pCurLineTbl->iCnt[i];
            }
            break;
        case LINEINFO_CSV_LINE_NUMBER:
        default:
            break;
        }
    }
    return;
}


/*!
    @brief      茋ʂt@C(metric.csv)ɏo͂
*/
static void cdmtrOutputCSV(FILE *fp,
                           _TCHAR *pcDirPath,
                           _TCHAR *pcFName,
                           _TCHAR *pcLangName,
                           FUNCINFO_T *pFuncTbl,
                           OUTINFO_T *pOutTbl
                          )
{
    int ilen = 0;
    _TCHAR *ptBuffer = NULL;
    _ftprintf(fp, _T("\"%s\","), pcDirPath);
    _ftprintf(fp, _T("\"%s\","), pcFName);
    _ftprintf(fp, _T("\""));
    ptBuffer = CDMtrLibUtilCopyString(pFuncTbl->pcStr[FUNCINFO_FUNC_NAME]);
    if (ptBuffer != NULL) {
        ilen = _tcslen(ptBuffer);
        if (ilen > 2) {
            *(ptBuffer + ilen - 1) = '\0';
            _ftprintf(fp, _T("%s"), ptBuffer + 1);
            CDMtrLibUtilFreeW((void **)&ptBuffer);
        }
    }
    if (_tcscmp(pcFuncOpt, FUNC_OPTION_NONE) != 0) {
        ptBuffer = CDMtrLibUtilCopyString(pFuncTbl->pcStr[FUNCINFO_PARAM_NAME]);
        if (ptBuffer != NULL) {
            ilen = _tcslen(ptBuffer);
            if (ilen > 2) {
                *(ptBuffer + ilen - 1) = '\0';
                _ftprintf(fp, _T("%s"), ptBuffer + 1);
                CDMtrLibUtilFreeW((void **)&ptBuffer);
            }
        }
    }
    _ftprintf(fp, _T("\","));
    _ftprintf(fp, _T("%s,"), pcLangName);
    _ftprintf(fp, _T("%d,"), pOutTbl->iCnt[OUTINFO_FLOC]);
    _ftprintf(fp, _T("%d,"), pOutTbl->iCnt[OUTINFO_ELOC]);
    _ftprintf(fp, _T("%d,"), pOutTbl->iCnt[OUTINFO_CLOC]);
    _ftprintf(fp, _T("%d,"), pOutTbl->iCnt[OUTINFO_BLOC]);
    _ftprintf(fp, _T("%d,"), pOutTbl->iCnt[OUTINFO_CYCLO]);
    _ftprintf(fp, _T("%d,"), pOutTbl->iCnt[OUTINFO_CYCLOWC]);
    _ftprintf(fp, _T("%d,"), pOutTbl->iCnt[OUTINFO_BRANCHS]);
    _ftprintf(fp, _T("%d,"), pOutTbl->iCnt[OUTINFO_CNDOPS]);
    _ftprintf(fp, _T("%d,"), pOutTbl->iCnt[OUTINFO_NESTS]);
    _ftprintf(fp, _T("-,"));
    _ftprintf(fp, _T("-,"));
    _ftprintf(fp, _T("-,"));
    _ftprintf(fp, _T("-"));
    _ftprintf(fp, _T("\n"));
    return;
}
