/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <tchar.h>

#include "CDMtrCmn.h"
#include "CDMtrExtCmn.h"
#include "CDMtrLibFileW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrLibSystemW.h"
#include "CDMtrLibOptW.h"
#include "CDMtrCntMain.h"
#include "CDMtrCntLang.h"
#include "CDMtrCntFunc.h"
#include "CDMtrCntCallProc.h"
#include "CDMtrCntPreFormat.h"
#include "CDMtrCntXrefDataUtil.h"
#include "CDMtrCntStructure.h"
#include "CDMtrCntLog.h"
#include "CDMtrCntOutputCSV.h"
#include "CDMtrCntExtTool.h"
#include "CDMtrCntFanIO.h"
#include "CDMtrCntLineCount.h"
#include "CDMtrSps.h"
#include "CDMtrMessage.h"

/*----------------------------------------------------------------------------*/
/* static function declaration                                                */
/*----------------------------------------------------------------------------*/
static int cdmtrCntStructureDoStruct(_TCHAR *pcFileName);
static int cdmtrCntStructureCheckLangType(int *piShortPathFlag, int *piCharsetFlg, _DoStruct *ptParam);
static int cdmtrCntStructureCodeMetricsJAVA(_DoStruct *ptParam);
static int cdmtrCntStructureCodeMetricsCS(_DoStruct *ptParam);
static void cdmtrCntStructureCodeMetricsVB(_DoStruct *ptParam);
static void cdmtrCntStructureCodeMetricsJS(_TCHAR *pcFileName, _DoStruct *ptParam);
static int cdmtrCntStructureCodeMetricsSimple(_DoStruct *ptParam);
static int cdmtrCntStructureCodeMetricsStandard(_TCHAR *pcFileName, _DoStruct *ptParam);

/*----------------------------------------------------------------------------*/
/* global function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief      \gNX𑪒肷
*/
int CDMtrCntStructureDoStructProcess(_FileList *pcFileName)
{
    int iRet = RET_NG;
    int iFuncRet;
    int i, j;
    _FileList *pFileList = NULL;
    int iLangType;
    fanCounterList *pFanCountList = NULL;
    _TCHAR *pcMergeFile = NULL;
    const _TCHAR *pcFileNameLogOut = NULL;
    CDMtrLibUtilFreeW((void **)&pcTempFio);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcTempFio, pcTempFolderName, FOLDER_SEPALATE, TEMP_FILE_FIO, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    CDMtrLibUtilFreeW((void **)&pcTempXref);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcTempXref, pcTempFolderName, FOLDER_SEPALATE, TEMP_FILE_XREF, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    for (j = 0; j < pcFileName->count; j++) {
        iFuncRet = CDMtrLibFileGetFileList(pcFileName->filename[j], &pFileList);
        pcFileNameLogOut = CDMtrLibFileRemoveLongPathMarkW(pcFileName->filename[j]);
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000148, pcFileNameLogOut); //* MSG_LOG_ID_C_00000148
            goto FUNC_END;
        }
        if (pFileList->count == 0) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000149, pcFileNameLogOut); //* MSG_LOG_ID_C_00000149
        } else {
            for (i = 0; i < pFileList->count; i++) {
                iFuncRet = cdmtrCntStructureDoStruct(pFileList->filename[i]);
                if (iFuncRet == RET_NG) {
                }
            }
        }
        if (pFileList != NULL) {
            CDMtrLibFileFreeFileList(&pFileList);
            pFileList = NULL;
        }
    }
#ifndef OSS
    if (iStructMode == OPTION_STRUCT_STD && giFANIOMode == CDMTR_TRUE) {
        pFanCountList = (fanCounterList *) calloc(1, sizeof(fanCounterList));
        if (pFanCountList == NULL) {
            goto FUNC_END;
        }
        iFuncRet = CDMtrCntFanIOMain(pcTempXref, pFanCountList);
        if (iFuncRet != RET_OK) {
            pFanCountList->iListSize = 0;
        }
        CDMtrLibUtilFreeW((void **)&pcMergeFile);
        iFuncRet = CDMtrLibUtilCreateStringW(&pcMergeFile, pcTempFolderName, FOLDER_SEPALATE, TEMP_MERGE, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        iFuncRet = CDMtrCntXrefMerge(pcTempFio, pFanCountList, pcMergeFile);
        if (iFuncRet == RET_OK) {
            iLangType = 0;
            iFuncRet = CDMtrCntOutputCSVStructFileToOutFile(pcMergeFile, iLangType);
        }
    }
#endif //OSS
    iRet = RET_OK;
FUNC_END:
    if (pFileList != NULL) {
        CDMtrLibFileFreeFileList(&pFileList);
        pFileList = NULL;
    }
    CDMtrLibUtilFreeW((void **)&pcTempFio);
    CDMtrLibUtilFreeW((void **)&pcTempXref);
    CDMtrLibUtilFreeW((void **)&pcMergeFile);
    CDMtrCntXrefDataUtilFreeAllXrefTables();
    if (pFanCountList != NULL) {
        free(pFanCountList);
    }
    return iRet;
}

/*!
    @brief          \gNX̑茋ʂ̊mFNESTS␳s
*/
int CDMtrCntStructureStructRecordCheckAndMod(_TCHAR *pcBuffer)
{
    int iRet = RET_NG;
    int iItem = STRUCT_ITEM_NUM_FIFO;
    int iLen = 0;
    int iLenNew = 0;
    int iNests = 0;
    _TCHAR *p = NULL;
    _TCHAR *pcNestsPos = NULL;
    _TCHAR cNestsStr[STRUCT_NESTS_STR_LEN];
    if (pcBuffer == NULL) {
        return iRet;
    }
    p = &(pcBuffer[_tcslen(pcBuffer) - 1]);
    for (; p != pcBuffer; p--) {
        if (*p != _T(',')) {
            continue;
        }
        iItem--;
        if (iItem <= STRUCT_ITEM_DIR) {
            break;
        } else if (iItem == STRUCT_ITEM_NESTS) {
            pcNestsPos = p;
        } else if (iItem == (STRUCT_ITEM_NESTS - 1)) {
            iLen = pcNestsPos - p - 1;
            if ((iNestsCount != NUM_NESTS_COUNT_INNERBLOCK) || (iLen <= 0) || (iLen >= STRUCT_NESTS_STR_LEN)) {
                continue;
            }
            _tcsncpy(cNestsStr, p + 1, iLen);
            cNestsStr[iLen] = _T('\0');
            errno = 0;
            iNests = _ttoi(cNestsStr);
            if ((errno != 0) || (iNests <= 0)) {
                continue;
            }
            iNests--;
            memset(cNestsStr, 0x00, STRUCT_NESTS_STR_LEN);
            if (_itot_s(iNests, cNestsStr, STRUCT_NESTS_STR_LEN, 10) != 0) {
                goto FUNC_END;
            }
            iLenNew = _tcslen(cNestsStr);
            _tcsncpy((p + 1), cNestsStr, iLenNew);
            if (iLen != iLenNew) {
                _tcscpy((p + 1 + iLenNew), pcNestsPos);
            }
        }
    }
    if (iItem <= STRUCT_ITEM_DIR) {
        iRet = RET_OK;
    } else {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000168); //* MSG_LOG_ID_C_00000168
    }
FUNC_END:
    return iRet;
}

/*----------------------------------------------------------------------------*/
/* static function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief      \gNX𑪒肷(Pt@C̑)
*/
static int cdmtrCntStructureDoStruct(_TCHAR *pcFileName)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    int iShortPathFlag = CDMTR_TRUE;
    unsigned int uiLenName = 0;
    int iCharsetFlg = CDMTR_FALSE;
    int iOldNumOfSuccess = iNumOfSuccess;
    _DoStruct tParam;

    memset(&tParam, 0, sizeof(_DoStruct));

    tParam.pcFileNameLogOut = CDMtrLibFileRemoveLongPathMarkW(pcFileName);
    giStmtMode = CDMTR_FALSE;
    tParam.pcOptionDebug = _T(" ");
    tParam.pcOptionDebug2 = _T(" ");

    /** Oo͗pt@CpXݒ肵ďo͂s */
    CDMtrLibCmnSetTargetName(tParam.pcFileNameLogOut);
    iSourceID++;
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000253); //* MSG_LOG_ID_C_00000253
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000254, tParam.pcFileNameLogOut); //* MSG_LOG_ID_C_00000254
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000255, iSourceID); //* MSG_LOG_ID_C_00000255
    }

    /** t@C擾 */
    uiLenName = _tcslen(pcFileName);
    iFuncRet = CDMtrLibUtilMallocW((void **) & (tParam.pcFName), (uiLenName + 1) * sizeof(_TCHAR));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibFileGetFileName(pcFileName, tParam.pcFName);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** ʂ擾Ďʖ̏s */
    tParam.iLangType = CDMtrCntLangGetTypeFromFileName(giExceptBinaryMode, pcFileName, &(tParam.pcLangName));
    globaliLangType = tParam.iLangType;
    iFuncRet = cdmtrCntStructureCheckLangType(&iShortPathFlag, &iCharsetFlg, &tParam);
    if (iFuncRet != RET_OK) {
        if (iFuncRet == RET_SKIP) {
            iRet = RET_OK;
        }
        goto FUNC_END;
    }

    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000260, tParam.pcFName); //* MSG_LOG_ID_C_00000260
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000261, tParam.pcLangName); //* MSG_LOG_ID_C_00000261
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000262, tParam.iLangType); //* MSG_LOG_ID_C_00000262
    }

    /** WG[o͗pt@CpX쐬 */
    iFuncRet = CDMtrLibUtilCreateStringW(&(tParam.pcErrOutFile),
                                         pcTempFolderName,
                                         FOLDER_SEPALATE,
                                         TEMP_FILE_ERROUTPUT,
                                         NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    iFuncRet = CDMtrLibUtilMallocW((void **) & (tParam.pcDirPath), (_tcslen(tParam.pcFileNameLogOut) + 1) * sizeof(_TCHAR));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    iFuncRet = CDMtrLibFileGetDirName(tParam.pcFileNameLogOut, tParam.pcDirPath);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** ς݃t@CJEg */
    iNumOfFiles++;
    if (iShowDetails == DETAILS_SHOW) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000263, tParam.pcFileNameLogOut); //* MSG_LOG_ID_C_00000263
    }

    /** NKFs */
    iFuncRet = CDMtrCntExtToolExecNkf(pcFileName, DIFF_NONE, tParam.iLangType, iShortPathFlag, iCharsetFlg, &(tParam.pcNkfFile), tParam.pcErrOutFile);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    /* NKF̃t@C\ */
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000264, tParam.pcNkfFile); //* MSG_LOG_ID_C_00000264
    }

    /** \[X`Kvȏꍇ͎{ */
    if (CDMtrCntExtToolIsExecBeautifier(tParam.iLangType) && tParam.iLangType != LANG_TYPE_JAVA) {
        iFuncRet = CDMtrCntExtToolExecBeautifier(DIFF_NONE, tParam.pcLangName, &(tParam.pcNkfFile), tParam.pcErrOutFile);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }

    /** CJE^p̃e|t@C쐬 */
    CDMtrLibUtilFreeW((void **) & (tParam.pcResultFile));
    iFuncRet = CDMtrLibUtilCreateStringW(&(tParam.pcResultFile), pcTempFolderName, FOLDER_SEPALATE, TEMP_FILE5, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    if (tParam.iLangType == LANG_TYPE_JAVA) {
        /** JAVAΉR[hgNXs */
        iFuncRet = cdmtrCntStructureCodeMetricsJAVA(&tParam);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    } else if (tParam.iLangType == LANG_TYPE_CS) {
        /** C#ΉR[hgNXs */
        iFuncRet = cdmtrCntStructureCodeMetricsCS(&tParam);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    } else if (tParam.iLangType == LANG_TYPE_VB) {
        /** VBΉR[hgNXs */
        cdmtrCntStructureCodeMetricsVB(&tParam);
    } else if (tParam.iLangType == LANG_TYPE_JS) {
        /** JavaScriptΉR[hgNXs */
        cdmtrCntStructureCodeMetricsJS(pcFileName, &tParam);
    } else {
        if (iStructMode == OPTION_STRUCT_SMP) {
            /** C/C++ΉR[hgNXs(ȈՃp[T) */
            iFuncRet = cdmtrCntStructureCodeMetricsSimple(&tParam);
#ifndef OSS
        } else if (iStructMode == OPTION_STRUCT_STD) {
            /** C/C++ΉR[hgNXs(Wp[T) */
            iFuncRet = cdmtrCntStructureCodeMetricsStandard(pcFileName, &tParam);
#endif //OSS
        }
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }

    if (iNumOfSuccess > iOldNumOfSuccess ) {
#ifndef OSS
        if (iStructMode == OPTION_STRUCT_STD && giFANIOMode == CDMTR_TRUE) {
            /** FANIOΉ */
            iFuncRet = CDMtrCntFanIOStructFileToFanTempFile(tParam.pcResultFile, tParam.iLangType);
            if (iFuncRet == RET_NG) {
                goto FUNC_END;
            }
        } else {
#endif //OSS
            /** ʂo͂ */
            iFuncRet = CDMtrCntOutputCSVStructFileToOutFile(tParam.pcResultFile, tParam.iLangType);
            if (iFuncRet == RET_NG) {
                goto FUNC_END;
            }
#ifndef OSS
        }
#endif //OSS
        iRet = RET_OK;
    }
FUNC_END:
    if (iRet != RET_OK) {
#ifndef OSS
        if (iStructMode == OPTION_STRUCT_STD && giFANIOMode == CDMTR_TRUE) {
            CDMtrCntFanIOErrFileToFanTempFile(tParam.pcFileNameLogOut, tParam.pcLangName);
        } else {
#endif //OSS
            CDMtrCntOutputCSVErrFileToOutFile(tParam.pcFileNameLogOut, tParam.pcLangName);
#ifndef OSS
        }
#endif //OSS
    }
    CDMtrLibCmnClearTargetName();
    CDMtrLibUtilFreeW((void **) & (tParam.pcNkfFile));
    CDMtrLibUtilFreeW((void **) & (tParam.pcResultFile));
    CDMtrLibUtilFreeW((void **) & (tParam.pcOptionCharset));
    CDMtrLibUtilFreeW((void **) & (tParam.pcDirPath));
    CDMtrLibUtilFreeW((void **) & (tParam.pcFName));
    CDMtrLibUtilFreeW((void **) & (tParam.pcLangName));
    CDMtrLibUtilFreeW((void **) & (tParam.pcErrOutFile));
    return iRet;
}

/*!
    @brief          \gNX̌ʂ𔻒f
*/
static int cdmtrCntStructureCheckLangType(int *piShortPathFlag, int *piCharsetFlg, _DoStruct *ptParam)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;

    switch (ptParam->iLangType) {
    case LANG_TYPE_CPP:
        /** CPP[hŎs */
        ptParam->pcLangOpt = EDG_OPT_CPP;
        /** --debug2IvVǉB */
        if (iSpsDebug == DEBUG_ON) {
            ptParam->pcOptionDebug2 = STRUCT_OPTION_DEBUG2;
        }
        break;
    case LANG_TYPE_C:
        /** C[hŎs */
        ptParam->pcLangOpt = EDG_OPT_C;
        /** --debug2IvVǉB */
        if (iSpsDebug == DEBUG_ON) {
            ptParam->pcOptionDebug2 = STRUCT_OPTION_DEBUG2;
        }
        break;
    case LANG_TYPE_CS:
        *piShortPathFlag = CDMTR_FALSE;
    case LANG_TYPE_JAVA:
    case LANG_TYPE_JS:
#if NEED_SOURCE_ID
        _stprintf(chSourceID, SOURCEID_FMT, iSourceID);
#endif
        /** charset w̗LmF */
        if (pcCharSet != NULL) {
            /** R[h̃IvVw肷 */
            iFuncRet = CDMtrLibUtilCreateStringW(&(ptParam->pcOptionCharset), _T(" --charset \""),
                                                 pcCharSet, _T("\" "), NULL);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            *piCharsetFlg = CDMTR_TRUE;
        } else {
            /** ftHgCHARSETݒ肷 */
            iFuncRet = CDMtrLibUtilCreateStringW(&(ptParam->pcOptionCharset), _T(" --charset \""),
                                                 STRUCT_DEFAULT_CHARSET, _T("\" "), NULL);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
        }

        /** --debugIvVǉB */
        if (iDebug == DEBUG_ON) {
            ptParam->pcOptionDebug = STRUCT_OPTION_DEBUG;
        }

        /** --debug2IvVǉB */
        if (iSpsDebug == DEBUG_ON) {
            ptParam->pcOptionDebug2 = STRUCT_OPTION_DEBUG2;
        }
        break;
    case LANG_TYPE_VB:
#if NEED_SOURCE_ID
        _stprintf(chSourceID, SOURCEID_FMT, iSourceID);
#endif
        /** --debugIvVǉB */
        if (iDebug == DEBUG_ON) {
            ptParam->pcOptionDebug = STRUCT_OPTION_DEBUG;
        }

        /** --debug2IvVǉB */
        if (iSpsDebug == DEBUG_ON) {
            ptParam->pcOptionDebug2 = STRUCT_OPTION_DEBUG2;
        }
        break;
    case LANG_TYPE_CPPH:
    case LANG_TYPE_CH:
    case LANG_TYPE_TXT:
    case LANG_TYPE_ETC:
        /** XLbv */
        if (iShowDetails == DETAILS_SHOW) {
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000257, ptParam->pcFileNameLogOut); //* MSG_LOG_ID_C_00000257
        }
        iRet = RET_SKIP;
        goto FUNC_END;
        break;
    case LANG_TYPE_BIN:
        /** XLbv */
        if (iShowDetails == DETAILS_SHOW) {
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000258, ptParam->pcFileNameLogOut); //* MSG_LOG_ID_C_00000258
        }
        iRet = RET_SKIP;
        goto FUNC_END;
        break;
    case LANG_TYPE_UNKNOW:
    default:
        /** XLbv */
        if (iShowDetails == DETAILS_SHOW) {
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000259, ptParam->pcFileNameLogOut); //* MSG_LOG_ID_C_00000259
        }
        iRet = RET_SKIP;
        goto FUNC_END;
        break;
    }
    iRet = RET_OK;

FUNC_END:
    return iRet;
}

/*!
    @brief          \gNX𑪒肷(JAVA)
*/
static int cdmtrCntStructureCodeMetricsJAVA(_DoStruct *ptParam)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    _TCHAR *pcCommand = NULL;
    _TCHAR *pcWorkPath = NULL;
    const _TCHAR *pcTargetFilePath = NULL;
    const _TCHAR *pcOptTargetFilePath = NULL;

    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000265); //* MSG_LOG_ID_C_00000265
    }
    CDMtrLibUtilFreeW((void **)&pcCommand);

    /** \gNXs */
    iFuncRet = CDMtrLibUtilUNICODEtoBYTEW(&pcWorkPath, (wchar_t **) & (ptParam->pcFileNameLogOut));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    } else {
        pcTargetFilePath = pcWorkPath;
        pcOptTargetFilePath = STRUCT_JAVA_OPT_HEXFILE;
    }

    /** R}h쐬 */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcCommand,
                                         pcStructJAVAPath,
                                         ptParam->pcOptionDebug, ptParam->pcOptionDebug2,
                                         _T(" --comp_opt "), gpcCompTypeForJava,
                                         _T(" --func_opt "), pcFuncOpt,
                                         _T(" --error_output \""), ptParam->pcErrOutFile,
                                         _T("\" --metric_file \""), ptParam->pcResultFile,
                                         _T("\" "), ptParam->pcOptionCharset , _T(" \""),
                                         ptParam->pcNkfFile,
                                         pcOptTargetFilePath, pcTargetFilePath,
                                         _T("\""),
                                         NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** 쐬R}hs */
    iFuncRet = CDMtrCntCallCreateProcess(STRUCT_JAVA, pcCommand, NULL, NULL, NULL);
    if (iDebug == DEBUG_ON || iSpsDebug == DEBUG_ON) {
        CDMtrCntLogLogOutErrExec(ptParam->pcErrOutFile);
    }
    if (iFuncRet != RET_OK) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000151, pcStructJAVAPath); //* MSG_LOG_ID_C_00000151
        iFuncRet = CDMtrCntCallJavaVersion(pcJAVAExeVersion, ptParam->pcErrOutFile);
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000266); //* MSG_LOG_ID_C_00000266
        } else {
            CDMtrCntMainShowFile(ptParam->pcErrOutFile);
        }
    } else {
        iNumOfSuccess++;
    }

    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcCommand);
    CDMtrLibUtilFreeW((void **)&pcWorkPath);
    return iRet;
}

/*!
    @brief          \gNX𑪒肷(C#)
*/
static int cdmtrCntStructureCodeMetricsCS(_DoStruct *ptParam)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    _TCHAR *pcCommand = NULL;

    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000267); //* MSG_LOG_ID_C_00000267
    }
    CDMtrLibUtilFreeW((void **)&pcCommand);

    /** R}h쐬 */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcCommand,
                                         pcStructCSPath,
                                         ptParam->pcOptionDebug, ptParam->pcOptionDebug2,
                                         _T(" --error_output \""), ptParam->pcErrOutFile,
                                         _T("\" --metric_file \""), ptParam->pcResultFile,
                                         _T("\" --target_file_path \""), ptParam->pcFileNameLogOut,
                                         _T("\" --skip \""), pcSkip,
                                         _T("\" --func_opt \""), pcFuncOpt,
                                         _T("\" "), ptParam->pcOptionCharset , _T(" \""),
                                         ptParam->pcNkfFile,
                                         _T("\""),
                                         NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** 쐬R}hs */
    iFuncRet = CDMtrCntCallCreateProcess(STRUCT_CS, pcCommand, NULL, NULL, NULL);
    if (iDebug == DEBUG_ON || iSpsDebug == DEBUG_ON) {
        CDMtrCntLogLogOutErrExec(ptParam->pcErrOutFile);
    }
    if (iFuncRet != RET_OK) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000152, pcStructCSPath); //* MSG_LOG_ID_C_00000152
    } else {
        iNumOfSuccess++;
    }

    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcCommand);
    return iRet;
}

/*!
    @brief          \gNX𑪒肷(VisualBasic)
*/
static void cdmtrCntStructureCodeMetricsVB(_DoStruct *ptParam)
{
    int iFuncRet = RET_NG;

    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000268); //* MSG_LOG_ID_C_00000268
    }

    /** \gNXs */
    iFuncRet = CDMtrCntCallVBParser(pcStructVBPath,
                                    ptParam->pcOptionDebug, ptParam->pcOptionDebug2,
                                    ptParam->pcErrOutFile,
                                    pcTempFolderName,
                                    ptParam->pcNkfFile,
                                    chSourceID);
    if (iDebug == DEBUG_ON || iSpsDebug == DEBUG_ON) {
        CDMtrCntLogLogOutErrExec(ptParam->pcErrOutFile);
    }
    if (iFuncRet != RET_OK) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000153, pcStructVBPath); //* MSG_LOG_ID_C_00000153
    } else {
        /** Wvs */
        iFuncRet = CDMtrCntPreFormatAggregate(pcTempFolderName,
                                              chSourceID,
                                              ptParam->pcDirPath,
                                              ptParam->pcFName,
                                              ptParam->pcLangName,
                                              ptParam->pcResultFile,
                                              ptParam->iLangType);
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000154, ptParam->pcFileNameLogOut); //* MSG_LOG_ID_C_00000154
        } else {
            iNumOfSuccess++;
        }
    }
    return;
}

/*!
    @brief          \gNX𑪒肷(JavaScript)
*/
static void cdmtrCntStructureCodeMetricsJS(_TCHAR *pcFileName, _DoStruct *ptParam)
{
    int iFuncRet = RET_NG;

    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000269); //* MSG_LOG_ID_C_00000269
    }

    /** \gNXs */
    iFuncRet = CDMtrCntCallJSParser(pcStructJSPath,
                                    ptParam->pcOptionDebug, ptParam->pcOptionDebug2,
                                    ptParam->pcErrOutFile,
                                    pcTempFolderName,
                                    pcFileName,
                                    chSourceID,
                                    ptParam->pcOptionCharset,
                                    ptParam->pcNkfFile);
    if (iDebug == DEBUG_ON || iSpsDebug == DEBUG_ON) {
        CDMtrCntLogLogOutErrExec(ptParam->pcErrOutFile);
    }
    if (iFuncRet != RET_OK) {
        /** JAVAsVersion\pR}h쐬 */
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000155, pcStructJSPath); //* MSG_LOG_ID_C_00000155
        iFuncRet = CDMtrCntCallJavaVersion(pcJAVAExeVersion, ptParam->pcErrOutFile);
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000270); //* MSG_LOG_ID_C_00000270
        } else {
            CDMtrCntMainShowFile(ptParam->pcErrOutFile);
        }
    } else {
        /** Wvs */
        iFuncRet = CDMtrCntPreFormatAggregate(pcTempFolderName,
                                              chSourceID,
                                              ptParam->pcDirPath,
                                              ptParam->pcFName,
                                              ptParam->pcLangName,
                                              ptParam->pcResultFile,
                                              ptParam->iLangType);
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000156, ptParam->pcFileNameLogOut); //* MSG_LOG_ID_C_00000156
        } else {
            iNumOfSuccess++;
        }
    }
}

/*!
    @brief          \gNX𑪒肷(C/C++(Ȉ))
*/
static int cdmtrCntStructureCodeMetricsSimple(_DoStruct *ptParam)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    int iCntLangType = 0;
    _TCHAR langTypeBuf[8] = {0};
    _TCHAR *pcCommand = NULL;

    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000271); //* MSG_LOG_ID_C_00000271
    }

    iCntLangType = SPS_LANG_TYPE_CPP;
    if (ptParam->iLangType == LANG_TYPE_C) {
        iCntLangType = SPS_LANG_TYPE_C;
    }
    iFuncRet = _itot_s(iCntLangType, langTypeBuf, sizeof(langTypeBuf) / sizeof(_TCHAR), 10);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** R}h쐬 */
    CDMtrLibUtilFreeW((void **)&pcCommand);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcCommand,
                                         pcStructSmpPath,
                                         ptParam->pcOptionDebug2,
                                         _T(" --lang_name \""), ptParam->pcLangName,
                                         _T("\" --lang_type \""), &langTypeBuf,
                                         _T("\" --file_path \""), ptParam->pcDirPath,
                                         _T("\" --file_name \""), ptParam->pcFName,
                                         _T("\" --metric_file \""), ptParam->pcResultFile,
                                         _T("\" --metric_skip \""), (iSkipChangeFlg == 0) ? _T("old") : _T("new"),
                                         _T("\" --error_output \""), ptParam->pcErrOutFile,
                                         _T("\" --func_opt \""), pcFuncOpt,
                                         _T("\" --qrt_flg \""), (giQrtOutFlg == CDMTR_TRUE) ? _T("EXCEL") : _T("NONE"), _T("\""),
                                         _T(" \""),
                                         ptParam->pcNkfFile,
                                         _T("\""),
                                         NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** 쐬R}hs */
    iFuncRet = CDMtrCntCallCreateProcess(STRUCT_SMP, pcCommand, NULL, NULL, NULL);
    if (iDebug == DEBUG_ON || iSpsDebug == DEBUG_ON) {
        CDMtrCntLogLogOutErrExec(ptParam->pcErrOutFile);
    }
    if (iFuncRet != RET_OK) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000157, pcStructSmpPath); //* MSG_LOG_ID_C_00000157
    } else {
        iNumOfSuccess++;
    }

    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcCommand);
    return iRet;
}

/*!
    @brief          \gNX𑪒肷(C/C++(W))
*/
static int cdmtrCntStructureCodeMetricsStandard(_TCHAR *pcFileName, _DoStruct *ptParam)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    int iExitCode = RET_OK;
    _TCHAR *pcCommand = NULL;
    _TCHAR *pcWorkPath = NULL;
    _TCHAR *pcIncDir = NULL;

    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000272); //* MSG_LOG_ID_C_00000272
    }
    CDMtrLibUtilFreeW((void **)&pcCommand);

    /** ΏۃpX̃fBNgpX擾 */
    iFuncRet = CDMtrLibUtilMallocW((void **)&pcWorkPath, (_tcslen(pcFileName) + 1) * sizeof(_TCHAR));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibFileGetDirName(pcFileName, pcWorkPath);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** \gNXs */
    iFuncRet = CDMtrLibFileGetShortPathWithinMaxpathW(pcWorkPath, &pcIncDir);
    if (iFuncRet != RET_OK) {
        pcIncDir = ptParam->pcDirPath;
        ptParam->pcDirPath = NULL;
    }

    /** R}h쐬 */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcCommand,
                                         pcStructPath,
                                         OPTION_SEP_SPACE,
                                         gpcCompOpt,
                                         OPTION_SEP_SPACE,
                                         ptParam->pcLangOpt,
                                         _T(" -n -X \""),
                                         pcTempFolderName, FOLDER_SEPALATE, _T("test.xref"),
                                         _T("\" --error_output \""), ptParam->pcErrOutFile,
                                         _T("\" --metric_file \""), ptParam->pcResultFile,
                                         _T("\" --target_file_path \""), ptParam->pcFileNameLogOut,
                                         _T("\" --pcXrefFPath \""), pcTempXref,
                                         _T("\" -I\""),
                                         pcIncDir,
                                         _T("\" "),
                                         pcKnownOpts,
                                         OPTION_SEP_SPACE,
                                         gpcSysInc,
                                         OPTION_SEP_SPACE,
                                         _T(" --metrics_skip "), pcSkip,
                                         _T(" --metrics_func_opt "), pcFuncOpt,
                                         _T(" \""),
                                         ptParam->pcNkfFile,
                                         _T("\""),
                                         NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** 쐬R}hs */
    iFuncRet = CDMtrCntCallCreateProcess(STRUCT, pcCommand, NULL, NULL, &iExitCode);
    if (iFuncRet != RET_OK) {
        if (iDebug == DEBUG_ON) {
            CDMtrCntLogLogOutErrExec(ptParam->pcErrOutFile);
        }
        if (iExitCode == RET_FAIL_XREF) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000158, pcStructPath); //* MSG_LOG_ID_C_00000158
            iNumOfSuccess++;
        } else {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000159, pcStructPath); //* MSG_LOG_ID_C_00000159
        }
    } else {
        iNumOfSuccess++;
    }

    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcCommand);
    CDMtrLibUtilFreeW((void **)&pcWorkPath);
    CDMtrLibUtilFreeW((void **)&pcIncDir);
    return iRet;
}
