/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "CDMtrExtCmn.h"
#include "CDMtrExtMain.h"
#include "CDMtrExtLine.h"
#include "CDMtrExtTake.h"
#include "CDMtrLibCmnW.h"
#include "CDMtrLibFileW.h"
#include "CDMtrLibUtilW.h"

#define OUTPUT_DOUBLE_QUOTE _T("\"")
#define OUTPUT_BLEAK_LINE _T("\n")
#define OUTPUT_MARK_FORMAT _T("%s\"%s\"\n")

extern FILE *fp_diff_ret_file;

/*!
    @brief          sڍ׃}[NĕWo
*/
int CDMtrExtTakeStdOutMark(int iBlank, const _TCHAR *pcMark, const _TCHAR *pcBuff)
{
    int iRet;
    unsigned int uiStart, uiEnd;
    unsigned int uiLength;
    _TCHAR *pcStart, *pcEnd;
    char *cTempBuffer = NULL;
    iRet = RET_NG;
    if (pcMark == NULL || pcBuff == NULL) {
        goto FUNC_END;
    }
    pcStart = (_TCHAR *)pcBuff;
    uiEnd = _tcslen(pcBuff);
    pcEnd = (_TCHAR *)(pcBuff + uiEnd);
    if (!gtOptInfo_lc.iDetailBlankFlg) {
        SKIP_WHITE_SPACE(&pcStart);
        while (pcEnd > pcStart) {
            pcEnd--;
            if (!IS_WHITE_SPACE(pcEnd)) {
                pcEnd++;
                break;
            }
        }
    }
    uiStart = pcStart - pcBuff;
    uiEnd = pcEnd - pcBuff;
    uiLength = uiEnd - uiStart;
    if (uiLength == 0) {
        if (!iBlank && !gtOptInfo_lc.iDetailBlankFlg) {
            iRet = RET_OK;
            goto FUNC_END;
        }
    } else {
        pcStart[uiLength] = _T('\0');
    }
    if (iExecuteMode == DIFF_MODE) {
        cTempBuffer = CDMtrLibUtilConvertStringW(ENCODING_UTF_8, OUTPUT_MARK_FORMAT, pcMark, pcStart);
        if (cTempBuffer == NULL) {
            goto FUNC_END;
        }
        if (fputs(cTempBuffer, fp_diff_ret_file) < 0) {
            goto FUNC_END;
        }
    } else {
        cTempBuffer = CDMtrLibUtilConvertStringW(pcLogCodeOpts, OUTPUT_MARK_FORMAT, pcMark, pcStart);
        if (cTempBuffer == NULL) {
            goto FUNC_END;
        }
        if (fputs(cTempBuffer, stdout) < 0) {
            goto FUNC_END;
        }
    }
    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&cTempBuffer);
    return iRet;
}
