/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef CDMTRCMN_H_
#define CDMTRCMN_H_

#ifdef CDMTR_DEBUG
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>
#endif
#include <tchar.h>
#include <windows.h>
#include <mmsystem.h>

#define RET_OK (0)

#define RET_SKIP (2)

#define RET_NG (-1)

#define RET_NOTFOUND_FILE (-2)

#define RET_END_FILE (-3)

#define RET_SHOW_HELP (-4)      //!< wv\
#define RET_CONTINUE (-5)       //!< p

#define RET_TRUE (1)

#define RET_FALSE (0)

#define CDMTR_TRUE (1)

#define CDMTR_FALSE (0)


#define ROW_MODE                1
#define DIFF_MODE               2
#define STRUCT_MODE             3
#define CK_MODE				    4


#define EXEC_ROW_MODE           _T("ROW")
#define EXEC_DIFF_MODE          _T("DIFF")
#define EXEC_DIFF_FILE_MODE     _T("DIFF_FILE")
#define EXEC_DIFF_FUNC_MODE     _T("DIFF_FUNC")
#define EXEC_STRUCT_MODE        _T("STRUCT")
#define EXEC_STRUCT_STD_MODE    _T("STRUCT_STD")
#define EXEC_STRUCT_SMP_MODE    _T("STRUCT_SMP")
#define EXEC_CK_MODE			_T("CK")


#define TEMP_FILE1                  _T("temp1.tmp")
#define TEMP_FILE2                  _T("temp2.tmp")
#define TEMP_FILE3                  _T("temp3.tmp")
#define TEMP_FILE4                  _T("temp4")
#define TEMP_FILE5                  _T("temp5")
#define TEMP_FILE4_BASE             _T("temp4Base")
#define TEMP_FILE4_DIST             _T("temp4Dist")
#define TEMP_FILE_NKF               _T("tempnkf")
#define TEMP_FILE_NKF_BASE          _T("tempnkfBase")
#define TEMP_FILE_NKF_DIST          _T("tempnkfDist")
#define TEMP_FILE_BEAUTIFILE        _T("tempbeauti")
#define TEMP_FILE_BEAUTIFILE_BASE   _T("tempbeautiBase")
#define TEMP_FILE_BEAUTIFILE_DIST   _T("tempbeautiDist")
#define TEMP_FILE_ERROUTPUT         _T("temp_err_output.tmp")
#define TEMP_FILE_LCRESULT          _T("temp_lc_result.tmp")
#define TEMP_FILE_LCRET_BASE        _T("temp_lc_ret_base.tmp")
#define TEMP_FILE_LCRET_DIST        _T("temp_lc_ret_dist.tmp")
#define TEMP_FILE_DIFFRET           _T("temp_diff_ret.tmp")
#define TEMP_FILE_CLASS_PATH        _T("temp_class_path.tmp")
#define TEMP_FILE_OPTCLASS_PATH     _T("temp_optclass_path.tmp")
#define TEMP_FILE_XREF              _T("tempxref")
#define TEMP_FILE_FIO               _T("temp_faninout")
#define TEMP_MERGE                  _T("temp_merge")
#define TEMP_FILE_JAVAEXE_STD       _T("temp_javaexec_std.tmp")
#define TEMP_FILE_JAVAEXE_ERR       _T("temp_javaexec_err.tmp")
#define TEMP_FILE_SOURCE            _T("temp_source")
#define TEMP_FILE_BASE              _T("temp_base")
#define TEMP_FILE_DIST              _T("temp_dist")


#define DIFF_NONE   (-1)
#define DIFF_BASE   0
#define DIFF_DIST   1

#define DETAILS_HIDE            0
#define DETAILS_SHOW            1

#define DEBUG_OFF               0
#define DEBUG_ON                1

#define PERFORMANCE_OFF         0x00
#define PERFORMANCE_LVL1        0x01
#define PERFORMANCE_LVL2        0x02
#define PERFORMANCE_LVL3        0x04
#define PERFORMANCE_LVL4        0x08
#define PERFORMANCE_LVL5        0x10
#define PERFORMANCE_LVL6        0x20
#define PERFORMANCE_LVL7        0x40
#define PERFORMANCE_LVL8        0x80
#define PERFORMANCE_LVLMAX      0xFF
#define MEMORY_LVL1             0x0100
#define MEMORY_LVL2             0x0200
#define MEMORY_LVLMAX           0x0F00

//* MSG_LOG_ID_C_00000496
#define MACRO_PERFORMANCE_PUTLOG(lvl, comment) \
    if(giPerformance & lvl){\
        CDMtrLibCmnLogOut(_T("[PERF],%#x,%.3f,%s\n"),lvl,(float)timeGetTime()/1000,comment);\
    }

extern int iShowDetails ;

extern int iDebug ;

extern long giPerformance ;


#endif
