/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef CDMTREXTCMN_H_
#define CDMTREXTCMN_H_

#include "CDMtrCmn.h"

#include <tchar.h>

#define EXT_SIZE (15)

#define LANG_SIZE (6)

#define CMNT_NUM (32)

#define CMNT_SIZE (31)

#define BUFF_LINE_LENGTH (1024)

#define BUFF_LINE_SIZE (BUFF_LINE_LENGTH*sizeof(_TCHAR))

typedef enum {
    COMMENT_TYPE_NOSET = 0,
    COMMENT_TYPE_LINE,
    COMMENT_TYPE_BLOCK,
} COMMENT_TYPE;


typedef enum {
    LANG_TYPE_UNKNOW = 0,
    LANG_TYPE_CPP,
    LANG_TYPE_CPPH,
    LANG_TYPE_C,
    LANG_TYPE_CH,
    LANG_TYPE_JAVA,
    LANG_TYPE_CLASS,
    LANG_TYPE_JAR,
    LANG_TYPE_CS,
    LANG_TYPE_VB,
    LANG_TYPE_JS,
    LANG_TYPE_TXT,
    LANG_TYPE_BIN,
    LANG_TYPE_ETC,
} LANG_TYPE;


typedef struct tag_LINECOUNT {
    unsigned long ulTLOC;
    unsigned long ulELOC;
    unsigned long ulCLOC;
    unsigned long ulBlank;
    unsigned long ulUndef;
    unsigned long ulICLOC;

    unsigned long ulLine;
    unsigned long ulPre;
    unsigned long ulCmnt;
    unsigned long ulDoc;
}
_LINECOUNT;

typedef struct tag_USRCOMMENT {
    int iType;
    _TCHAR cCmntS[CMNT_SIZE + 1];
    _TCHAR cCmntE[CMNT_SIZE + 1];
}
_USRCOMMENT;

typedef struct tag_COMMENT {
    unsigned int uiNum;
    _USRCOMMENT tCmnt[CMNT_NUM];
}
_COMMENT;

typedef struct tag_OPTINFO {
    int iHeaderFlg;
    int iDocFlg;
    int iCmntCaseFlg;
    int iLangType;
    int iDetailFlg;
    int iDetailBlankFlg;
    int giDebug;
    int iDiffStatusFlg;
    _TCHAR *pcCommandLine;
    _TCHAR *pcInputpath;
    _TCHAR *pcProppath;
    _TCHAR *pcLangName;
    _TCHAR *lc_ret_base;
    _TCHAR *lc_ret_dist;
    _TCHAR *pcDiffFuncPath;
}
_OPTINFO;


typedef struct tag_DIFFDETAIL {
    unsigned long ulEqu;
    unsigned long ulAdd;
    unsigned long ulDel;
    unsigned long ulModAdd;
    unsigned long ulModDel;
} _DIFFDETAIL;

typedef struct tag_DIFFLINES {
    _DIFFDETAIL tDiffTotal;
    _DIFFDETAIL tDiffEloc;
    _DIFFDETAIL tDiffCloc;
    _DIFFDETAIL tDiffBloc;
    _DIFFDETAIL tDiffSkip;
} _DIFFLINES;

typedef struct tag_FUNCDATA {
    long    lID;
    long    lStart;
    long    lEnd;
    long    lNameLen;
    _TCHAR  *pcName;
    _TCHAR  *pcParam;
} _FUNCDATA;

typedef struct tag_LINECOUNT_LIST {
    int         iChkFlg;
    int         iInvalidFlg;
    _FUNCDATA   tFuncData;
    _LINECOUNT  tLCData;
    _DIFFLINES  *ptDiffData;
    struct tag_LINECOUNT_LIST *next;
} _LINECOUNT_LIST;

extern int iExecuteMode;

extern int iSkipChangeFlg;

extern _TCHAR *pcLogCodeOpts;

extern _OPTINFO gtOptInfo_lc;


extern int cdmtrExtMain(_LINECOUNT_LIST *ptLineCountList);

#endif
