/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef CDMTRLIBFILE_H_
#define CDMTRLIBFILE_H_
#include <stdlib.h>
#define FILE_PATH_SIZE (2048)

typedef struct tag_FileList {
    int count;
    char *filename[1];
} _FileList;


extern int iNumOfUnrecognized ;


int CDMtrLibFileGetDirName(const char *pcpath, char *pcdir);
int CDMtrLibFileGetFileName(const char *pcpath, char *pcfile);
int CDMtrLibFileSetDirFileName(const char *pcDir, const char *pcFile, char **ppcPath);
int CDMtrLibFileGetAbsolutePath(const char *pcfile, char **ppcpath);
int CDMtrLibFileIsDir(const char *pcdir);
int CDMtrLibFileIsFile(const char *pcfile);
int CDMtrLibFileGetFileList(const char *pcdir, _FileList **ppflist);
void CDMtrLibFileFreeFileList(_FileList **ppflist);

int CDMtrLibFileCreateDir(const char *pcDirpath);
int CDMtrLibFileDeleteDir(const char *pcDirpath);
int CDMtrLibFileDeleteDirAll(const char *pcDirpath, int iDelFlg);
int CDMtrLibFileDelete(const char *pcTargetfile);
int CDMtrLibFileRename(const char *pcOldPath, const char *pcNewPath);
int CDMtrLibFileCreateTempFile(char **ppcpath);

#endif
