/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <Windows.h>

#include "CDMtrCmn.h"
#include "CDMtrLibCmn.h"
#include "CDMtrLibUtil.h"
#include "CDMtrMessage.h"

#define VAL_STR_FALSE "false"

/*!
    @brief          Delimiter󔒕܂łĎ擾
*/
int CDMtrLibUtilGetStringNextDelimSP(char **string, char **startp,
                                     char **endp, char delimiter)
{
    char *p;
    int iRet = RET_NG;
    if (string == NULL || startp == NULL || endp == NULL) {
        goto FUNC_END;
    }
    if (*string == NULL) {
        goto FUNC_END;
    }
    p = *string;
    *startp = *string;
    *endp = *string;
    while (1) {
        if (*p == delimiter || IS_WHITE_SPACE(p)) {
            *endp = p;
            *string = p;
            iRet = RET_OK;
            goto FUNC_END;
        } else if (IS_NULL_CHAR(p)) {
            break;
        }
        p++;
    }
FUNC_END:
    return iRet;
}


/*!
    @brief          ݍs̈ʒu|C^ = ؂蕶Ƃƒl̃|C^ʒu擾
*/
int CDMtrExtPropGetAttributePos(char **currentp, char **name_top, char **name_end,
                                char **val_top, char **val_end)
{
    char *p, *old_p;
    char *ntop, *nend, *vtop, *vend;
    int iRet;
    iRet = RET_NG;
    ntop = NULL;
    nend = NULL;
    vtop = NULL;
    vend = NULL;
    *name_top = NULL;
    *name_end = NULL;
    *val_top = NULL;
    *val_end = NULL;
    p = *currentp;
    old_p = p;
    ntop = p;
    while (1) {
        if (IS_BREAK_LINE(p) || IS_NULL_CHAR(p)) {
            goto FUNC_END;
        } else if (IS_WHITE_SPACE(p)) {
            SKIP_WHITE_SPACE(&p);
            continue;
        } else if (IS_EQUAL(p)) {
            nend = old_p;
            if (ntop == p) {
                goto FUNC_END;
            }
            p++;
            break;
        }
        old_p = p;
        p++;
    }
    iRet = RET_OK;
    old_p = p;
    SKIP_WHITE_SPACE(&p);
    vtop = p;
    vend = p;
    old_p = p;
    while (1) {
        if (IS_BREAK_LINE(p) || IS_NULL_CHAR(p)) {
            break;
        } else if (IS_WHITE_SPACE(p)) {
            SKIP_WHITE_SPACE(&p);
            continue;
        }
        old_p = p;
        p++;
    }
    if (vtop == p) {
        vtop = NULL;
        vend = NULL;
    } else {
        vend = old_p;
    }
    *currentp = p;
    *name_top = ntop;
    *name_end = nend;
    *val_top = vtop;
    *val_end = vend;
FUNC_END:
    return iRet;
}


/*!
    @brief          ̐ݒ
*/
int CDMtrLibUtilSetString(char **dst, const char *val_top, const char *val_end)
{
    char *p;
    int iRet;
    unsigned int uiLen;
    iRet = RET_NG;
    uiLen = 0;
    p = NULL;
    if (dst == NULL) {
        goto FUNC_END;
    }
    *dst = NULL;
    if (val_top == NULL || val_end == NULL) {
        goto FUNC_END;
    }
    if (val_top > val_end) {
        goto FUNC_END;
    }
    uiLen = val_end - val_top + 1;
    p = (char *)CDMtrLibCmnMalloc(uiLen + 1);
    if (p == NULL) {
        goto FUNC_END;
    }
    strncpy(p, val_top, uiLen);
    p[uiLen] = '\0';
    *dst = p;
    iRet = RET_OK;
FUNC_END:
    return iRet;
}


/*!
    @brief          ̐ݒ
*/
char *CDMtrLibUtilCopyString(const char *pcStr)
{
    char *pcRet;
    unsigned int uiLen;
    pcRet = NULL;
    if (pcStr == NULL) {
        goto FUNC_END;
    }
    uiLen = strlen(pcStr);
    pcRet = (char *)CDMtrLibCmnMalloc(uiLen + 1);
    if (pcRet == NULL) {
        goto FUNC_END;
    }
    strncpy(pcRet, pcStr, uiLen);
FUNC_END:
    return pcRet;
}


/*!
    @brief          񂪓(啶AʂȂ)
*/
int CDMtrLibUtilCompString(const char *pcDst, const char *pcSrc)
{
    int iRet;
    unsigned int uiDstLen;
    unsigned int uiSrcLen;
    char *pcTmpDst, *pcTmpSrc;
    iRet = RET_FALSE;
    pcTmpDst = NULL;
    pcTmpSrc = NULL;
    if (pcDst == NULL || pcSrc == NULL) {
        goto FUNC_END;
    }
    uiDstLen = strlen(pcDst);
    uiSrcLen = strlen(pcSrc);
    if (uiDstLen != uiSrcLen) {
        goto FUNC_END;
    }
    pcTmpDst = (char *)CDMtrLibCmnMalloc(uiDstLen + 1);
    if (pcTmpDst == NULL) {
        goto FUNC_END;
    }
    strncpy(pcTmpDst, pcDst, uiDstLen);
    pcTmpDst[uiDstLen] = '\0';
    CDMtrLibUtilSetLowString(pcTmpDst);
    pcTmpSrc = (char *)CDMtrLibCmnMalloc(uiSrcLen + 1);
    if (pcTmpSrc == NULL) {
        goto FUNC_END;
    }
    strncpy(pcTmpSrc, pcSrc, uiSrcLen);
    pcTmpSrc[uiSrcLen] = '\0';
    CDMtrLibUtilSetLowString(pcTmpSrc);
    if (strcmp(pcTmpDst, pcTmpSrc) == 0) {
        iRet = RET_TRUE;
    }
FUNC_END:
    CDMtrLibCmnFree((void **)&pcTmpDst);
    CDMtrLibCmnFree((void **)&pcTmpSrc);
    return iRet;
}

/*!
    @brief          񂪓(啶AʂȂ)
*/
int CDMtrLibUtilStrCaseCmp(const char *s1, const char *s2, int n)
{
    int iRet = 0;
    iRet = _strnicmp(s1, s2, n);
    return iRet;
}

/*!
    @brief          ōŏɏo錟ւ̃|C^ԋp (啶AʂȂ)
*/
char *CDMtrLibUtilStrCaseStr(const char *string, const char *pattern)
{
    char *pcRet;
    int strpos;
    int ptnpos;
    pcRet = NULL;
    if (string == NULL || pattern == NULL) {
        goto FUNC_END;
    }
    strpos = 0;
    while (string[strpos] != '\0') {
        if (tolower (string[strpos]) == tolower (pattern[0])) {
            ptnpos = 1;
            while ( (string[strpos + ptnpos]  != '\0') &&
                    (pattern[ptnpos]  != '\0') &&
                    (tolower(string[strpos + ptnpos])
                     == tolower(pattern[ptnpos])) ) {
                ptnpos++;
            }
            if (pattern[ptnpos] == '\0') {
                pcRet = (char *)(string + strpos);
                goto FUNC_END;
            }
        }
        strpos++;
    }
FUNC_END:
    return pcRet;
}


/*!
    @brief          ^Ul̔
*/
int CDMtrLibUtilIsStringFalse(const char *val_top, const char *val_end)
{
    char *pcAttr;
    int iFuncRet;
    int iRet;
    iRet = RET_FALSE;
    pcAttr = NULL;
    if (val_top == NULL || val_end == NULL) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibUtilSetString(&pcAttr, val_top, val_end);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    CDMtrLibUtilSetLowString(pcAttr);
    if (strcmp(VAL_STR_FALSE, pcAttr) == 0) {
        iRet = RET_TRUE;
    }
FUNC_END:
    CDMtrLibCmnFree((void **)&pcAttr);
    return iRet;
}


/*!
    @brief          v邩
*/
int CDMtrLibUtilMatchPattern(const char *pcStr, const char *pcReg)
{
    int iRet;
    int iSeachType;
    int iCopyFlag;
    char *pcTmpStr;
    char *pcTmpReg;
    char *pcRegComp;
    char *p;
    unsigned int uiRegIndex;
    unsigned int uiRegLen;
    unsigned int uiPosLen;
    iRet = RET_FALSE;
    pcTmpStr = NULL;
    pcTmpReg = NULL;
    pcRegComp = NULL;
    if (pcStr == NULL || pcReg == NULL) {
        goto FUNC_END;
    }
    uiRegLen = strlen(pcReg);
    if (uiRegLen == 0) {
        goto FUNC_END;
    }
    if (uiRegLen == 1 && pcReg[uiRegLen - 1] == REGEX_ASTARISK_CHAR) {
        iRet = RET_TRUE;
        goto FUNC_END;
    }
    pcTmpReg = CDMtrLibUtilCopyString(pcReg);
    if (pcTmpReg == NULL) {
        goto FUNC_END;
    }
    CDMtrLibUtilSetLowString(pcTmpReg);
    pcTmpStr = CDMtrLibUtilCopyString(pcStr);
    if (pcTmpStr == NULL) {
        goto FUNC_END;
    }
    CDMtrLibUtilSetLowString(pcTmpStr);
    pcRegComp = (char *)CDMtrLibCmnMalloc(uiRegLen + 1);
    if (pcRegComp == NULL) {
        goto FUNC_END;
    }
    uiRegIndex = 0;
    p = pcRegComp;
    iSeachType = SEARCH_COMPLETE;
    iCopyFlag = CDMTR_TRUE;
    while (uiRegIndex < uiRegLen) {
        switch (pcTmpReg[uiRegIndex]) {
        case REGEX_ASTARISK_CHAR:
            if (uiRegIndex == 0) {
                iSeachType = SEARCH_SUFFIX;
                iCopyFlag = CDMTR_FALSE;
            } else if (uiRegIndex == (uiRegLen - 1)) {
                if (iSeachType == SEARCH_SUFFIX) {
                    iSeachType = SEARCH_PART;
                } else {
                    iSeachType = SEARCH_PREFIX;
                }
                iCopyFlag = CDMTR_FALSE;
            } else {
            }
            break;
        case REGEX_ESCAPE_CHAR:
            break;
        default:
            break;
        }
        if (iCopyFlag) {
            *p = pcTmpReg[uiRegIndex];
            p++;
        }
        iCopyFlag = CDMTR_TRUE;
        uiRegIndex++;
    }
    uiRegLen = strlen(pcRegComp);
    switch (iSeachType) {
    case SEARCH_COMPLETE:
        if (strcmp(pcTmpStr, pcRegComp) == 0) {
            iRet = RET_TRUE;
        }
        break;
    case SEARCH_PREFIX:
        if (strncmp(pcTmpStr, pcRegComp, uiRegLen) == 0) {
            iRet = RET_TRUE;
        }
        break;
    case SEARCH_SUFFIX:
        uiPosLen = strlen(pcTmpStr);
        while (1) {
            if (uiRegLen == 0) {
                iRet = RET_TRUE;
                break;
            }
            if (uiPosLen == 0) {
                break;
            }
            if (pcTmpStr[uiPosLen - 1] != pcRegComp[uiRegLen - 1]) {
                break;
            }
            uiPosLen--;
            uiRegLen--;
        }
        break;
    case SEARCH_PART:
        if (strstr(pcTmpStr, pcRegComp) != NULL) {
            iRet = RET_TRUE;
        }
        break;
    default:
        break;
    }
FUNC_END:
    CDMtrLibCmnFree((void **)&pcTmpStr);
    CDMtrLibCmnFree((void **)&pcTmpReg);
    CDMtrLibCmnFree((void **)&pcRegComp);
    return iRet;
}


/*!
    @brief          ɕϊ
*/
int CDMtrLibUtilSetLowString(char *dst)
{
    char *p;
    if (dst == NULL) {
        return RET_NG;
    }
    p = dst;
    while (!IS_NULL_CHAR(p)) {
        *p = tolower(*p);
        p++;
    }
    return RET_OK;
}


/*!
    @brief          啶ɕϊ
*/
int CDMtrLibUtilSetUpperString(char *dst)
{
    char *p;
    if (dst == NULL) {
        return RET_NG;
    }
    p = dst;
    while (!IS_NULL_CHAR(p)) {
        *p = toupper(*p);
        p++;
    }
    return RET_OK;
}


/*!
    @brief          piA`ZAa`zjǂ
*/
int CDMtrLibUtilIsAlpha(char c)
{
    int iRet;
    iRet = RET_FALSE;
    if (isalpha(c)) {
        iRet = RET_TRUE;
    }
    return iRet;
}


/*!
    @brief          i0`9jǂ
*/
int CDMtrLibUtilIsDigit(char c)
{
    int iRet;
    iRet = RET_FALSE;
    if (isdigit(c)) {
        iRet = RET_TRUE;
    }
    return iRet;
}

/*!
    @brief          R[hϊ (MBCS to Unicode)
*/
int CDMtrLibUtilMBCStoUNICODE(wchar_t **new_char, const char **org_str, _TCHAR *charSet)
{
    int   iRet = RET_NG;
    int   wLength;
    int   i_result;
    UINT  orgCodePage;
    if ((new_char != NULL) && (org_str != NULL) && (charSet != NULL) ) {
        if (iDebug == DEBUG_ON) {
            CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000532, charSet); //* MSG_LOG_ID_C_00000532
        }
    } else {
        goto FUNC_END;
    }
    wLength  = 0;
    i_result = 0;
    orgCodePage = CP_ACP;
    CDMtrLibUtilCheckSupportCharset(charSet, &orgCodePage);
    if (*org_str && (strlen(*org_str) >= 0)) {
        if (*new_char != NULL && wcslen(*new_char) >= 0) {
            return iRet;
        }
        wLength = MultiByteToWideChar(orgCodePage, 0, *org_str, -1, NULL, 0);
        if (wLength <= 0) {
            goto FUNC_END;
        }
        *new_char = (wchar_t *)malloc(sizeof(wchar_t) * (wLength));
        if (NULL == *new_char) {
            goto FUNC_END;
        }
        memset(*new_char, 0, sizeof(char) * (wLength));
        i_result = MultiByteToWideChar(orgCodePage, 0, *org_str, -1, *new_char, wLength);
        if (i_result <= 0) {
            goto FUNC_END;
        }
        iRet = RET_OK;
    }
FUNC_END:
    return iRet;
}

/*!
    @brief          R[hϊ (Unicode to MBCS)
*/
int CDMtrLibUtilUNICODEtoMBCS(char **new_char, const wchar_t **org_str, _TCHAR *charSet)
{
    int   iRet = RET_NG;
    int   cLength;
    int   i_result;
    UINT   CodePage;
    if ((new_char != NULL) && (org_str != NULL) && (charSet != NULL) ) {
        if (iDebug == DEBUG_ON) {
            CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000533, charSet); //* MSG_LOG_ID_C_00000533
        }
    } else {
        goto FUNC_END;
    }
    cLength  = 0;
    i_result = 0;
    CodePage = CP_ACP;
    CDMtrLibUtilCheckSupportCharset(charSet, &CodePage);
    if (*org_str && (wcslen(*org_str) >= 0)) {
        if (*new_char != NULL && strlen(*new_char) >= 0) {
            return iRet;
        }
        cLength = WideCharToMultiByte(CodePage, 0, *org_str, -1, NULL, 0, NULL, NULL);
        if (cLength <= 0) {
            goto FUNC_END;
        }
        *new_char = (char *)CDMtrLibCmnMalloc(sizeof(char) * (cLength));
        if (NULL == *new_char) {
            goto FUNC_END;
        }
        i_result = WideCharToMultiByte(CodePage, 0, *org_str, -1, *new_char, cLength, NULL, NULL);
        if (i_result <= 0) {
            goto FUNC_END;
        }
        iRet = RET_OK;
    }
FUNC_END:
    return iRet;
}

/*!
    @brief          T|[gZbg(R[h)mF
*/
int CDMtrLibUtilCheckSupportCharset(_TCHAR *cpCharset, unsigned int *uipCodePage)
{
    int iRet = RET_NG;
    unsigned int CodePage = CP_ACP;
    long x = 0;
    _TCHAR *endptr = NULL;
    if (NULL == cpCharset) {
        return RET_NG;
    }
    if (_tcscmp(cpCharset, ENCODING_EUC_JP) == 0) {
        iRet = RET_OK;
        CodePage = 20932;
    } else if (_tcscmp(cpCharset, ENCODING_SHIFT_JIS) == 0) {
        iRet = RET_OK;
        CodePage = 932;
    } else if (_tcscmp(cpCharset, ENCODING_UTF_8) == 0) {
        iRet = RET_OK;
        CodePage = CP_UTF8;
    } else if (_tcscmp(cpCharset, ENCODING_SYSTEM) == 0) {
        iRet = RET_OK;
        CodePage = CP_ACP;
    } else {
        if ( (_tcslen(cpCharset) > 2) &&
                *(cpCharset + 0) == _T('C') &&
                *(cpCharset + 1) == _T('P') ) {
            x = _tcstol((cpCharset + 2), &endptr, 10);
            if (_T('\0') != *endptr) {
                iRet = RET_NG;
                goto FUNC_END;
            }
            if (0 <= x && x <= UINT_MAX) {
                CodePage = x;
            } else {
                iRet = RET_NG;
                goto FUNC_END;
            }
        } else {
            iRet = RET_NG;
            goto FUNC_END;
        }
    }
    if (0 != IsValidCodePage(CodePage)) {
        iRet = RET_OK;
    }
    if ((uipCodePage != NULL) && (iRet == RET_OK)) {
        *uipCodePage = CodePage;
    }
FUNC_END:
    return iRet;
}
