/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <Windows.h>

#include "CDMtrCmn.h"
#include "CDMtrExtCmn.h"
#include "CDMtrLibCmnW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrLibSystemW.h"

/*----------------------------------------------------------------------------*/
/* static function declaration                                                */
/*----------------------------------------------------------------------------*/
static int cdmtrLibSystemGetLocaleW(LCID Locale, LCTYPE LCType, TCHAR **pcBuffer);

/*----------------------------------------------------------------------------*/
/* global function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief          P[\̂ݒ肷
    @param[in,out]  ptsyslocale       P[\
    @note           OS烍P[擾P[\̂ɐݒB
	                擾sуG[̏ꍇ͂̏͐ݒ肳ȂB
*/
void CDMtrLibSystemSetLocaleAttrW(_SysLocale *ptsyslocale)
{
    LCID localeId = 0 ;
    LANGID langID = 0 ;
    langID = GetUserDefaultUILanguage();
    if (langID != 0) {
        cdmtrLibSystemGetLocaleW(langID, LOCALE_SISO639LANGNAME, &(ptsyslocale->pcUserDispLang));
    }
    langID = GetSystemDefaultUILanguage();
    if (langID != 0) {
        cdmtrLibSystemGetLocaleW(langID, LOCALE_SISO639LANGNAME, &(ptsyslocale->pcSysDispLang));
    }
    localeId = GetUserDefaultLCID();
    if (localeId != 0) {
        cdmtrLibSystemGetLocaleW(localeId, LOCALE_SISO639LANGNAME, &(ptsyslocale->pcUserLang));
        CDMtrLibUtilTolowerW(ptsyslocale->pcUserLang);
        cdmtrLibSystemGetLocaleW(localeId, LOCALE_SISO3166CTRYNAME, &(ptsyslocale->pcUserCountry));
        CDMtrLibUtilTolowerW(ptsyslocale->pcUserCountry);
        cdmtrLibSystemGetLocaleW(localeId, LOCALE_IDEFAULTCODEPAGE, &(ptsyslocale->pcUserOEMCodePage));
        cdmtrLibSystemGetLocaleW(localeId, LOCALE_IDEFAULTANSICODEPAGE, &(ptsyslocale->pcUserANSICodePage));
    }
    localeId = GetSystemDefaultLCID();
    if (localeId != 0) {
        cdmtrLibSystemGetLocaleW(localeId, LOCALE_SISO639LANGNAME, &(ptsyslocale->pcSysLang));
        CDMtrLibUtilTolowerW(ptsyslocale->pcUserLang);
        cdmtrLibSystemGetLocaleW(localeId, LOCALE_SISO3166CTRYNAME, &(ptsyslocale->pcSysCountry));
        CDMtrLibUtilTolowerW(ptsyslocale->pcSysCountry);
        cdmtrLibSystemGetLocaleW(localeId, LOCALE_IDEFAULTCODEPAGE, &(ptsyslocale->pcSysOEMCodePage));
        cdmtrLibSystemGetLocaleW(localeId, LOCALE_IDEFAULTANSICODEPAGE, &(ptsyslocale->pcSysANSICodePage));
    }
    return ;
}

/*----------------------------------------------------------------------------*/
/* static function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief          OS烍P[擾B
    @param[in]      Locale			P[ID܂͌ID
    @param[in]      LCType			LCTYPEF擾郍P[
    @param[out]     pcBuffer		擾ݒ肷镶|C^
    @retval         RET_OK          
    @retval         RET_NG          Ȃ
	@note           擾sуG[RET_FALSEԋpB

*/
static int cdmtrLibSystemGetLocaleW(LCID Locale, LCTYPE LCType, TCHAR **pcBuffer)
{
    int iFRet = RET_NG;
    int iLen = 0;
    _TCHAR pcToken[42] ;
    if (Locale != 0) {
        iLen = GetLocaleInfo(Locale, LCType, NULL, 0);
        if (iLen > 0 && iLen < 40) {
            GetLocaleInfo(Locale, LCType, pcToken, iLen);
            iFRet = CDMtrLibUtilCreateStringW(pcBuffer, pcToken, NULL);
        }
    }
    return iFRet;
}
