/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


#ifndef CDMTRSPSCMN_H_
#define CDMTRSPSCMN_H_


#define CDMTRSPS_FLAG_ON   (1)
#define CDMTRSPS_FLAG_OFF  (0)

#define CDMTRSPS_RET_OK (0)
#define CDMTRSPS_RET_NG (-1)
#define CDMTRSPS_RET_NOTFOUND_FILE (-2)

#define CDMTRSPS_MAX_MACRO_NEST    124
#define CDMTRSPS_MAX_KEYWORD_NAME  512
#define CDMTRSPS_MAX_LINE_BUF     2048

#define CDMTRSPS_MAX_STACK_SIZE (512)
#define CDMTRSPS_MAX_TKN_NUMARY (512)
#define CDMTRSPS_MAX_TKN_NUMINFO  (5)

#define SET__ON_ESCAPE_FLAG 1
#define SET_OFF_ESCAPE_FLAG 0

typedef struct {
    int     debug_mode;
    int     iLangType;
    int     iSkipFlg;
    int     iQrtFlg;
    int     iOutFmtFlg;
    char   *pcFilepath;
    char   *pcLangName;
    char   *pcDirPath;
    char   *pcFName;
    char   *pcTemp;
    char   *pcFuncOpt;
    char   *pcErrorOutput;
    FILE   *errfile;
} PARAM_INFO_T;

extern PARAM_INFO_T strParamInfo;

extern struct ParsesEventFunc *p_method;

extern struct ParsesSettingFunc *p_set_method;

extern int giQrt_Out_Flg_ext;

extern int iSpsDebug;



void cdmtrSpsEventFuncSet(struct ParsesEventFunc *p);
void cdmtrSpsSettingFuncSet(struct ParsesSettingFunc *p);
void cdmtrSpsStrcpyToArray(char *pcArray, char *pcSrc, int iMaxArraySize);
void cdmtrSpsStrcatToArray(char *pcArray, char *pcSrc, int iMaxArraySize);
void cdmtrSpsParsesInit();
void cdmtrSpsLexerInit();
#endif
