/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef CDMTRSPSIFACE_H_
#define CDMTRSPSIFACE_H_

#define SPSIF_IDENTIFIER 258
#define SPSIF_CONSTANT 259
#define SPSIF_STRING_LITERAL 260
#define SPSIF_SIZEOF 261
#define SPSIF_PTR_OP 262
#define SPSIF_INC_OP 263
#define SPSIF_DEC_OP 264
#define SPSIF_LEFT_OP 265
#define SPSIF_RIGHT_OP 266
#define SPSIF_LE_OP 267
#define SPSIF_GE_OP 268
#define SPSIF_EQ_OP 269
#define SPSIF_NE_OP 270
#define SPSIF_ASS_OP 271
#define SPSIF_TILDE_OP 272
#define SPSIF_ETC_OP 273
#define SPSIF_AND_OP 274
#define SPSIF_OR_OP 275
#define SPSIF_MUL_ASSIGN 276
#define SPSIF_DIV_ASSIGN 277
#define SPSIF_MOD_ASSIGN 278
#define SPSIF_ADD_ASSIGN 279
#define SPSIF_SUB_ASSIGN 280
#define SPSIF_LEFT_ASSIGN 281
#define SPSIF_RIGHT_ASSIGN 282
#define SPSIF_AND_ASSIGN 283
#define SPSIF_XOR_ASSIGN 284
#define SPSIF_OR_ASSIGN 285
#define SPSIF_TYPE_NAME 286
#define SPSIF_ASM 287
#define SPSIF_CATCH 288
#define SPSIF_CLASS 289
#define SPSIF_CONST_CAST 290
#define SPSIF_DELETE_WD 291
#define SPSIF_DYNAMIC_CAST 292
#define SPSIF_EXPLICIT 293
#define SPSIF_EXPORT 294
#define SPSIF_FALSE_WD 295
#define SPSIF_FRIEND 296
#define SPSIF_MUTABLE 297
#define SPSIF_NAMESPACE 298
#define SPSIF_NEW 299
#define SPSIF_OPERATOR 300
#define SPSIF_PRIVATE 301
#define SPSIF_PROTECTED 302
#define SPSIF_PUBLIC 303
#define SPSIF_REINTERPRET_CAST 304
#define SPSIF_STATIC_CAST 305
#define SPSIF_TEMPLATE 306
#define SPSIF_THIS_WD 307
#define SPSIF_THROW 308
#define SPSIF_TRUE_WD 309
#define SPSIF_TRY 310
#define SPSIF_TYPEID 311
#define SPSIF_TYPENAME 312
#define SPSIF_USING 313
#define SPSIF_VIRTUAL 314
#define SPSIF_WCHAR_T 315
#define SPSIF_TYPEDEF 316
#define SPSIF_EXTERN 317
#define SPSIF_STATIC 318
#define SPSIF_AUTO 319
#define SPSIF_REGISTER 320
#define SPSIF_INLINE 321
#define SPSIF_RESTRICT 322
#define SPSIF_CHAR 323
#define SPSIF_SHORT 324
#define SPSIF_INT 325
#define SPSIF_LONG 326
#define SPSIF_SIGNED 327
#define SPSIF_UNSIGNED 328
#define SPSIF_FLOAT 329
#define SPSIF_DOUBLE 330
#define SPSIF_CONST_WD 331
#define SPSIF_VOLATILE 332
#define SPSIF_VOID_WD 333
#define SPSIF_BOOL 334
#define SPSIF_COMPLEX 335
#define SPSIF_IMAGINARY 336
#define SPSIF_STRUCT 337
#define SPSIF_UNION 338
#define SPSIF_ENUM 339
#define SPSIF_ELLIPSIS 340
#define SPSIF_CASE 341
#define SPSIF_DEFAULT 342
#define SPSIF_IF 343
#define SPSIF_ELSE 344
#define SPSIF_SWITCH 345
#define SPSIF_WHILE 346
#define SPSIF_DO 347
#define SPSIF_FOR 348
#define SPSIF_GOTO 349
#define SPSIF_CONTINUE 350
#define SPSIF_BREAK 351
#define SPSIF_RETURN 352
#define SPSIF_SEMICOLON 353
#define SPSIF_PARENST 354
#define SPSIF_BRACEST 355
#define SPSIF_PARENED 356
#define SPSIF_BRACEED 357
#define SPSIF_COMMA 358
#define SPSIF_DCOLON 359
#define SPSIF_COLON 360

#define SPSIF_LINEBREAK_NORMAL (0)
#define SPSIF_LINEBREAK_BRANK  (1)
#define SPSIF_LINEBREAK_ESCAPE (2)

#define SPSIF_COMMENT_TYPE_REM  (0)
#define SPSIF_COMMENT_TYPE_DOC  (1)

#define SPSIF_TYPE_IF      1
#define SPSIF_TYPE_IF0     2
#define SPSIF_TYPE_IFDEF   3
#define SPSIF_TYPE_IFNDEF  4
#define SPSIF_TYPE_ELIF    5
#define SPSIF_TYPE_ELSE    6
#define SPSIF_TYPE_ENDIF   7
#define SPSIF_TYPE_INCLUDE 8
#define SPSIF_TYPE_DEFINE  9
#define SPSIF_TYPE_UNDEF   10
#define SPSIF_TYPE_LINE    11
#define SPSIF_TYPE_ERROR   12
#define SPSIF_TYPE_PRAGMA  13
#define SPSIF_TYPE_OTHER   90

#define SPSIF_MACRO_TRUE    0
#define SPSIF_MACRO_FALSE   1
#define SPSIF_MACRO_SKIP    2

#define SPSIF_RET_OK (0)
#define SPSIF_RET_NG (1)


struct ParsesEventFunc {
    void (*pefTokenString)(int tokrn_id, int line_from, int colum_from, int line_to, int colum_to, char *token_text);
    void (*pefLineBreak)(int break_id, int line_from, int colum_from, int line_to, int colum_to);
    void (*pefLineSkip)(int line_from, int colum_from, int line_to, int colum_to, char *skipline);
    void (*pefComment)(int cmt_type, int cmtno, int linenum, int line_from, int colum_from, int line_to, int colum_to, char *cmtline);
    void (*pefMacro)(int pre_type, int preno, int linenum, int line_from, int colum_from, int line_to, int colum_to, int pre_nest, int pre_pars, int *macronest, int cntmacronest, int iSkipLine, char *keyname, char *keyparam);
    void (*pefFileEof)(int linenum);
    void (*pefStatement)(int **StackTokenInfo, int iStackCnt, int line_from, int line_to, char *statement_text);
    void (*pefFuncCandidate)(int line_from, int line_to, char *funcname, int cntparam, char *funcline);
    void (*pefFuncToStatement)(int **StackTokenInfo, int iStackCnt, int line_from, int line_to, char *funcname, char *statement_text);
    void (*pefFunction)(int **StackTokenInfo, int iStackCnt, int line_from, int line_to, char *funcname, char *param_name, int cntparam, char *funcline, int func_name_line);
    void (*pefFuncEnd)(int **StackTokenInfo, int iStackCnt, int line_from, int line_to, int cntmaxnests);
    void (*pefBranchCandidate)(int branch_type, int line_from, int line_to, char *statement_text);
    void (*pefBranchStatement)(int branch_type, int **StackTokenInfo, int iStackCnt, int line_from, int line_to, int cntcondition, char *statement_text);
    void (*pefBraceNest)(int brace_type, int **StackTokenInfo, int iStackCnt, int line_from, int line_to, int cntinner, int cntouter, int cntmaxinner, int cntmaxouter, char *token_text);
    void (*pefParenNest)(int paren_type, int line_from, int line_to, int cntfunc, int cntbranch, char *token_text);
};
struct ParsesSettingFunc {
    int (*psfGetFunctionStartFlag)(void);
    int (*psfGetTargetLangType)(void);
};

void cdmtrSpsIfaceEventFuncSet(struct ParsesEventFunc *ppef);

void cdmtrSpsIfaceSettingFuncSet(struct ParsesSettingFunc *ppes);

void cdmtrSpsIfaceInit();

int cdmtrSpsIfaceParses(char *filepath);

typedef enum {
    KEYWOR_CASE_NONE = 0,
    KEYWOR_CASE_IDENTIFIER,
    KEYWOR_CASE_FUNC_DECLARATION,
    KEYWOR_CASE_FUNC_DEFINITION,
    KEYWOR_CASE_IF,
    KEYWOR_CASE_FOR,
    KEYWOR_CASE_WHILE,
    KEYWOR_CASE_SWITCH,
    KEYWOR_CASE_CASE,
    KEYWOR_CASE_STRUCT,
    KEYWOR_CASE_UNION,
    KEYWOR_CASE_ENUM,
    KEYWOR_CASE_ELSE,
    KEYWOR_CASE_DEFAULT,
    KEYWOR_CASE_DO,
    KEYWOR_CASE_COLON
} KEYWORD_CASE_ID;

#endif
