/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef CDMTR_STMT_LEX_H
#define CDMTR_STMT_LEX_H

typedef enum {

    token_unknown  = 0,


    token_colon,
    token_colon2,
    token_eq,
    token_eq2,
    token_generic,


    token_atmark,
    token_lbracket,
    token_rbracket,
    token_lparent,
    token_rparent,
    token_lcbrace,
    token_rcbrace,
    token_semicolon,
    token_comma,
    token_question,
    token_operator,
    token_other_mark,

    token_string,
    token_character,

    token_struct,
    token_class,
    token_union,
    token_interface,
    token_enum,
    token_for,
    token_while,
    token_foreach,
    token_switch,
    token_try,
    token_catch,
    token_finally,
    token_case,
    token_default,
    token_public,
    token_private,
    token_protected,
    token_if,
    token_else,
    token_do,
    token_lock,
    token_delegate,
    token_using,
    token_fixed,
    token_this,
    token_goto,
    token_is,
    token_as,
    token_other,

    token_end
} type_token;



#if CDMTR_LOG_WHITE_BOX
#define CDMtrStmtBufSize (13)
#else
#define CDMtrStmtBufSize (1024)
#endif

extern char CDMtrStmtWorkBuf[];
extern int iPosWorkBuf;


extern int CDMtrStmtGetToken(void);

extern void CDMtrStmtTokenBuffFree(void);
extern void CDMtrStmtTokenBuffInit(void);
extern int CDMtrStmtTokenBuffADD(char);
extern int CDMtrStmtTokenBuffReSize(void);
extern void CDMtrStmtTokenBuffClear(void);

extern void CDMtrStmtPrintToken(int);
#endif
