/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#include <stdio.h>
#include <string.h>

#include <tchar.h>

#include "CDMtrStmt.h"
#include "CDMtrStmtFile.h"
#include "CDMtrStmtLex.h"
#include "CDMtrStmtParse.h"
#include "CDMtrStmtLog.h"
#include "CDMtrMessage.h"

/*!
    @brief          Xe[ggv C֐
*/

int CDMtrStmtCountStatement(const _TCHAR *pcFileName, const _TCHAR *pcErrOutFile, int iLangMode, int *iLogMode, long *plStmt)
{
    int iFuncRet;
    int iReadSize = 0;
    iFuncRet = -1;
    if (plStmt == NULL) {
        PASS_CHECK;
        iFuncRet = -1;
        return iFuncRet;
    }
    if (pcFileName == NULL) {
        PASS_CHECK;
        iFuncRet = -1;
        return iFuncRet;
    }
    *plStmt = 0L;
    CDMtrStmtLogLevel = *iLogMode;
    if (pcErrOutFile == NULL || _tcslen(pcErrOutFile) == 0) {
        *iLogMode = CDMtrStmtLogLevel = CDMtrStmtLogOFF;
    }
    switch (iLangMode) {
    case CDMtrStmtLangModeC :
        PASS_CHECK;
        break;
    case CDMtrStmtLangModeCPP :
        PASS_CHECK;
        break;
    case CDMtrStmtLangModeJAVA :
        PASS_CHECK;
        break;
    case CDMtrStmtLangModeCS :
        PASS_CHECK;
        break;
    default:
        PASS_CHECK;
        iLangMode = CDMtrStmtLangModeC;
        break;
    }
    CDMtrStmtLangType = iLangMode;
    CDMTR_STMT_LOG_FUNC(CDMtrStmtLogFileOpen(pcErrOutFile););
    *iLogMode = CDMtrStmtLogLevel ;
    if (CDMtrStmtOpenInputFile(pcFileName) < 0) {
        PASS_CHECK;
        iFuncRet = -1;
        CDMtrStmtLogFileClose();
        return iFuncRet;
    }
    memset((void *)CDMtrStmtWorkBuf, 0, CDMtrStmtBufSize + 1);
    if ((iReadSize = CDMtrStmtReadOneLine(CDMtrStmtWorkBuf, CDMtrStmtBufSize)) < 0) {
        PASS_CHECK;
        iFuncRet = -1;
        goto FUNC_END ;
    }
    iPosWorkBuf = 0;
    CDMtrStmtTokenBuffInit();
    for ( ; ; ) {
        long lCurLines = 0;
        lCurLines = CDMtrStmtReadOneStatement(token_semicolon);
        if (lCurLines < 0) {
            PASS_CHECK;
            break;
        }
        *plStmt = *plStmt + lCurLines;
        CDMTR_STMT_LOG_FUNC(CDMtrStmtLogFileOut(MSG_LOG_ID_C_00000713, *plStmt, lCurLines);); //* MSG_LOG_ID_C_00000713
        if (CDMtrStmt_flg_isEOF == CDMtrStmt_FILE_ON) {
            PASS_CHECK;
            iFuncRet = 0;
            break;
        }
    }
FUNC_END:
    CDMtrStmtTokenBuffFree();
    CDMtrStmtCloseInputFile();
    CDMtrStmtLogFileClose();
    return iFuncRet;
}
