/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#include <stdio.h>
#include <stdarg.h>

#include <tchar.h>

#include "CDMtrStmtLog.h"


int CDMtrStmtLogLevel = CDMtrStmtLogOFF;
FILE *CDMtrStmtLogFile = NULL ;


/*!
    @brief Xe[ggv 胍O
*/

int CDMtrStmtLogFileOpen(const _TCHAR *pcFileName)
{
#if defined(UNICODE) || defined(_UNICODE)
    errno_t erno = 0;
    erno = _tfopen_s(&CDMtrStmtLogFile, pcFileName, _T("wt"));
    if ( erno != 0 ) {
        PASS_CHECK;
        CDMtrStmtLogLevel = CDMtrStmtLogOFF;
        return -1;
    }
#else
    CDMtrStmtLogFile = fopen(pcFileName, "wt");
    if ( CDMtrStmtLogFile == NULL ) {
        PASS_CHECK;
        CDMtrStmtLogLevel = CDMtrStmtLogOFF;
        return -1;
    }
#endif
    return 0;
}

/*!
    @brief Xe[ggv 胍O
*/
void CDMtrStmtLogFileClose()
{
    if ( CDMtrStmtLogFile != NULL ) {
        fclose(CDMtrStmtLogFile);
    }
    return ;
}

/*!
    @brief Xe[ggv 胍O
*/
void CDMtrStmtLogFileOut(const char *pArgc, ...)
{
    va_list pArglist;
    if (pArgc == NULL || CDMtrStmtLogFile == NULL ) {
        goto FUNC_END;
    }
    va_start(pArglist, pArgc);
    vfprintf(CDMtrStmtLogFile, pArgc, pArglist);
    va_end(pArglist);
FUNC_END:
    return ;
}
