/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include <stdio.h>
#include <string.h>
#include "CDMtrVBIface.h"
#include "CDMtrVBCmn.h"
#include "CDMtrVBMessage.h"


/*!
    @brief  VBp[T֐
*/
int cdmtrVBIfaceInit(PARAM_INFO_T *pparaminfo)
{
    if (cdmtrVBCmnInit(pparaminfo) != CDMTRVB_RET_OK) {
        return VBIF_RET_NG;
    }
    return VBIF_RET_OK;
}

/*!
    @brief  VBp[TI֐
*/
void cdmtrVBIfaceFinal()
{
    cdmtrVBCmnFinal();
}

/*!
    @brief  VBp[Ts֐
*/
int cdmtrVBIfaceParses(int iphase)
{
    if (cdmtrVBCmnParse(iphase) != CDMTRVB_RET_OK) {
        return VBIF_RET_NG;
    }
    return VBIF_RET_OK;
}

/*!
    @brief  VBp[Tʏo͊֐
*/
int cdmtrVBIfaceOutput()
{
    int iretvalue = VBIF_RET_OK;
    cdmtrVBCmnLog(VBIF_DEBUGMODE_1, MSG_LOG_ID_C_00000804, pParamInfo->iStmtFlg); //* MSG_LOG_ID_C_00000804
    if (pParamInfo->iStmtFlg != VBIF_STAT_ON) {
        if (cdmtrVBCmnOutputFunctionTable() != CDMTRVB_RET_OK) {
            iretvalue = VBIF_RET_NG;
        }
    }
    if (cdmtrVBCmnOutputMetricTable() != CDMTRVB_RET_OK) {
        iretvalue = VBIF_RET_NG;
    }
    if (IS_DEBUG2) {
        cdmtrVBCmnOutputFunctionTable_debug2();
        cdmtrVBCmnOutputMetricTable_debug2();
        cdmtrVBCmnOutputSource_debug2();
    }
    return iretvalue;
}
